package CGI::Minimal

require bytes
####

sub _internal_calling_parms_table
    my $self = shift
    my $pkg = __PACKAGE__
    my $vars = $self->{?$pkg}

    my $outs = <<"EOF"
<table border="1" cellspacing="0">
<tr> <th colspan="4">Form Fields</th> </tr>
<tr> <th>Field</th> <th>Value</th> <th>mime Type</th> <th>File Name</th> </tr>
EOF
    foreach my $fname (sort $vars{?'field_names'})
        my $f_data = \ $vars{'field'}{?$fname}
        my $sub_field_counter =( nelems($f_data->{?'value'})-1)
        for my $fn (0..$sub_field_counter)
            my $fmime  = $f_data->{'mime_type'}[$fn]
            my $ffile  = $f_data->{'filename'}[$fn]
            my $fvalue = '[non-text value]'
            if ($fmime =~ m#^text/#oi)
                $fvalue = $self->htmlize($f_data->{'value'}[$fn])
            
            $outs .= <<"EOF"
	<tr>
	 <td>$fname (#$fn)</td>
	 <td> $fvalue </td>
	 <td>$fmime</td>
	 <td>$ffile</td>
	</tr>
EOF
        
    
    $outs .= <<"EOF"
<tr>
  <th colspan="4">Environment Variables</th>
</tr>

<tr>
  <th>Variable</th>
  <th colspan="3">Value</th>
</tr>
EOF

    foreach my $fname (sort { $a cmp $b }, env::keys)
        $outs .= "<tr>\n  <td>$fname</td>\n  <td colspan=\"3\">" .
            $self->htmlize($(env::var($fname))) . "</td>\n</tr>\n"
    

    $outs .= "</table>\n"

    return $outs


####

sub _internal_date_rfc1123($self, $tick)
    my (@: $sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=@: gmtime($tick)
    my $wkday = (@: 'Sun','Mon','Tue','Wed','Thu','Fri','Sat')[$wday]
    my $month = (@: 'Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec')[$mon]
    $year += 1900
    my $date = sprintf('%s, %02d %s %s %02d:%02d:%02d GMT',$wkday,$mday,$month,$year,$hour,$min,$sec)
    return $date


####

sub _internal_url_decode($self, ?$s)
    return '' if (! defined($s))
    $s =~ s/\+/ /gs
    $s =~ s/%(?:([0-9a-fA-F]{2})|u([0-9a-fA-F]{4}))/$( defined($1)?? bytes::chr(hex($1)) !! _utf8_chr(hex($2)))/g
    return $s


####

sub _internal_dehtmlize($self, ?$s)
    return ('') if (! defined($s))

    $s=~s/\&gt;/>/gs
    $s=~s/\&lt;/</gs
    $s=~s/\&quot;/\"/gs
    $s=~s/\&amp;/\&/gs

    return $s


sub _internal_set($self, $parms)
    my $pkg = __PACKAGE__
    my $vars = \ $self->{?$pkg}

    foreach my $name (keys $parms)
        my $value = $parms{?$name}
        my $data  = $@
        my $data_type = ref::svtype($value)
        if ($data_type eq 'PLAINVALUE' or $data_type eq 'UNDEF')
            $data = @:  $value 
        elsif ($data_type eq 'ARRAY')
            $data = $value # Shallow copy
        else
            die("$($pkg)::_internal_set() - Parameter '$name' has illegal data type of '$data_type'")
        

        if (! defined ($vars->{'field'}{?$name}{?'count'}))
            push ($vars->{'field_names'},$name)
        
        my $record = \$%
        $record->{+'count'} = nelems($data)
        $record->{+'value'} = $data
        my $data_entries = nelems($data)
        for my $f_count (0..$data_entries-1)
            $record->{+'filename'}[+$f_count]  = ''
            $record->{+'mime_type'}[+$f_count] = 'text/plain'
        
        $vars->{'field'}{+$name} = $record->%
    


1
