#!/usr/bin/perl -w


use lib ('./blib','./lib','../blib','../lib')
use CGI::Minimal

my $do_tests = \$: 1..1

my $test_subs = \%: 
    1 => \(%:  code => &test_x_www,  desc => 'decode from command line                   ' )
    

run_tests($test_subs,$do_tests)

exit

###########################################################################################

########################################################
# Test simple form decoding via command line interface #
########################################################

sub test_x_www

    local $^WARNING = 0

    # "Bad evil naughty Zoot"

    my $test_file = "test-data.$^PID.data"
    my $data      = 'hello=testing&hello2=standard+encoded+FORM&submit+button=submit'

    open (my $testfh, ">","$test_file") || return ("failed : could not open test file $test_file for writing: $^OS_ERROR")
    binmode ($testfh)
    print $testfh, $data
    close ($testfh)

    CGI::Minimal::reset_globals
    open ($^STDIN, "<",$test_file) || return ("failed : could not open test file $test_file for reading: $^OS_ERROR")
    my $cgi = CGI::Minimal->new
    close ($^STDIN)
    unlink $test_file

    my $string_pairs = \%:  'hello' => 'testing'
                            'hello2' => 'standard encoded FORM'
                            'submit button' => 'submit'
        
    my @form_keys   = keys $string_pairs->%
    my @param_keys  = $cgi->param_as_list
    if ((nelems(@form_keys)-1) !=( nelems(@param_keys)-1))
        return 'failed : Expected 3 parameters in x-www-form-urlencoded, found ' . ((nelems(@param_keys)-1) + 1)
    

    my %form_keys_hash = %+: map { %: $_ => $string_pairs->{?$_} }, @form_keys
    foreach my $key_item ( @param_keys)
        if (! defined %form_keys_hash{?$key_item})
            return 'failed : Parameter names did not match'
        
        my $item_value = $cgi->param($key_item)
        if (%form_keys_hash{?$key_item} ne $item_value)
            return 'failed : Parameter values did not match'
        
    


    # Success is an empty string (no error message ;) )
    return ''


###########################################################################################

sub run_tests($test_subs,$do_tests)

    print $^STDOUT, < $do_tests->[[(@: 0)]],'..', <$do_tests->[[(@: (nelems($do_tests->@)-1))]],"\n"
    print $^STDERR, "\n"
    my $n_failures = 0
    foreach my $test ( $do_tests->@)
        my $sub  = $test_subs->{$test}->{?code}
        my $desc = $test_subs->{$test}->{?desc}
        my $failure = ''
        try { $failure = $sub->(); }
        if ($^EVAL_ERROR)
            $failure = $^EVAL_ERROR
        
        if ($failure)
            print $^STDOUT, "not ok $test\n"
            print $^STDERR, "    $desc - $($failure->message)\n"
            $n_failures++
        else
            print $^STDOUT, "ok $test\n"
            print $^STDERR, "    $desc - ok\n"

    print $^STDOUT, "END\n"


