# -*- mode: cperl -*-

use File::Spec
use Test::More
use lib "lib"
require CPAN::HandleConfig

my %special = %:  < @+: map { @: $_ => undef }, qw(
                                     dontload_hash
                                     mbuild_install_build_command
                                     make_install_make_command
                                    ) 
my %all = %: < %CPAN::HandleConfig::keys,< %special
plan tests => (
               nelems( keys %all)
               )

sub _f ($file) {File::Spec->catfile( <split m/\//, $file);}

open my $fh, '<', _f"lib/CPAN.pm" or die "Could not open CPAN.pm: $^OS_ERROR"
my $seen
my $in_config_variables = 0
while (~< $fh->*)
    if (not $in_config_variables)
        $in_config_variables ||= m/^=head2 Config Variables/
        next
    
    next if m/^(\w|$)/ && !$seen
    last if m/^(\w|$)/ && $seen
    chomp
    my(@: $leader,$gedoct) =@:  unpack("a2 a40",$_)
    next if $gedoct =~ m/^\s/
    $gedoct =~ s/\s.*//
    if (exists %CPAN::HandleConfig::keys{$gedoct})
        delete %CPAN::HandleConfig::keys{$gedoct}
        $seen++
        ok(1,"'$gedoct' doc'd")
    elsif (exists %special{$gedoct})
        ok(1,"found doc'd for backwards compat: '$gedoct'")
    else
        ok(0,"found doc'd but not registered: '$gedoct'")
    

for (sort keys %CPAN::HandleConfig::keys)
    ok(0,"missing docs: '$_'")
