#!/usr/bin/perl -w


# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

BEGIN { $^OUTPUT_AUTOFLUSH = 1; print $^STDOUT, "1..35\n"; }

use Cache::Cache < qw( $EXPIRES_NOW
                     $EXPIRES_NEVER )

use Cache::CacheTester

use Cache::FileCache


print $^STDOUT, "ok 1\n"


######################### End of black magic.

our ($TEST_COUNT)

$TEST_COUNT = 2

my $cache = Cache::FileCache->new( ) or
    not_ok( "Couldn't create new FileCache" )

ok( )

my $cache_tester = Cache::CacheTester->new( $TEST_COUNT ) or
    not_ok( "Couldn't create new CacheTester" )

$cache_tester->test( $cache )


sub ok
    print $^STDOUT, "ok $TEST_COUNT\n"

    $TEST_COUNT++



sub not_ok( $message)

    print $^STDOUT, "not ok $TEST_COUNT #  $message\n"

    $TEST_COUNT++



sub skip( $message)

    print $^STDOUT, "ok $TEST_COUNT # skipped: $message\n"

    $TEST_COUNT++


