#!perl -w

use warnings


use Test::More tests=>8

BEGIN 
    use_ok( 'Carp::Assert::More' )


my %foo = %: 
    name => "Andy Lester"
    phone => "578-3338"
    wango => undef
    


try {
    assert_exists( \%foo, 'name' );
}
is( $^EVAL_ERROR, "" )


try {
    assert_exists( \%foo, 'wango' );
}
is( $^EVAL_ERROR, "" )


dies_like { assert_exists( \%foo, 'Nonexistent' ) }
  , qr/Assert.+failed/


try {
    assert_exists( \%foo, \qw( name ) );
}
is( $^EVAL_ERROR, "" )

try {
    assert_exists( \%foo, \qw( name social-security-number ) );
}
like( $^EVAL_ERROR->{?description}, qr/Assertion.+failed/ )

try {
    assert_exists( \%foo, \qw( name phone ) );
}
is( $^EVAL_ERROR, "" )


try {
    assert_exists( \%foo, \(@: 'name','Nonexistent') );
}
like( $^EVAL_ERROR->{?description}, qr/Assert.+failed/ )


