#!perl -w

package Foo

sub new { my $class = shift; return bless \(%: < @_), $class; }

package main

use warnings


use Test::More tests => 7

BEGIN { use_ok( 'Carp::Assert::More' ); }

local $^EVAL_ERROR = undef
$^EVAL_ERROR = ''

# {} is a hashref
try {
    assert_hashref( \$% );
}
is( $^EVAL_ERROR, '' )

# a ref to a hash with stuff in it is a hashref
my %hash = %:  foo => 'foo', bar => 'bar' 
try {
    assert_hashref( \%hash );
}
is( $^EVAL_ERROR, '' )

# 3 is not a hashref
try {
    assert_hashref( 3 );
}
like( $^EVAL_ERROR->{?description}, qr/Assertion.*failed/ )

# [] is not a hashref
try {
    assert_hashref( \$@ );
}
like( $^EVAL_ERROR->{?description}, qr/Assertion.*failed/ )

# sub {} is not a hashref
try {
    assert_hashref( sub {} );
}
like( $^EVAL_ERROR->{?description}, qr/Assertion.*failed/ )

# Foo->new->isa("HASH") returns true, so do we
try {
    assert_hashref( Foo->new );
}
is( $^EVAL_ERROR, '' )

