#!perl

use warnings


use Test::More tests => 5
use IO::File # just for creating objects

BEGIN { use_ok( 'Carp::Assert::More' ); }

local $^EVAL_ERROR = undef
$^EVAL_ERROR = ''

try {
    my $fh = IO::File->new();
    assert_isa( $fh, 'IO::File', 'Created an IO::File object' );
    assert_isa( $fh, 'GLOB',     'Created an IO::File object, which is a GLOB' );
}
is( $^EVAL_ERROR, '' )

try {
    my $random = 2112;
    assert_isa( $random, 'IO::File', 'Created an IO::File object' );
}
like( $^EVAL_ERROR->{?description}, qr/Assertion.*failed/ )



try {
    my @array;
    assert_isa( \@array, 'HASH', 'An array is not a hash' );
}
like( $^EVAL_ERROR->{?description}, qr/Assertion.*failed/ )

try {
    my %hash;
    assert_isa( \%hash, 'HASH', 'Created a hash' );
}
is( $^EVAL_ERROR, '' )
