#!/usr/bin/perl

use warnings


use Test::More tests => 8

BEGIN { use_ok( 'Carp::Assert::More' ); }

local $^EVAL_ERROR = undef
$^EVAL_ERROR = ''

# 'like' is in 'unlikely'
try {
    assert_like('unlikely', qr/like/ );
}
is( $^EVAL_ERROR, '' )

# 'te.*st' matches 'tempest'
try {
    my $string = 'tempest';
    assert_like( $string, qr/te.*st/  );
}
is( $^EVAL_ERROR, '' )

# 'qu.*inn' matches 'quality inn'
try {
    my $string = 'quality inn';
    my $regex = qr/qu.*inn/;
    assert_like( $string, $regex );
}
is( $^EVAL_ERROR, '' )

# 'fa.*il' does not match 'passing'
try {
    assert_like( 'passing', qr/fa.*il/ );
}
like( $^EVAL_ERROR->{?description}, qr/Assertion.*failed/ )

# undef with a regex will fail
try {
    assert_like( undef, qr/fails/ );
}
like( $^EVAL_ERROR->{?description}, qr/Assertion.*failed/ )

# A string without a regex fails, too
try {
    my $string = "Blah blah";
    assert_like( $string, undef );
}
like( $^EVAL_ERROR->{?description}, qr/Assertion.*failed/ )

# A bad reference should also fail.
try {
    my $string = "Blah blah";
    my $ref = \$string;
    assert_like( $string, $ref );
}
like( $^EVAL_ERROR->{?description}, qr/Assertion.*failed/ )
