#!perl

package Foo

sub new { my $class = shift; return bless \(@: < @_), $class; }

package main

use warnings


use Test::More tests => 8

BEGIN { use_ok( 'Carp::Assert::More' ); }

local $^EVAL_ERROR = undef
$^EVAL_ERROR = ''

# {} is not a listref
try {
    assert_listref( \$% );
}
like( $^EVAL_ERROR->{?description}, qr/Assertion.*failed/ )

# a ref to a hash with stuff in it is not a listref
my $ref = \%:  foo => 'foo', bar => 'bar' 
try {
    assert_listref( $ref );
}
like( $^EVAL_ERROR->{?description}, qr/Assertion.*failed/ )

# 3 is not a listref
try {
    assert_listref( 3 );
}
like( $^EVAL_ERROR->{?description}, qr/Assertion.*failed/ )

# [] is a listref
try {
    assert_listref( \$@ );
}
is( $^EVAL_ERROR, '' )

# a ref to a list with stuff in it is a listref
my @ary = @: 'foo', 'bar', 'baaz'
try {
    assert_listref( \@ary );
}
is( $^EVAL_ERROR, '' )

# sub {} is not a listref
try {
    assert_listref( sub {} );
}
like( $^EVAL_ERROR->{?description}, qr/Assertion.*failed/ )

# Foo->new->isa("ARRAY") returns true, so do we
try {
    assert_listref( Foo->new );
}
is( $^EVAL_ERROR, '' )
