#!perl

use warnings


use Test::More tests => 6

BEGIN { use_ok( 'Carp::Assert::More' ); }

local $^EVAL_ERROR = undef
$^EVAL_ERROR = ''

# 3 is nonblank
try {
    assert_nonblank( 3 );
}
is( $^EVAL_ERROR, '' )

# 0 is nonblank
try {
    assert_nonblank( 0 );
}
is( $^EVAL_ERROR, '' )

# '' is blank
try {
    assert_nonblank( '' );
}
like( $^EVAL_ERROR->{?description}, qr/Assertion.*failed/ )

# undef is not nonblank
try {
    assert_nonblank( undef );
}
like( $^EVAL_ERROR->{?description}, qr/Assertion.*failed/ )

# References are not nonblank
try {
    my $scalar = "Blah blah";
    my $ref = \$scalar;
    assert_nonblank( $ref );
}
like( $^EVAL_ERROR->{?description}, qr/Assertion.*failed/ )
