#!perl

use warnings


use Test::More tests => 6

BEGIN { use_ok( 'Carp::Assert::More' ); }

local $^EVAL_ERROR = undef
$^EVAL_ERROR = ''

# 3 is nonref
try {
    assert_nonref( 3 );
}
is( $^EVAL_ERROR, '' )

# 0 is nonref
try {
    assert_nonref( 0 );
}
is( $^EVAL_ERROR, '' )

# '' is nonref
try {
    assert_nonref( 0 );
}
is( $^EVAL_ERROR, '' )

# undef is not a reference, but it also fails by my rules
try {
    assert_nonref( undef );
}
like( $^EVAL_ERROR->{?description}, qr/Assertion.*failed/ )

# A reference is not a non-reference
try {
    my $scalar = "Blah blah";
    my $ref = \$scalar;
    assert_nonref( $ref );
}
like( $^EVAL_ERROR->{?description}, qr/Assertion.*failed/ )
