#!/usr/bin/perl -w

# Test with assert on.


use Test::More tests => 7
use env

# Make sure we're shielded against the user possibly having
# NDEBUG or PERL_NDEBUG set.  Localize the changes because changes
# to %ENV persist across processes in VMS.
BEGIN 
    local env::var('PERL_NDEBUG') = undef
    local env::var('NDEBUG') = undef
    require Carp::Assert
    Carp::Assert->import


# shouldn't makes its decision at run-time
local env::var('PERL_NDEBUG') = undef
local env::var('NDEBUG') = undef


dies_like sub (@< @_) { assert(1==0) if DEBUG; },
          qr/^Assertion failed/i


try { assert(1==1); }
is $^EVAL_ERROR, ''


try { assert(Dogs->isa('People'), 'Dogs are people, too!') }
like $^EVAL_ERROR->{?description}, '/Dogs are people, too!/'


try { should('this', 'this') }
is $^EVAL_ERROR, ''


dies_like sub (@< @_) { should('this', 'that') },
          qr/^Assertion \(.*\) failed/i


try { shouldnt('this', 'that') }
is $^EVAL_ERROR, ''


try { shouldnt('up', 'up') }
like $^EVAL_ERROR->{?description}, '/^Assertion \(.*\) failed/i'

