#!/usr/bin/perl -w

# Test with assert off.


use Test::More tests => 25
use env


use Carp::Assert < qw(:NDEBUG)


my $tests = <<'END_OF_TESTS'
try { assert(1==0) if DEBUG; };
is $^EVAL_ERROR, '';


try { assert(1==0); };
is $^EVAL_ERROR, '';


try { should('this', 'moofer') if DEBUG };
is $^EVAL_ERROR, '';


try { shouldnt('this', 'this') };
is $^EVAL_ERROR, '';
END_OF_TESTS


my @disable_code = @: 
    "use Carp::Assert < qw(:NDEBUG);"
    "no Carp::Assert;"
    'BEGIN { env::var("NDEBUG") = 1; }  use Carp::Assert;'
    'BEGIN { env::var("PERL_NDEBUG") = 1; }  use Carp::Assert;'
    'BEGIN { env::var("NDEBUG") = 0;  env::var("PERL_NDEBUG") = 1; } use Carp::Assert;'
    

for my $code ( @disable_code)
    local env::var('PERL_NDEBUG') = undef
    local env::var('NDEBUG') = undef
    eval $code . "\n" . $tests; die if $^EVAL_ERROR
    is $^EVAL_ERROR, ''

