#!/usr/local/perl/5.8.8/bin/perl -w

use Test::More 'no_plan';
use env;

package main;

# pre-5.8.0's warns aren't caught by a tied STDERR.
$^WARN_HOOK = sub { $main::_STDERR_ .= @_[0]->message; };

do {
    undef $main::_STDOUT_;
    undef $main::_STDERR_;
#line 115 lib/Carp/Assert.pm

BEGIN {
    local env::var("PERL_NDEBUG") = undef;
    local env::var("NDEBUG") = undef;
    require Carp::Assert;
    Carp::Assert->import;
}

local env::var("PERL_NDEBUG") = undef;
local env::var("NDEBUG") = undef;


    undef $main::_STDOUT_;
    undef $main::_STDERR_;
};

do {
    undef $main::_STDOUT_;
    undef $main::_STDERR_;
#line 217 lib/Carp/Assert.pm
my $life = 'Whimper!';
ok( try { assert( $life =~ m/!$/ ); 1 },   'life ends with a bang' );

    undef $main::_STDOUT_;
    undef $main::_STDERR_;
};

do {
    undef $main::_STDOUT_;
    undef $main::_STDERR_;
#line 237 lib/Carp/Assert.pm
do {
  package Some::Other;
  no Carp::Assert;
  main::ok( try { assert(0) if DEBUG; 1 } );
};

    undef $main::_STDOUT_;
    undef $main::_STDERR_;
};

do {
    undef $main::_STDOUT_;
    undef $main::_STDERR_;
#line 248 lib/Carp/Assert.pm
ok( try { assert(1); 1 } );
ok( !try { assert(0); 1 } );

    undef $main::_STDOUT_;
    undef $main::_STDERR_;
};

do {
    undef $main::_STDOUT_;
    undef $main::_STDERR_;
#line 258 lib/Carp/Assert.pm
try { assert(0) };
like( $^EVAL_ERROR->message, '/^Assertion failed!/',       'error format' );

    undef $main::_STDOUT_;
    undef $main::_STDERR_;
};

do {
    undef $main::_STDOUT_;
    undef $main::_STDERR_;
#line 273 lib/Carp/Assert.pm
try { assert( Dogs->isa('People'), 'Dogs are people, too!' ); };
like( $^EVAL_ERROR->{description}, '/^Assertion \(Dogs are people, too!\) failed!/', 'names' );

    undef $main::_STDOUT_;
    undef $main::_STDERR_;
};

do {
    undef $main::_STDOUT_;
    undef $main::_STDERR_;
#line 310 lib/Carp/Assert.pm
my $foo = 1;  my $bar = 2;
dies_like sub { affirm { $foo == $bar } },
  qr/\$foo == \$bar/;

    undef $main::_STDOUT_;
    undef $main::_STDERR_;
};

    undef $main::_STDOUT_;
    undef $main::_STDERR_;
eval q{
  my $example = sub {
    local $^WARNING = 0;

#line 149 lib/Carp/Assert.pm

    # Take the square root of a number.
    sub my_sqrt {
        my($num) = shift;

        # the square root of a negative number is imaginary.
        assert($num +>= 0);

        return sqrt $num;
    }




;

  }
};
is($^EVAL_ERROR && $^EVAL_ERROR->message, '', "example from line 149");

do {
    undef $main::_STDOUT_;
    undef $main::_STDERR_;
#line 149 lib/Carp/Assert.pm

    # Take the square root of a number.
    sub my_sqrt {
        my($num) = shift;

        # the square root of a negative number is imaginary.
        assert($num +>= 0);

        return sqrt $num;
    }




is( my_sqrt(4),  2,            'my_sqrt example with good input' );
ok( !try{ my_sqrt(-1); 1 },   '  and pukes on bad' );

    undef $main::_STDOUT_;
    undef $main::_STDERR_;
};

    undef $main::_STDOUT_;
    undef $main::_STDERR_;

    undef $main::_STDOUT_;
    undef $main::_STDERR_;
eval q{
  my $example = sub {
    local $^WARNING = 0;
    my $customerid = 0;

#line 300 lib/Carp/Assert.pm

    affirm {
        my $customer = Customer->new($customerid);
        my @cards = $customer->credit_cards;
        grep { $_->is_active }, @cards;
    }, "Our customer has an active credit card";

;

  }
};
is($^EVAL_ERROR, '', "example from line 300");

    undef $main::_STDOUT_;
    undef $main::_STDERR_;

