
use Test::More < qw(no_plan)

use lib 't/lib'
use Foo

ok(Foo->add_trigger(before_foo => sub (@< @_) { print $^STDOUT, "before_foo\n" }),
      'add_trigger in Foo')
ok(Foo->add_trigger(after_foo  => sub (@< @_) { print $^STDOUT, "after_foo\n" }),
      'add_trigger in foo')

my $foo = Foo->new

do
    my $out = ''
    open my $fh, '>>', \$out or die
    local $^STDOUT = $fh->*{IO}
    $foo->foo
    is $out, "before_foo\nfoo\nafter_foo\n"


ok(Foo->add_trigger(after_foo  => sub (@< @_) { print $^STDOUT, "after_foo2\n" }),
      'add_trigger in Foo')

do
    my $out = ''
    open my $fh, '>>', \$out or die
    local $^STDOUT = $fh->*{IO}

    $foo->foo
    is $out, "before_foo\nfoo\nafter_foo\nafter_foo2\n"


ok(Foo->add_trigger(after_foo  => sub (@< @_) { print $^STDOUT, ref @_[0] }),
      'add_trigger in Foo')

do
    my $out = ''
    open my $fh, '>>', \$out or die
    local $^STDOUT = $fh->*{IO}

    $foo->foo
    is $out, "before_foo\nfoo\nafter_foo\nafter_foo2\nFoo", 'class name'


# coverage tests

do
    # pass a non-code ref and catch the carp

    dies_like( { Foo->add_trigger(wrong_type => \$@) },
               qr(add_trigger[(][)] needs coderef), 'check for right callback param')

