
use Test::More tests => 6

use lib 't/lib'
use Foo
use Foo::Bar

ok(Foo->add_trigger(before_foo => sub (@< @_) { print $^STDOUT, "before_foo\n" }),
      'add_trigger in Foo')
ok(Foo::Bar->add_trigger(after_foo  => sub (@< @_) { print $^STDOUT, "after_foo\n" }),
           'add_trigger in Foo::Bar')
ok(Foo::Bar->add_trigger(before_foo  => sub (@< @_) { print $^STDOUT, "before_foo2\n" }),
           'add_trigger in Foo::Bar')
ok(Foo->add_trigger(before_foo => sub (@< @_) { print $^STDOUT, "before_foo3\n" }),
      'add_trigger in Foo')

my $foo = Foo::Bar->new

do
    my $out = ''
    open my $fh, '>>', \$out or die
    local $^STDOUT = $fh->*{IO}

    $foo->foo
    is $out, "before_foo\nbefore_foo3\nbefore_foo2\nfoo\nafter_foo\n"


my $foo_parent = Foo->new
do
    my $out = ''
    open my $fh, '>>', \$out or die
    local $^STDOUT = $fh->*{IO}

    $foo_parent->foo
    is $out, "before_foo\nbefore_foo3\nfoo\n", 'Foo not affected'




