
use Test::More tests => 5

use lib 't/lib'
use Foo

ok(Foo->add_trigger(before_foo => sub (@< @_) { print $^STDOUT, "before_foo\n" }),
      'add_trigger in Foo')

do
    my $out = ''
    open my $fh, '>>', \$out or die
    local $^STDOUT = $fh->*{IO}
    my $foo = Foo->new

    $foo->add_trigger(after_foo => sub (@< @_) { print $^STDOUT, "after_foo\n" })
    $foo->foo
    is $out, "before_foo\nfoo\nafter_foo\n"


do
    my $out = ''
    open my $fh, '>>', \$out or die
    local $^STDOUT = $fh->*{IO}
    my $foo = Foo->new

    $foo->foo
    is $out, "before_foo\nfoo\n"


do
    my $foo = Foo->new
    my $out = ''
    open my $fh, '>>', \$out or die
    local $^STDOUT = $fh->*{IO}
    $foo->add_trigger(after_foo => sub (@< @_) { print $^STDOUT, "after_foo1\n" })
    $foo->add_trigger(after_foo => sub (@< @_) { print $^STDOUT, "after_foo2\n" })
    $foo->foo
    is $out, "before_foo\nfoo\nafter_foo1\nafter_foo2\n"


do
    my $foo = Foo->new
    my $out = ''
    open my $fh, '>>', \$out or die
    local $^STDOUT = $fh->*{IO}
    $foo->foo
    is $out, "before_foo\nfoo\n"


