# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

use Test::More tests => 11

use Clone::PP < qw( clone )
use Data::Dumper

ok 1

package Test::Hash

our @ISA = qw(Clone::PP)

sub new
    my $class = shift
    my %self = %:  < @_ 
    bless \%self, $class


sub DESTROY
    my $self = shift
# warn "DESTROYING $self";


package main

$^WARNING = 0

my $a = Test::Hash->new(
    level => 1,
    href  => \ %: 
        level => 2
        href  => \ %: 
            level => 3
            href  => \ %: 
                level => 4
    )

$a->{+a} = $a

my $b = $a->clone(0)
my $c = $a->clone(3)

ok( $a->{?level} == $b->{?level} )

ok( $b->{?href} \== $a->{?href} )
ok( $c->{?href} \!= $a->{?href} )

ok( $b->{href}->{?href} \== $a->{href}->{?href} )
ok( $c->{href}->{?href} \!= $a->{href}->{?href} )

ok( $c->{href}->{href}->{?level} == 3 )
ok( $c->{href}->{href}->{href}->{?level} == 4 )

ok( $b->{href}->{href}->{?href} \== $a->{href}->{href}->{?href} )
ok( $c->{href}->{href}->{?href} \== $a->{href}->{href}->{?href} )

my %circ = $%
%circ{+c} = \%circ
my $cref = clone(\%circ)
ok( Dumper(\%circ) eq Dumper($cref) )
