# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

use Test::More tests => 5

use Clone::PP < qw( clone )
use Data::Dumper

package Test::Scalar

our @ISA = qw(Clone::PP)

sub new
    my $class = shift
    my $self = shift
    bless \$self, $class


sub DESTROY
    my $self = shift
# warn "DESTROYING $self";


package main

$^WARNING = 0

my $a = Test::Scalar->new(1.0)
my $b = $a->clone(1)

ok( $a->$ == $b->$ )
ok( $a \!= $b )

my $c = \"test 2 scalar"
my $d = Clone::PP::clone($c, 2)

ok( $c->$ == $d->$ )
ok( $c \!= $d )

my $circ = undef
$circ = \$circ
my $aref = clone($circ)
ok( Dumper($circ) eq Dumper($aref) )
