#!./perl

# $Id: dclone.t,v 0.11 2001/07/29 19:31:05 ray Exp $
#
# Id: dclone.t,v 0.6.1.1 2000/03/02 22:21:05 ram Exp
#
#  Copyright (c) 1995-1998, Raphael Manfredi
#
#  You may redistribute only under the terms of the Artistic License,
#  as specified in the README file that comes with the distribution.
#
# $Log: dclone.t,v $
# Revision 0.11  2001/07/29 19:31:05  ray
# VERSION 0.11
#
# Revision 0.10.2.1  2001/07/28 21:47:49  ray
# commented out print statements.
#
# Revision 0.10  2001/04/29 21:56:10  ray
# VERSION 0.10
#
# Revision 0.9  2001/03/05 00:11:49  ray
# version 0.9
#
# Revision 0.9  2000/08/21 23:06:34  ray
# added support for code refs
#
# Revision 0.8  2000/08/11 17:08:36  ray
# Release 0.08.
#
# Revision 0.7  2000/08/01 00:31:42  ray
# release 0.07
#
# Revision 0.6  2000/07/28 21:37:20  ray
# "borrowed" code from Storable
#
# Revision 0.6.1.1  2000/03/02 22:21:05  ram
# patch9: added test case for "undef" bug in hashes
#
# Revision 0.6  1998/06/04  16:08:25  ram
# Baseline for first beta release.
#

require 't/dump.pl'

# use Storable qw(dclone);
use Clone::PP < qw(clone)

use Test::More tests => 5

$a = 'toto'
$b = \$a
our $c = bless \$%, 'CLASS'
$c->{+attribute} = 'attrval'
our %a = %: 'key', 'value', 1, 0, $a, $b, 'cvar', \$c
our @a = @: 'first', undef, 3, -4, -3.14159, 456, 4.5
            $b, \$a, $a, $c, \$c, \%a

my $aref
ok(defined ($aref = clone(\@a)))

our $dumped = dump(\@a)

our $got = dump($aref)

# print $got;
# print $dumped;
# print $_, "\n" for (@a);
# print $_, "\n" foreach (@$aref);
ok( $got eq $dumped );

package FOO; our @ISA = qw(Clone::PP)

sub make
    my $self = bless \$%
    $self->{+key} = \%main::a
    return $self
;

package main

my $foo = FOO->make
my $r
ok( defined($r = $foo->clone) )

# print &dump($foo);
# print &dump($r);
ok( dump($foo) eq dump($r) )

# Ensure refs to "undef" values are properly shared during cloning
my $hash = \$% 
push $hash->{+''}, \$hash->{+a}
ok( $hash->{''}[0] \== \$hash->{+a} )

my $cloned = clone(clone($hash))
require Data::Dumper

# warn "Hash: " . ( $$hash{''}[0] )   . " : " . ( \$$hash{a} )   . "\n";
# warn "Copy: " . ( $$cloned{''}[0] ) . " : " . ( \$$cloned{a} ) . "\n";

warn "This test is todo " unless $cloned->{''}[0] \== \$cloned->{+a}

$cloned->{+a} = "blah"
warn "This test is todo " unless $cloned->{''}[0] \== \$cloned->{+a}

