# $Id: 02hash.t,v 0.19 2006-10-08 03:37:29 ray Exp $
# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

use Test::More tests => 11

use Clone < qw( clone )
use Data::Dumper

######################### End of black magic.

# Insert your test code below (better if it prints "ok 13"
# (correspondingly "not ok 13") depending on the success of chunk 13
# of the test code):

package Test::Hash

our @ISA = qw(Clone)

sub new
    my $class = shift
    my %self = %:  < @_ 
    bless \%self, $class


sub DESTROY
    my $self = shift
# warn "DESTROYING $self";


package main

$^WARNING = 0

my $a = Test::Hash->new(
    level => 1,
    href  => \ %: 
        level => 2
        href  => \ %: 
            level => 3
            href  => \ %: 
                level => 4
    )

$a->{+a} = $a

my $b = $a->clone(0)
my $c = $a->clone(3)

is( $a->{?level}, $b->{?level} )

is( $b->{?href}, $a->{?href} )
isnt( $c->{?href}, $a->{?href} )

is( $b->{href}->{?href}, $a->{href}->{?href} )
isnt( $c->{href}->{?href}, $a->{href}->{?href} )

is( $c->{href}->{href}->{?level}, 3 )
is( $c->{href}->{href}->{href}->{?level}, 4 )

is( $b->{href}->{href}->{?href}, $a->{href}->{href}->{?href} )
is( $c->{href}->{href}->{?href}, $a->{href}->{href}->{?href} )

my %circ = $%
%circ{+c} = \%circ
my $cref = clone(\%circ)
is( Dumper(\%circ), Dumper($cref) )

# test for unicode support
do
    use utf8
    my $a = \%:  chr(256) => 1 
    my $b = clone( $a )
    ok( ord( keys($a->%)[0] ) == ord( keys($b->%)[0] ) )

