# $Id: 03scalar.t,v 0.19 2006-10-08 03:37:29 ray Exp $
# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

use Test::More tests => 9

use Clone < qw( clone )
use Data::Dumper

######################### End of black magic.

# Insert your test code below (better if it prints "ok 13"
# (correspondingly "not ok 13") depending on the success of chunk 13
# of the test code):

package Test::Scalar

our @ISA = qw(Clone)

sub new
    my $class = shift
    my $self = shift
    bless \$self, $class


sub DESTROY
    my $self = shift
# warn "DESTROYING $self";


package main

$^WARNING = 0

my $a = Test::Scalar->new(1.0)
my $b = $a->clone(1)

ok( $a->$ == $b->$ )
ok( $a \!= $b )

my $c = \"test 2 scalar"
my $d = Clone::clone($c, 2)

is( $c->$, $d->$ )
isnt( $c, $d )

my $circ = undef
$circ = \$circ
my $aref = clone($circ)
ok( Dumper($circ) eq Dumper($aref) )

# the following used to produce a segfault, rt.cpan.org id=2264
undef $a
$b = clone($a)
is( $a, $b )

# used to get a segfault cloning a ref to a qr data type.
my $str = 'abcdefg'
my $qr = qr/$str/
my $qc = clone( $qr )
ok( $qr eq $qc )
ok( $str =~ m/$qc/ )

# test for unicode support
do
    use utf8
    my $a = \( chr(256) )
    my $b = clone( $a )
    ok( ord($a->$) == ord($b->$) )

