#!/usr/local/bin/perl

use lib '..','../blib/lib','.','./blib/lib'

eval "use Crypt::DES()"
if ($^EVAL_ERROR)
    print $^STDOUT, "1..0 # Skipped: Crypt::DES not installed\n"
    exit


print $^STDOUT, "1..33\n"

sub test($num, $true, ?$msg)
    local($^WARNING) = 0

    print($^STDOUT, $true ?? "ok $num\n" !! "not ok $num $msg\n")


my $test_data = <<END
Mary had a little lamb,
Its fleece was black as coal,
And everywere that Mary went,
That lamb would dig a hole.
END
    

use Crypt::CBC

my ($i, $c, $p)

test(1,!$^EVAL_ERROR,"Couldn't load module")
test(2, ($i = Crypt::CBC->new( key => 'secret', cipher => 'DES')),
     "Couldn't create new object")
test(3, ($c = $i->encrypt($test_data)), "Couldn't encrypt")
test(4, ($p = $i->decrypt($c)), "Couldn't decrypt")
test(5,$p eq $test_data,"Decrypted ciphertext doesn't match plaintext")

# now try various truncations of the whole
for my $c (1..7)
    substr($test_data,-$c, undef, '')  # truncate
    test(5+$c,$i->decrypt($i->encrypt($test_data)) eq $test_data)


# now try various short strings
for my $c (0..18)
    $test_data = 'i' x $c
    test (13+$c,$i->decrypt($i->encrypt($test_data)) eq $test_data)



# make sure that strings that end in spaces or nulls are treated correctly
$test_data = "This string ends in a null\0"
test (32,$i->decrypt($i->encrypt($test_data)) eq $test_data)

$test_data = "This string ends in some spaces  "
test (33,$i->decrypt($i->encrypt($test_data)) eq $test_data)
