#!/usr/bin/perl -w


use lib '..','../blib/lib','.','./blib/lib'

my (@mods,@pads,@in,$pad,$test_data,$mod,$tnum,$c,$i,$p)

@mods = qw/Rijndael
           Blowfish
           Blowfish_PP
           IDEA
           DES
          /
@pads = qw/standard oneandzeroes space null/

for my $mod ( @mods)
    eval "use Crypt::$mod(); 1" && push @in,$mod


unless ((nelems(@in)-1) +> -1)
    print $^STDOUT, "1..0 # Skipped: no cryptographic modules found\n"
    exit


print $^STDOUT, '1..', 128*((nelems(@in)-1) + 1) * ((nelems(@pads)-1) + 1) + 1, "\n"

sub test($num, $true,$msg)
    local($^WARNING) = 0

    $num->$++
    print($^STDOUT, $true ?? "ok $num->$\n" !! "not ok $num->$ $msg\n")


$tnum = 0

eval "use Crypt::CBC"
test(\$tnum,!$^EVAL_ERROR,"Couldn't load module")

for my $mod ( @in)
    for my $pad ( @pads)
        my $cipher = Crypt::CBC->new(key => 'secret',
            cipher => $mod,
            padding => $pad
            )
        for my $length (1..128)
            my $test_data = 'a'x$length . '0'
            my $encrypted = $cipher->encrypt_hex($test_data)
            my $decrypted = $cipher->decrypt_hex($encrypted)
            test(\$tnum,$test_data eq $decrypted,"$mod/$pad: match failed on zero-terminated data length $length")
        
    


