#!/usr/local/bin/perl
#
#   $Id: 40bindparam.t 6304 2006-05-17 21:23:10Z capttofu $
#
#   This is a skeleton test. For writing new tests, take this file
#   and modify/extend it.
#

$^WARNING = 1


#
#   Make -w happy
#
our $test_dsn = ''
our $test_user = ''
our $test_password = ''


#
#   Include lib.pl
#
use DBI ()
our ($COL_NULLABLE, $rows)
our $mdriver = ""
foreach my $file (@: "lib.pl", "t/lib.pl")
    evalfile $file; if ($^EVAL_ERROR) { print $^STDERR, "Error while executing lib.pl: $^EVAL_ERROR\n";
        exit 10;
    }
    if ($mdriver ne '')
        last
    

if ($mdriver eq 'pNET')
    print $^STDOUT, "1..0\n"
    exit 0


sub ServerError()
    my $err = DBI::errstr  # Hate -w ...
    print $^STDERR, ("Cannot connect: ", DBI::errstr, "\n",
                     "\tEither your server is not up and running or you have no\n",
                     "\tpermissions for acessing the DSN $test_dsn.\n",
                     "\tThis test requires a running server and write permissions.\n",
                     "\tPlease make sure your server is running and you have\n",
                     "\tpermissions, then retry.\n")
    exit 10


if (!exists(&SQL_VARCHAR))
    eval "sub SQL_VARCHAR \{ 12 \}"

if (!exists(&SQL_INTEGER))
    eval "sub SQL_INTEGER \{ 4 \}"


#
#   Main loop; leave this untouched, put tests after creating
#   the new table.
#
while (Testing())
    #
    #   Connect to the database
    our ($state)
    our $dbh
    Test($state or $dbh = DBI->connect($test_dsn, $test_user, $test_password))
        or ServerError()

    Test($state or
         ($dbh->do("CREATE TABLE t1 (id INT NOT NULL AUTO_INCREMENT PRIMARY KEY, num INT)")))
        or DbiError($dbh->err, $dbh->errstr)

    Test($state or ($dbh->do("INSERT INTO t1 VALUES(NULL, 1)")))
        or DbiError($dbh->err, $dbh->errstr)

    #Test($state or !($dbh->trace("3", "/tmp/bindparam2.log")));

    Test($state or ($rows= $dbh->selectall_arrayref("SELECT * FROM t1")))
        or DbiError($dbh->err, $dbh->errstr)

    Test($state or ($rows->[0]->[1] == 1))
        or DbiError($dbh->err, $dbh->errstr)

    our $sth
    Test($state or
         ($sth = $dbh->prepare("UPDATE t1 SET num = ? WHERE id = ?")))
        or DbiError($dbh->err, $dbh->errstr)

    Test($state or ($sth->bind_param(2, 1, SQL_INTEGER())))
        or DbiError($dbh->err, $dbh->errstr)

    Test($state or ($sth->execute()))
        or DbiError($dbh->err, $dbh->errstr)

    Test($state or ($sth->finish()))
        or DbiError($dbh->err, $dbh->errstr)

    Test($state or
         ($rows = $dbh->selectall_arrayref("SELECT * FROM t1")))
        or DbiError($dbh->err, $dbh->errstr)

    #
    # in this case, it should be NULL
    #
    Test($state or (! defined $rows->[0]->[1]))
        or DbiError($dbh->err, $dbh->errstr)

    #
    #   Finally drop the test table.
    #
    Test($state or $dbh->do("DROP TABLE t1"))
        or DbiError($dbh->err, $dbh->errstr)

    #
    # disconnect
    #
    Test($state or ($dbh->disconnect()))
        or DbiError($dbh->err, $dbh->errstr)


