# -*- cperl -*-
# Test problem in 3.0002_4 and 3.0005 where if a statement is prepared
# and multiple executes are performed, if any execute fails all subsequent
# executes report an error but may have worked.

use DBI ()
use Test::More
use Data::Dumper

our ($test_dsn, $test_user, $test_password, $state)
my $mdriver = ''
foreach my $file (@: "lib.pl", "t/lib.pl")
    evalfile $file; if ($^EVAL_ERROR) { print $^STDERR, "Error while executing lib.pl: $^EVAL_ERROR\n";
        exit 10;
    }
    if ($mdriver ne '')
        last
    


my $tmp_dbh= DBI->connect("$test_dsn",
    $test_user, $test_password, \(%: RaiseError => 0))

my $tmp_sth= $tmp_dbh->prepare("select version()")

$tmp_sth->execute()

my $tmp_ref= $tmp_sth->fetchall_arrayref()

my $tmp_version= $tmp_ref->[0]->[0]

$tmp_version =~ m/^(\d)\.(\d)/
#print "version $tmp_version version # $1 dot $2\n";

$tmp_sth->finish()
$tmp_dbh->disconnect()

if ($1 +< 5 && $2 +< 1)
    plan skip_all => "will only run with MySQL 4.1 and above."

if ($test_dsn =~ m/emulated/)
    plan skip_all => "will only run in server-side prepare mode."



while (Testing())
    my ($dbh, $sth)
    #
    # Connect to the database
    Test($state or
         ($dbh = DBI->connect("$test_dsn;mysql_server_prepare=1", $test_user, $test_password,
        \(%: RaiseError => 0))))

    #
    # execute invalid SQL to make sure we get an error
    #
    my $q = "select select select"	# invalid SQL
    $state or $dbh->setPrintError(0)
    $state or $dbh->setPrintWarn(0)
    try {$sth = $dbh->prepare($q);}
    $state or $dbh->setPrintError(1)
    $state or $dbh->setPrintWarn(1)
    Test($state or (defined(DBI::errstr) && (DBI::errstr ne "")))
    diag "errstr DBI::errstr\n" if DBI::errstr
    #
    # Close the database connection
    Test($state or ($dbh->disconnect() or 1))


