package DBI::Util::_accessor

our $VERSION = sprintf("0.\%06d", q$Revision: 9478 $ =~ m/(\d+)/)

# inspired by Class::Accessor::Fast

sub new($proto, $fields)
    my $class = ref $proto || $proto
    $fields ||= \$%

    my @dubious = grep { !m/^_/ && !$proto->can($_) }, keys $fields->%
    warn "$class doesn't have accessors for fields: $(join ' ', @dubious)" if nelems(@dubious)

    # make a (shallow) copy of $fields.
    bless \(%: < $fields->%), $class


sub mk_accessors($self, @< @fields)
    $self->mk_accessors_using('make_accessor', < @fields)


sub mk_accessors_using($self, $maker, @< @fields)
    my $class = ref $self || $self

    # So we don't have to do lots of lookups inside the loop.
    $maker = $self->can($maker) unless ref $maker


    foreach my $field ( @fields)
        my $accessor = $self->?$maker($field)
        Symbol::fetch_glob($class."\:\:$field")->* = $accessor
            unless exists Symbol::fetch_glob($class."\:\:$field")->*->&
    
    #my $hash_ref = \%{$class."\:\:_accessors_hash};
    #$hash_ref->{$_}++ for @fields;
    # XXX also copy down _accessors_hash of base class(es)
    # so one in this class is complete
    return


sub make_accessor
    my(@: $class, $field) =  @_
    return sub (@< @_)
        my $self = shift
        return $self->{?$field} unless nelems(@_)
        die "Too many arguments to $field" if nelems(@_) +> 1
        return ($self->{+$field} = shift)
    


sub make_accessor_autoviv_hashref
    my(@: $class, $field) =  @_
    return sub (@< @_)
        my $self = shift
        return ($self->{+$field} ||= \$%) unless nelems(@_)
        die "Too many arguments to $field" if nelems(@_) +> 1
        return ($self->{+$field} = shift)
    


1
