#!perl -w

use Test::More tests => 8

$^OUTPUT_AUTOFLUSH=1
$^WARNING=1

BEGIN { use_ok( 'DBI', ':sql_types' ) }
BEGIN { use_ok( 'DBI::DBD::Metadata' ) } # just to check for syntax errors etc

my $dbh = DBI->connect("dbi:ExampleP:.","","", \(%:  FetchHashKeyName => 'NAME_lc' ))
    or die "Unable to connect to ExampleP driver: DBI::errstr"

isa_ok($dbh, 'DBI::db')
#$dbh->trace(3);

#use Data::Dumper;
#print Dumper($dbh->type_info_all);
#print Dumper($dbh->type_info);
#print Dumper($dbh->type_info(DBI::SQL_INTEGER));

my @ti = $dbh->type_info
ok(nelems(@ti)+>0)

is($dbh->type_info(SQL_INTEGER)[0]->{?DATA_TYPE}, SQL_INTEGER)
is($dbh->type_info(SQL_INTEGER)[0]->{?TYPE_NAME}, 'INTEGER')

is($dbh->type_info(SQL_VARCHAR)[0]->{?DATA_TYPE}, SQL_VARCHAR)
is($dbh->type_info(SQL_VARCHAR)[0]->{?TYPE_NAME}, 'VARCHAR')

1
