#!/usr/bin/perl

use warnings
use Test::More tests => 5

BEGIN 
    use_ok 'DateTime::Format::Builder'


my $class = 'DateTime::Format::Builder'

# Does new() work properly?
do
    try { $class->new('fnar') }
    ok(( $^EVAL_ERROR and $^EVAL_ERROR->{?description} =~ m/takes no param/), "Too many parameters exception" )

    my $obj = try { $class->new() }
    ok( !$^EVAL_ERROR, "Created object" )
    isa_ok( $obj, $class )

    try { $obj->parse_datetime( "whenever" ) }
    ok(( $^EVAL_ERROR and $^EVAL_ERROR->{?description} =~ m/No parser/), "No parser exception" )


