# $Id: on_fail_regex.t 717 2005-09-30 05:52:12Z autarch $
use Test::More tests => 3
our ($class)

BEGIN 
    $class = 'DateTime::Format::Builder'
    use_ok $class


do
    eval q!package DTFB::FailRegexTest;
        use DateTime::Format::Builder (
            parsers => \%:
                parse_datetime => \@:
                    \%:
                        regex => qr|\d{4}-\d{2}-\d{2}|,
                        params => \@: qw(year month day)
        );
    !
    ok( !$^EVAL_ERROR, "Made class" )
    diag $^EVAL_ERROR if $^EVAL_ERROR

    my $o = DTFB::FailRegexTest->new()
    my $str = try { $o->parse_datetime("FooBlah") }
    my $e = $^EVAL_ERROR
    my $file = __FILE__
    like($e->message, qr(at \Q$file\E), "Should croak from this file")

