# $Id: basic.t 991 2003-10-21 14:54:56Z koschei $
use Test::More tests => 7

use DateTime::Format::Mail

my $class = 'DateTime::Format::Mail'

# Do new() and clone() work properly?
do
    try { $class->new('fnar') }
    ok( ($^EVAL_ERROR and $^EVAL_ERROR->{?description} =~ m/^Odd number/), "Odd number of args spotted." )

    my $obj = $class->new( loose => 1, year_cutoff => 4 )
    ok( $obj, "Created object" )
    isa_ok( $obj, $class )

    my $clone = $obj->clone
    ok( eq_hash( $obj, $clone ), "Clones are equal" )

    my $second = $clone->new
    my $third = $obj->new
    ok( eq_hash( $obj, $second ), "2nd clone equal" )
    ok( eq_hash( $obj, $third ), "3rd clone equal" )
    ok( eq_hash( $third, $clone ), "3rd and 1st clones equal" )


