#!/usr/bin/perl -w

use Test::More tests => 8

use DateTime
use DateTime::Locale

try { DateTime->new( year => 100, locale => 'en_US' ) }
ok( ! $^EVAL_ERROR, 'make sure constructor accepts locale parameter' )

try { DateTime->now( locale => 'en_US' ) }
ok( ! $^EVAL_ERROR, 'make sure constructor accepts locale parameter' )

try { DateTime->today( locale => 'en_US' ) }
ok( ! $^EVAL_ERROR, 'make sure constructor accepts locale parameter' )

try { DateTime->from_epoch( epoch => 1, locale => 'en_US' ) }
ok( ! $^EVAL_ERROR, 'make sure constructor accepts locale parameter' )

try { DateTime->last_day_of_month( year => 100, month => 2, locale => 'en_US' ) }
ok( ! $^EVAL_ERROR, 'make sure constructor accepts locale parameter' )

do
    package DT::Object
    sub utc_rd_values { ( (@:  0, 0 ) ) }


DateTime->from_object( object => (bless \(%: ), 'DT::Object'), locale => 'en_US' )
ok( 1, 'make sure constructor accepts locale parameter' )

DateTime->new( year => 100, locale => DateTime::Locale->load('en_US') )
ok( 1, 'make sure constructor accepts locale parameter as object' )

DateTime->DefaultLocale('it')
is( DateTime->now->locale->id, 'it', 'default locale should now be "it"' )
