#!/usr/bin/perl -w

use Test::More tests => 4

use DateTime


do
    try {
        DateTime->new( year => 2003, month => 4, day => 6,
            hour => 2, time_zone => 'America/Chicago',
            )
    }

    like( $^EVAL_ERROR->{?description}, qr/Invalid local time .+/, 'exception for invalid time' )

    try {
        DateTime->new( year => 2003, month => 4, day => 6,
            hour => 2, minute => 59, second => 59,
            time_zone => 'America/Chicago',
            );
    }
    like( $^EVAL_ERROR->{?description}, qr/Invalid local time .+/, 'exception for invalid time' )


do
    try {
        DateTime->new( year => 2003, month => 4, day => 6,
            hour => 1, minute => 59, second => 59,
            time_zone => 'America/Chicago',
            );
    }
    ok( ! $^EVAL_ERROR, 'no exception for valid time' )

    my $dt = DateTime->new( year => 2003, month => 4, day => 5,
        hour => 2,
        time_zone => 'America/Chicago',
        )

    try { $dt->add( days => 1 ) }
    like( $^EVAL_ERROR->{?description}, qr/Invalid local time .+/, 'exception for invalid time produced via add' )

