#!perl -w

print $^STDOUT, "1..6\n"

use Digest::MD5 < qw(md5_hex)

my $a = Digest::MD5->new
$a->add("a")
my $b = $a->clone

print $^STDOUT, "not " unless $b->clone->hexdigest eq md5_hex("a")
print $^STDOUT, "ok 1\n"

$a->add("a")
print $^STDOUT, "not " unless $a->hexdigest eq md5_hex("aa")
print $^STDOUT, "ok 2\n"

print $^STDOUT, "not " unless $a->hexdigest eq md5_hex("")
print $^STDOUT, "ok 3\n"

$b->add("b")
print $^STDOUT, "not " unless $b->clone->hexdigest eq md5_hex("ab")
print $^STDOUT, "ok 4\n"

$b->add("c")
print $^STDOUT, "not " unless $b->clone->hexdigest eq md5_hex("abc")
print $^STDOUT, "ok 5\n"

# Test that cloning picks up the correct class for subclasses.
do
    package MD5
    @MD5::ISA = qw(Digest::MD5)


$a = MD5->new
$a->add("a")
$b = $a->clone

print $^STDOUT, "not " unless ref($b) eq "MD5" && $b->add("b")->hexdigest eq md5_hex("ab")
print $^STDOUT, "ok 6\n"
