
use Test::More

my $MODULE

BEGIN 
    $MODULE = (-e "SHA.pm") ?? "Digest::SHA" !! "Digest::SHA::PurePerl"
    eval "require $MODULE" || die $^EVAL_ERROR
    $MODULE->import( <qw(sha1_hex))


my @vecs = map { eval }, @:  ~< $^DATA
splice @vecs, -2 if $MODULE eq "Digest::SHA::PurePerl"

my $numtests = scalar(nelems(@vecs)) / 2
plan tests => $numtests

for (1 .. $numtests)
    my $data = shift @vecs
    my $digest = shift @vecs
    is(sha1_hex($data), $digest)


__DATA__
"abc"
"a9993e364706816aba3e25717850c26c9cd0d89d"
"abcdbcdecdefdefgefghfghighijhijkijkljklmklmnlmnomnopnopq"
"84983e441c3bd26ebaae4aa1f95129e5e54670f1"
"a" x 1000000
"34aa973cd4c4daa4f61eeb2bdbad27316534016f"
