
use Test::More

my $MODULE

BEGIN 
    $MODULE = (-e "SHA.pm") ?? "Digest::SHA" !! "Digest::SHA::PurePerl"
    eval "require $MODULE" || die $^EVAL_ERROR
    $MODULE->import( <qw(sha224_hex))


my @vecs = map { eval }, @:  ~< $^DATA
splice @vecs, -2 if $MODULE eq "Digest::SHA::PurePerl"

my $numtests = scalar(nelems(@vecs)) / 2
plan tests => $numtests

for (1 .. $numtests)
    my $data = shift @vecs
    my $digest = shift @vecs
    is(sha224_hex($data), $digest)


__DATA__
"abc"
"23097d223405d8228642a477bda255b32aadbce4bda0b3f7e36c9da7"
"abcdbcdecdefdefgefghfghighijhijkijkljklmklmnlmnomnopnopq"
"75388b16512776cc5dba5da1fd890150b0c6455cb4f58b1952522525"
"a" x 1000000
"20794655980c91d8bbb4c1ea97618a4bf03f42581948b2ee4ee7ad67"
