#!perl -w

use Test::More
plan tests => 2

use Digest::SHA1

my $sha1 = Digest::SHA1->new

if ($Digest::base::VERSION && $Digest::base::VERSION)
    $sha1->add_bits("01111111")
    is($sha1->hexdigest, "23833462f55515a900e016db2eb943fb474c19f6")
    try {
        $sha1->add_bits("0111");
    }
    ok($^EVAL_ERROR->{?description} =~ m/must be multiple of 8/)
else
    print $^STDOUT, "# No Digest::base\n"
    try {
        $sha1->add_bits("foo");
    }
    ok($^EVAL_ERROR->{?description} =~ m/^Can\'t locate Digest\/base\.pm in \@INC/)
    ok(1)  # dummy


