#
# $Id: CJKConstants.pm,v 2.2 2006/06/03 20:28:48 dankogai Exp $
#

package Encode::CJKConstants

use warnings
our $RCSID = q$Id: CJKConstants.pm,v 2.2 2006/06/03 20:28:48 dankogai Exp $
our $VERSION = do { my @r = (@:  q$Revision: 2.2 $ =~ m/\d+/g ); sprintf "\%d." . "\%02d" x( nelems(@r)-1), < @r }

use Carp

require Exporter
our @ISA         = qw(Exporter)
our @EXPORT      = $@
our @EXPORT_OK   = qw(%CHARCODE %ESC %RE)
our %EXPORT_TAGS = %:  'all' => @EXPORT_OK +@+ @EXPORT 

my %_0208 = %: 
    1978 => '\e\$\@'
    1983 => '\e\$B'
    1990 => '\e&\@\e\$B'
    

our %CHARCODE = %: 
    UNDEF_EUC     => "\x[a2]\x[ae]"    # ® in EUC
    UNDEF_SJIS    => "\x[81]\x[ac]"    # ® in SJIS
    UNDEF_JIS     => "\x[a2]\x[f7]"    #  -- used in unicode
    UNDEF_UNICODE => "\x[20]\x[20]"    #  -- used in unicode
    

our %ESC = %: 
    GB_2312   => "\e\$A"
    JIS_0208  => "\e\$B"
    JIS_0212  => "\e\$(D"
    KSC_5601  => "\e\$(C"
    ASC       => "\e\(B"
    KANA      => "\e\(I"
    '2022_KR' => "\e\$)C"
    

our %RE = %: 
    ASCII     => '[\x[00]-\x[7f]]'
    BIN       => '[\x[00]-\x[06]\x[7f]\x[ff]]'
    EUC_0212  => '\x[8f][\x[a1]-\x[fe]][\x[a1]-\x[fe]]'
    EUC_C     => '[\x[a1]-\x[fe]][\x[a1]-\x[fe]]'
    EUC_KANA  => '\x[8e][\x[a1]-\x[df]]'
    JIS_0208  => "%_0208{?1978}|%_0208{?1983}|%_0208{?1990}"
    JIS_0212  => "\e" . '\$\(D'
    ISO_ASC   => "\e" . '\([BJ]'
    JIS_KANA  => "\e" . '\(I'
    '2022_KR' => "\e" . '\$\)C'
    SJIS_C    => '[\x[81]-\x[9f]\x[e0]-\x[fc]][\x[40]-\x[7e]\x[80]-\x[fc]]'
    SJIS_KANA => '[\x[a1]-\x[df]]'
    UTF8      => '[\x[c0]-\x[df]][\x[80]-\x[bf]]|[\x[e0]-\x[ef]][\x[80]-\x[bf]][\x[80]-\x[bf]]'
    

1

=head1 NAME

Encode::CJKConstants.pm -- Internally used by Encode::??::ISO_2022_*

=cut

