#
# $Id: H2Z.pm,v 2.2 2006/06/03 20:28:48 dankogai Exp $
#

package Encode::JP::H2Z

use warnings

our $RCSID = q$Id: H2Z.pm,v 2.2 2006/06/03 20:28:48 dankogai Exp $
our $VERSION = do { my @r = (@:  q$Revision: 2.2 $ =~ m/\d+/g ); sprintf "\%d." . "\%02d" x( nelems(@r)-1), < @r }

use Encode::CJKConstants < qw(:all)

our (%_D2Z,  $_PAT_D2Z
    ,  %_Z2D,  $_PAT_Z2D
    ,  %_H2Z,  $_PAT_H2Z
    ,  %_Z2H,  $_PAT_Z2H)

%_H2Z = %: 
    "\x[8e]\x[a1]" => "\x[a1]\x[a3]"    #£
    "\x[8e]\x[a2]" => "\x[a1]\x[d6]"    #
    "\x[8e]\x[a3]" => "\x[a1]\x[d7]"    #
    "\x[8e]\x[a4]" => "\x[a1]\x[a2]"    #¢
    "\x[8e]\x[a5]" => "\x[a1]\x[a6]"    #¦
    "\x[8e]\x[a6]" => "\x[a5]\x[f2]"    #
    "\x[8e]\x[a7]" => "\x[a5]\x[a1]"    #¡
    "\x[8e]\x[a8]" => "\x[a5]\x[a3]"    #£
    "\x[8e]\x[a9]" => "\x[a5]\x[a5]"    #¥
    "\x[8e]\x[aa]" => "\x[a5]\x[a7]"    #§
    "\x[8e]\x[ab]" => "\x[a5]\x[a9]"    #©
    "\x[8e]\x[ac]" => "\x[a5]\x[e3]"    #
    "\x[8e]\x[ad]" => "\x[a5]\x[e5]"    #
    "\x[8e]\x[ae]" => "\x[a5]\x[e7]"    #
    "\x[8e]\x[af]" => "\x[a5]\x[c3]"    #
    "\x[8e]\x[b0]" => "\x[a1]\x[bc]"    #¼
    "\x[8e]\x[b1]" => "\x[a5]\x[a2]"    #¢
    "\x[8e]\x[b2]" => "\x[a5]\x[a4]"    #¤
    "\x[8e]\x[b3]" => "\x[a5]\x[a6]"    #¦
    "\x[8e]\x[b4]" => "\x[a5]\x[a8]"    #¨
    "\x[8e]\x[b5]" => "\x[a5]\x[aa]"    #ª
    "\x[8e]\x[b6]" => "\x[a5]\x[ab]"    #«
    "\x[8e]\x[b7]" => "\x[a5]\x[ad]"    #­
    "\x[8e]\x[b8]" => "\x[a5]\x[af]"    #¯
    "\x[8e]\x[b9]" => "\x[a5]\x[b1]"    #±
    "\x[8e]\x[ba]" => "\x[a5]\x[b3]"    #³
    "\x[8e]\x[bb]" => "\x[a5]\x[b5]"    #µ
    "\x[8e]\x[bc]" => "\x[a5]\x[b7]"    #·
    "\x[8e]\x[bd]" => "\x[a5]\x[b9]"    #¹
    "\x[8e]\x[be]" => "\x[a5]\x[bb]"    #»
    "\x[8e]\x[bf]" => "\x[a5]\x[bd]"    #½
    "\x[8e]\x[c0]" => "\x[a5]\x[bf]"    #¿
    "\x[8e]\x[c1]" => "\x[a5]\x[c1]"    #
    "\x[8e]\x[c2]" => "\x[a5]\x[c4]"    #
    "\x[8e]\x[c3]" => "\x[a5]\x[c6]"    #
    "\x[8e]\x[c4]" => "\x[a5]\x[c8]"    #
    "\x[8e]\x[c5]" => "\x[a5]\x[ca]"    #
    "\x[8e]\x[c6]" => "\x[a5]\x[cb]"    #
    "\x[8e]\x[c7]" => "\x[a5]\x[cc]"    #
    "\x[8e]\x[c8]" => "\x[a5]\x[cd]"    #
    "\x[8e]\x[c9]" => "\x[a5]\x[ce]"    #
    "\x[8e]\x[ca]" => "\x[a5]\x[cf]"    #
    "\x[8e]\x[cb]" => "\x[a5]\x[d2]"    #
    "\x[8e]\x[cc]" => "\x[a5]\x[d5]"    #
    "\x[8e]\x[cd]" => "\x[a5]\x[d8]"    #
    "\x[8e]\x[ce]" => "\x[a5]\x[db]"    #
    "\x[8e]\x[cf]" => "\x[a5]\x[de]"    #
    "\x[8e]\x[d0]" => "\x[a5]\x[df]"    #
    "\x[8e]\x[d1]" => "\x[a5]\x[e0]"    #
    "\x[8e]\x[d2]" => "\x[a5]\x[e1]"    #
    "\x[8e]\x[d3]" => "\x[a5]\x[e2]"    #
    "\x[8e]\x[d4]" => "\x[a5]\x[e4]"    #
    "\x[8e]\x[d5]" => "\x[a5]\x[e6]"    #
    "\x[8e]\x[d6]" => "\x[a5]\x[e8]"    #
    "\x[8e]\x[d7]" => "\x[a5]\x[e9]"    #
    "\x[8e]\x[d8]" => "\x[a5]\x[ea]"    #
    "\x[8e]\x[d9]" => "\x[a5]\x[eb]"    #
    "\x[8e]\x[da]" => "\x[a5]\x[ec]"    #
    "\x[8e]\x[db]" => "\x[a5]\x[ed]"    #
    "\x[8e]\x[dc]" => "\x[a5]\x[ef]"    #
    "\x[8e]\x[dd]" => "\x[a5]\x[f3]"    #
    "\x[8e]\x[de]" => "\x[a1]\x[ab]"    #«
    "\x[8e]\x[df]" => "\x[a1]\x[ac]"    #¬
    

%_D2Z = (%: 
    "\x[8e]\x[b6]\x[8e]\x[de]" => "\x[a5]\x[ac]"    #¬
    "\x[8e]\x[b7]\x[8e]\x[de]" => "\x[a5]\x[ae]"    #®
    "\x[8e]\x[b8]\x[8e]\x[de]" => "\x[a5]\x[b0]"    #°
    "\x[8e]\x[b9]\x[8e]\x[de]" => "\x[a5]\x[b2]"    #²
    "\x[8e]\x[ba]\x[8e]\x[de]" => "\x[a5]\x[b4]"    #´
    "\x[8e]\x[bb]\x[8e]\x[de]" => "\x[a5]\x[b6]"    #¶
    "\x[8e]\x[bc]\x[8e]\x[de]" => "\x[a5]\x[b8]"    #¸
    "\x[8e]\x[bd]\x[8e]\x[de]" => "\x[a5]\x[ba]"    #º
    "\x[8e]\x[be]\x[8e]\x[de]" => "\x[a5]\x[bc]"    #¼
    "\x[8e]\x[bf]\x[8e]\x[de]" => "\x[a5]\x[be]"    #¾
    "\x[8e]\x[c0]\x[8e]\x[de]" => "\x[a5]\x[c0]"    #
    "\x[8e]\x[c1]\x[8e]\x[de]" => "\x[a5]\x[c2]"    #
    "\x[8e]\x[c2]\x[8e]\x[de]" => "\x[a5]\x[c5]"    #
    "\x[8e]\x[c3]\x[8e]\x[de]" => "\x[a5]\x[c7]"    #
    "\x[8e]\x[c4]\x[8e]\x[de]" => "\x[a5]\x[c9]"    #
    "\x[8e]\x[ca]\x[8e]\x[de]" => "\x[a5]\x[d0]"    #
    "\x[8e]\x[cb]\x[8e]\x[de]" => "\x[a5]\x[d3]"    #
    "\x[8e]\x[cc]\x[8e]\x[de]" => "\x[a5]\x[d6]"    #
    "\x[8e]\x[cd]\x[8e]\x[de]" => "\x[a5]\x[d9]"    #
    "\x[8e]\x[ce]\x[8e]\x[de]" => "\x[a5]\x[dc]"    #
    "\x[8e]\x[ca]\x[8e]\x[df]" => "\x[a5]\x[d1]"    #
    "\x[8e]\x[cb]\x[8e]\x[df]" => "\x[a5]\x[d4]"    #
    "\x[8e]\x[cc]\x[8e]\x[df]" => "\x[a5]\x[d7]"    #
    "\x[8e]\x[cd]\x[8e]\x[df]" => "\x[a5]\x[da]"    #
    "\x[8e]\x[ce]\x[8e]\x[df]" => "\x[a5]\x[dd]"    #
    "\x[8e]\x[b3]\x[8e]\x[de]" => "\x[a5]\x[f4]"    #
    )

# init only once;

#$_PAT_D2Z = join("|", keys %_D2Z);
#$_PAT_H2Z = join("|", keys %_H2Z);

%_Z2H = %:  < reverse @:< %_H2Z 
%_Z2D = (%:  < reverse @:< %_D2Z )

#$_PAT_Z2H    = join("|", keys %_Z2H);
#$_PAT_Z2D    = join("|", keys %_Z2D);

sub h2z($r_str, ?$keep_dakuten)
    no warnings < qw(uninitialized)
    my $n              = 0
    unless ($keep_dakuten)
        $n = (
            $r_str->$ =~ s(
               (%RE{?EUC_KANA}
                (?:\x[8e][\x[de]\x[df]])?)
             ){$( do {
                     my $str = $1;
                     %_D2Z{?$str} || %_H2Z{?$str} ||
                     # in case dakuten and handakuten are side-by-side!
                     %_H2Z{?substr($str,0,2)} . %_H2Z{?substr($str,2,2)};
             })}gx
          )
    else
        $n = (
            $r_str->$ =~ s(
               (%RE{?EUC_KANA})
             ){$(%_H2Z{?$1})}gx
          )
    $n


sub z2h
    my $r_str = shift
    my $n     = (
        $r_str->$ =~ s(
                       (%RE{?EUC_C}|%RE{?EUC_0212}|%RE{?EUC_KANA})
                      ){$( %_Z2D{?$1} || %_Z2H{?$1} || $1 )}gx
        )
    $n


1
__END__


=head1 NAME

Encode::JP::H2Z -- internally used by Encode::JP::2022_JP*

=cut
