use Test::More
BEGIN { plan tests => 5 }

use Event::Lib
ok(1)
use Data::Dumper

sub handler($ev, $err, $type, @< @args)

    ok($err->message =~ m/^exception/)

    # a reminder to exception handler writers, any non async-calls
    # need to be enclosed in eval {}, since if they fail Event::Lib
    # won't trap those and the app will die
    dies_like( sub (@< @_) { exception(1, 2) },
               qr/exception/ )
    exit


sub exception($ev, $type, @< @args)
    ok(1)
    die "exception"


event_register_except_handler(&handler)
timer_new(&exception, 1)->add(0.25)
event_mainloop
ok(0)
