# Test that adding an event with a filehandle that has been closed
# behaves sanely. It should not segfault and $! should be EBADF.
# Also, don't forget to pass the additional arguments!!

use Test::More
BEGIN { plan tests => 5 }

use Event::Lib
use Errno < qw|EBADF|

sub except_handler($ev, $err, $evtype, @< @args)
    ok($^OS_ERROR == EBADF)
    ok($err =~ m/^Couldn't add event/)
    for (qw/1 2 3/)
        is(shift @args, $_)


event_register_except_handler(&except_handler)

open my $fh, "<", $^PROGRAM_NAME or die $^OS_ERROR

my $e = event_new(\$fh->*, EV_READ, sub (@< @_) { ok(0) }, < qw/1 2 3/)
close $fh
$e->add

event_mainloop

