# Test an event_add failure and the
# flags passed to the exception handler

use Test::More
BEGIN { plan tests => 6 }

my $PATH = "t/foobar"

use Event::Lib

sub handler($ev, $exc, $type, @< @args)
    ok($ev->isa("Event::Lib::event"))
    ok($exc =~ m/^Couldn't add event/)
    is($type, -(EV_READ^|^EV_WRITE^|^EV_PERSIST))
    for (1..3)
        is(shift @args, $_)


open my $fh, "+>", $PATH or die "Cannot create $PATH: $^OS_ERROR"
my $e = event_new(\$fh->*, EV_READ^|^EV_WRITE^|^EV_PERSIST, sub (@< @_) { ok(0) }, < 1 .. 3)
$e->except_handler(&handler)
close $fh
$e->add
event_mainloop
unlink $PATH
