package MyEvent
use Event::Lib
use base < qw/Event::Lib::signal/

my $_DESTROY = "not called"

sub new
    my $class = shift
    bless signal_new(< @_) => $class


sub DESTROY
    $_DESTROY = "called"
    shift->SUPER::DESTROY


package main
$^WARNING = 0

use Event::Lib
use POSIX < qw/SIGHUP/
use Test::More
BEGIN { plan tests => 6; }

my $pid = fork
if (not defined $pid)
    for (1..6)
        skip("couldn't fork: $^OS_ERROR", 1)
    exit


if ($pid)
    # so the child can call event_init()
    sleep 1
    kill SIGHUP => $pid
    wait
    Test::Builder->new->current_test += 2
    ok(1)
else
    event_init
    MyEvent->new(SIGHUP, sub {})->add
    is($_DESTROY, "not called")
    event_one_loop
    is($_DESTROY, "not called", "Event::Lib::signal::DESTROY erroneously called")
    exit


$_DESTROY = "not called"

$pid = fork
skip($^OS_ERROR, 2) if not defined $pid

if ($pid)
    # so the child can call event_init()
    sleep 1
    kill SIGHUP => $pid
    wait
    Test::Builder->new->current_test += 2
    ok(1)
else
    event_init
    MyEvent->new(SIGHUP, sub (@< @_) {shift->remove})->add
    is($_DESTROY, "not called")
    event_one_loop
    is($_DESTROY, "called", "Event::Lib::signal::DESTROY called too late")
    exit

