# Objective:
# ----------
#
# Make sure that
#
#   $ev->add(0) == $ev->add != $ev->add(0.0)

use Test::More
BEGIN { plan tests => 4 }
use Event::Lib
use Socket
use warnings

ok(1)

pipe my $reader, my $writer

my $pid = fork
skip($^OS_ERROR, 1), exit if not defined $pid

if ($pid)
    # PARENT
    event_new(\$reader->*, EV_READ^|^EV_PERSIST,
              sub (@< @_)
                  my (@: $ev, $type) =  @_
                  is($type, EV_READ)
                  read ($ev->fh, my $buf, 2)
                  if ($buf eq 'ok')
                      ok(1)
                  
              
              )->add(0)
    event_one_loop(10)
    event_new(\$reader->*, EV_READ^|^EV_PERSIST,
              sub (@< @_)
                  my (@: $ev, $type) =  @_
                  is($type, EV_TIMEOUT)
                  exit
              
              )->add(0.0)
    event_one_loop(10)
    wait
else
    # CHILD
    $^OUTPUT_AUTOFLUSH = 1
    sleep 1
    print $writer, "ok\n"
    exit



