# Memory leak test.
# We create and delete 100_000 events in chunks of 100.
# After each chunk we test if memory usage has grown.
# If it has, it means there was a memory leak.
# Unlike 90_leak.t, in this test each event is triggered
# and removed via an explicit del().

# XXX This test does NOT work with Test::More as
# XXX that will apparently allocate more and more
# XXX memory.

use constant HAS_GTOP => try { require GTop && GTop->VERSION +>= 0.12 } || 0
use Test::More
use Event::Lib

plan skip_all => "These tests require GTop" unless HAS_GTOP
plan tests => 1000

my $gtop = GTop->new

sub run {}

# let perl reach a stable state of memory usage
for (1..100)
    timer_new(&run)->add(0.000001)
Event::Lib::event_mainloop

my $initial = $gtop->proc_mem($^PID)->vsize
for (1 .. 1000)
    for (1..100)
        timer_new(&run)->add(0.000001)
    event_mainloop
    is($gtop->proc_mem($^PID)->vsize, $initial)

