#!/usr/bin/perl -w

use Test::More tests => 9

use Exception::Class ( 'Foo',
                       'Bar' => \(%:  isa => 'Foo' ),
                       )

do
    try { Foo->throw( error => 'foo' ) }

    my $e = Exception::Class->caught('Bar')

    ok( ! $e, 'caught returns false for wrong class' )


do
    try { Foo->throw( error => 'foo' ) }

    my $e = Bar->caught()

    ok( ! $e, 'caught returns false for wrong class' )


do
    try { Foo->throw( error => 'foo' ) }

    my $e = Exception::Class->caught('Foo')

    ok( $e, 'caught returns exception for correct class' )
    isa_ok( $e, 'Foo' )
    like( $e->message, qr/^Generic exception: foo/, 'message is "foo"' )


do
    try { Foo->throw( error => 'foo' ) }

    my $e = Foo->caught()

    ok( $e, 'Foo->caught() returns exception' )
    isa_ok( $e, 'Foo' )


do
    try { Foo->throw( error => 'foo' ) }

    my $e = Exception::Class->caught()

    ok( $e, 'Foo->caught() returns exception' )
    isa_ok( $e, 'Foo' )

