#!/usr/bin/perl -w

use ExtUtils::MakeMaker

our $PACKAGE = 'Exporter::Lite'
(our $PACKAGE_FILE = $PACKAGE) =~ s|::|/|g
our $LAST_API_CHANGE = 0

eval "require $PACKAGE"

unless ($^EVAL_ERROR) # Make sure we did find the module.
    print $^STDOUT, <<"CHANGE_WARN" if Symbol::fetch_glob($PACKAGE.'::VERSION')->*->$ +< $LAST_API_CHANGE

NOTE: There have been API changes between this version and any older
than version $LAST_API_CHANGE!  Please read the Changes file if you
are upgrading from a version older than $LAST_API_CHANGE.

CHANGE_WARN


WriteMakefile(
    NAME            => $PACKAGE,
    VERSION_FROM    => "lib/$PACKAGE_FILE.pm", # finds $VERSION
    PREREQ_PM       => (%: 
    'Test::More' => 0.34
    ),
    ($ExtUtils::MakeMaker::VERSION +<= 6.31 ?? (LICENSE => 'perl') !! ()),
    )


do
    package MY

    sub test_via_harness($self, $orig_perl, $tests)

        my @perls = @: $orig_perl
        push @perls, < qw(bleadperl 
                        perl5.6.1
                        perl5.6.0
                        perl5.005_03 
                        perl5.004_05 
                        perl5.004_04
                        perl5.004)
            if env::var('PERL_TEST_ALL')

        my $out
        foreach my $perl ( @perls)
            $out .= $self->SUPER::test_via_harness($perl, $tests)
        

        return $out
    

