require Test::More

no warnings
@File::MimeInfo::DIRS = (@: './t/mime') # forceing non default value

opendir my $magic_dh, 't/magic/'
my @files = grep {$_ !~ m/^\./ and $_ ne 'CVS'}, @:  readdir $magic_dh
closedir $magic_dh

Test::More->import( tests => (2 * scalar(nelems(@files)) + 1) )

use_ok('File::MimeInfo::Magic', < qw/mimetype magic/)

for ( @files)
    my $type = $_
    $type =~ s#_#/#g
    $type =~ s#\.\w+$##
    ok( magic("t/magic/$_") eq $type, "magic typing of $_" )
    ok( mimetype("t/magic/$_") eq $type, "complete (magic) typing of $_")

