
require Test::More

env::var('XDG_DATA_HOME' ) = './t/'
env::var('XDG_DATA_DIRS' ) = './t/' # forceing non default value

opendir my $magic_dh, 't/magic/'
my @files = grep {$_ !~ m/\./ and $_ ne 'CVS'}, @:  readdir $magic_dh
closedir $magic_dh

Test::More->import( tests => scalar(nelems(@files)) )

eval "use File::MimeInfo::Magic" # force runtime evaluation
die $^EVAL_ERROR if $^EVAL_ERROR

SKIP: do
    unless (eval 'require IO::Scalar')
        skip('no IO::Scalar found', nelems(@files))

    for ( @files)
        my $type = $_
        $type =~ s#_#/#g

        open my $fh, '<', "t/magic/$_" || die $^OS_ERROR
        my $file = join '', @:  ( ~< $fh->*)
        close $fh
        my $io = IO::Scalar->new( \$file)

        ok( mimetype($io) eq $type, "typing of $_ as io::scalar" )


__END__

# Not all platforms seem to support <:encoding(latin2) :(

unless (eval 'require IO::File') {
	ok(1, 'Skip - no IO::File found');
	exit 0;
}

my $io = new IO::File;
$io->open('t/text_plain_czech', '<:encoding(latin2)');
ok( mimetype($io) eq 'text/plain', "czech (ISO 8859-2) encoded text" );

