#!/usr/bin/perl

use Test::More tests => 35;

use Graphics::ColorNames < qw( hex2tuple tuple2hex );

my $colors = Graphics::ColorNames->new();
ok($colors);

# Test RGB values being passed through

foreach my $rgb (qw(
    000000 000001 000010 000100 001000 010000 100000
    111111 123abc abc123 123ABC ABC123 abcdef ABCDEF
  )) {
  is($colors->get( "\x[23]" . $rgb ), $rgb);
  is($colors->get( $rgb ), $rgb);
}

# Test using multiple schemes

my $colors2 = Graphics::ColorNames->new( < qw( X Netscape ) );

ok(!defined $colors->get("Silver"));  # Silver doesn't exist in X
ok(defined $colors2->get("Silver")); # It does in Netscape

# Test precedence

my $colors3 = Graphics::ColorNames->new( < qw( Netscape X ) );

ok($colors->get("Brown"),  'a52a2a'); # Brown in X
ok($colors2->get("Brown"), 'a52a2a'); # Brown in X (don't try Netscape)
ok($colors3->get("Brown"), 'a62a2a'); # Brown in Netscape (don't try X)

# Test handling of non-existent color names

ok(!defined $colors->get("NonExistentColorName"));

