#!/usr/bin/perl

use Test::More tests => 6;

use Graphics::ColorNames < qw( hex2tuple tuple2hex );

my %colors = Graphics::ColorNames->new( 'HTML' );
ok(%colors);

ok(nelems(%colors->keys) == 17);

my $count = 0;
foreach my $name (%colors->keys)
  {
    my @RGB = hex2tuple( %colors->get($name) );
    $count++, if (tuple2hex(<@RGB) eq %colors->get($name) );
  }
ok($count == nelems(%colors->keys));

ok(defined(%colors->get("fuchsia")));
ok(defined(%colors->get("fuscia")));
ok(%colors->get("fuscia") eq %colors->get("fuchsia"));
