#!/usr/bin/perl

use Test::More tests => 6;

use Graphics::ColorNames v1.06 < qw( hex2tuple tuple2hex );

my %colors = Graphics::ColorNames->new( 'Netscape' );
ok(%colors);

ok(nelems(%colors->keys) == 100); #

my $count = 0;
foreach my $name (%colors->keys)
  {
    my @RGB = hex2tuple( %colors->get($name) );
    $count++, if (tuple2hex(<@RGB) eq %colors->get($name) );
  }
ok($count == nelems(%colors->keys));

# Problem is with Netscape's color definitions

do {
  local $TODO = "Problem with Netscape color definitions";
  ok(%colors->get("gold")      ne %colors->get("mediumblue"));
  ok(%colors->get("lightblue") ne %colors->get("mediumblue"));
  ok(%colors->get("lightblue") ne %colors->get("gold"));
};
