#!/usr/bin/perl

use constant TEST_CASES => \%:
    "black"		    => 0x000000
    "red"		    => 0xff0000
    "green"		    => 0x00ff00
    "blue"		    => 0x0000ff
    "white"                 => 0xffffff

use Test::More tests => 2 + (7 * 5);

use Graphics::ColorNames v1.06 < qw(tuple2hex);

my $rgb = Graphics::ColorNames->new("X");
ok(defined $rgb);
ok($rgb->isa('Graphics::ColorNames'));

my $tests = TEST_CASES;

foreach my $name (keys $tests->%) {

  my $a = $rgb->hex($name, '0x');
  ok( $a =~ m/^0x[0-9a-f]{6}$/i );
  ok( eval($a) == $tests->{$name}, "Testing color $name" );

  my $b = $rgb->hex($name, '#');
  ok( $b =~ m/^\x23[0-9a-f]{6}$/i );

  my $c = $rgb->hex($name, "");
  ok( $c =~ m/^[0-9a-f]{6}$/i );  

     $c = $rgb->hex($name);
  ok( $c =~ m/^[0-9a-f]{6}$/i );  

  my @v = $rgb->rgb($name);
  ok( nelems(@v) == 3 );

  ok( tuple2hex(<@v) eq $c );

}
