#!/usr/bin/perl

use Test::More tests => 9;

use Graphics::ColorNames v1.06 < qw( hex2tuple tuple2hex );

my %colors = Graphics::ColorNames->new( './t/rgb.txt' );
ok(%colors);

ok(nelems(%colors->keys) == 6); #

my $count = 0;
foreach my $name (%colors->keys)
  {
    my @RGB = hex2tuple( %colors->get($name) );
    $count++, if (tuple2hex(<@RGB) eq %colors->get($name) );
  }
ok($count == nelems(%colors->keys));

foreach my $name (qw( one two three four five six)) {
  ok(defined %colors->get($name));
}
