use Test::More tests => 6

use HTML::Parser ()

my $p = HTML::Parser->new(api_version => 3)

try {
    $p->handler(end => "end", q(xyzzy));
}
like($^EVAL_ERROR->{?description}, qr/^Unrecognized identifier xyzzy in argspec/)


try {
    $p->handler(end => "end", q(tagname text));
}
like($^EVAL_ERROR->{?description}, qr/^Missing comma separator in argspec/)


try {
    $p->handler(end => "end", q(tagname, "text));
}
like($^EVAL_ERROR->{?description}, qr/^Unterminated literal string in argspec/)


try {
    $p->handler(end => "end", q(tagname, "t\\t"));
}
like($^EVAL_ERROR->{?description}, qr/^Backslash reserved for literal string in argspec/)

try {
    $p->handler(end => "end", '"' . ("x" x 256) . '"');
}
like($^EVAL_ERROR->{?description}, qr/^Literal string is longer than 255 chars in argspec/)

$p->handler(end => sub (@< @_) { is(length(shift), 255) },
    '"' . ("x" x 255) . '"')
$p->parse("</x>")


