#!perl -w


use utf8

use Test::More tests => 9

use HTML::Entities < qw(_decode_entities)

try {
    _decode_entities("&lt;", undef);
}
like($^EVAL_ERROR->{?description}, qr/^Can't inline decode readonly string/)

try {
    my $a = "";
    _decode_entities($a, $a);
}
like($^EVAL_ERROR->{?description}, qr/^2nd argument must be hash reference/)

try {
    my $a = "";
    _decode_entities($a, \$@);
}
like($^EVAL_ERROR->{?description}, qr/^2nd argument must be hash reference/)

$a = "&lt;"
_decode_entities($a, undef)
is($a, "&lt;")

_decode_entities($a, \(%:  "lt" => "<" ))
is($a, "<")

my $x = "x" x 20

my $err
for ((@: ":", ":a", "a:", "a:a", "a:a:a", "a:::a"))
    my $a = $_
    $a =~ s/:/&a;/g
    my $b = $_
    $b =~ s/:/$x/g
    _decode_entities($a, \(%:  "a" => $x ))
    if ($a ne $b)
        diag "Something went wrong with '$_'"
        $err++
    

ok(!$err)

$a = "foo&nbsp;bar"
_decode_entities($a, \%HTML::Entities::entity2char)
is($a, "foo\x{A0}bar")

$a = "foo&nbspbar"
_decode_entities($a, \%HTML::Entities::entity2char)
is($a, "foo&nbspbar")

_decode_entities($a, \%HTML::Entities::entity2char, 1)
is($a, "foo\x{A0}bar")
