use Test::More tests => 3

my $HTML = <<EOT

<!DOCTYPE HTML>
<!-- comment
<h1>Foo</h1>
-->

<H1
>Bar</H1
>

<Table><tr><td>1<td>2<td>3
<tr>
</table>

<?process>

EOT

use HTML::Filter

my $tmpfile = "test-$^PID.htm"
die "$tmpfile already exists" if -e $tmpfile

open(my $html, ">", "$tmpfile") or die "$^OS_ERROR"

do
    local $^STDOUT = undef
    open $^STDOUT, ">&", $html or die "Failed open: $^OS_ERROR"
    HTML::Filter->new->parse($HTML)->eof

close($html)

open($html, "<", $tmpfile) or die "$^OS_ERROR"
local($^INPUT_RECORD_SEPARATOR) = undef
my $FILTERED = ~< $html->*
close($html)

#print $FILTERED;
is($FILTERED, $HTML)

do
    package MyFilter
    our @ISA=qw(HTML::Filter)
    sub comment {}
    sub output { push(@_[0]->{+fhtml}, @_[1]) }
    sub filtered_html { join("", @_[0]->{?fhtml}) }


my $f2 = MyFilter->new->parse_file($tmpfile)->filtered_html
unlink($tmpfile) or warn "Can't unlink $tmpfile: $^OS_ERROR"

#diag $f2;

unlike($f2, qr/Foo/)
like($f2, qr/Bar/)


