# This test that HTML::LinkExtor really absolutize links correctly
# when a base URL is given to the constructor.

use Test::More tests => 5
require HTML::LinkExtor

SKIP: do
    try {
        require URI;
    }
    skip $^EVAL_ERROR, 5 if $^EVAL_ERROR

    # Try with base URL and the $p->links interface.
    my $p = HTML::LinkExtor->new(undef, "http://www.sn.no/foo/foo.html")
    $p->parse(<<HTML)->eof
<head>
<base href="http://www.sn.no/">
</head>
<body background="http://www.sn.no/sn.gif">

This is <A HREF="link.html">link</a> and an <img SRC="img.jpg"
lowsrc="img.gif" alt="Image">.
HTML

    my @p = $p->links

    # There should be 4 links in the document
    is(nelems(@p), 4)

    my ($t, %attr)
    for ( @p)
        (@: $t, %< %attr) =  $_->@ if $_->[0] eq 'img'
    

    is($t, 'img')

    is(delete(%attr{src})->as_string, "http://www.sn.no/foo/img.jpg")

    is(delete(%attr{lowsrc})->as_string, "http://www.sn.no/foo/img.gif")

    ok(!(%attr)) # there should be no more attributes

