use Test::More tests => 4

my $filename = "file$^PID.htm"
die "$filename is already there" if -e $filename
open(my $fh, ">", "$filename") || die "Can't create $filename: $^OS_ERROR"
print $fh, <<'EOT'; close($fh)
<title>Heisan</title>
EOT

do
    package MyParser
    require HTML::Parser
    our @ISA=qw(HTML::Parser)

    sub start($self, $tag, $attr, ...)
        Test::More::is($tag, "title")
    


MyParser->new->parse_file($filename)
open($fh, "<", $filename) || die
MyParser->new->parse_file(\$fh->*)
close($fh)

require IO::File
my $io = IO::File->new($filename) || die
MyParser->new->parse_file($io)

my $text = ''
$io->seek(0, 0) || die
MyParser->new(
    start_h => \(@:  sub (@< @_){ shift->eof; }, "self" ),
    text_h =>  \(@:  sub (@< @_){ $text = shift; }, "text" ))->parse_file(\$io->*)
ok(!$text)

close($io)  # needed because of bug in perl
undef($io)

unlink($filename) or warn "Can't unlink $filename: $^OS_ERROR"
