#!perl -w


use Test::More tests => 2
use HTML::Parser
use bytes
require utf8

my @parsed
my $p = HTML::Parser->new(
    api_version => 3,
    start_h => \(@: \@parsed, 'tag, attr'),
    )

my @warn
$^WARN_HOOK = sub (@< @_)
    push(@warn, @_[0]->{?description} . "\n")


$p->parse("\x[EFBBBF]<head>Hi there</head>")
$p->eof

#use Encode;
$p->parse("\x[EFBBBF]<head>Hi there</head>" . utf8::chr(0x263A))
$p->eof

$p->parse("\x[FFFE]<head>Hi there</head>")
$p->eof

$p->parse("\x[FEFF]<head>Hi there</head>")
$p->eof

$p->parse("\0\0\x[FFFE]<head>Hi there</head>")
$p->eof

$p->parse("\x[FEFF]\0\0<head>Hi there</head>")
$p->eof

is(join("", @warn), <<EOT)
Parsing of undecoded UTF-16
Parsing of undecoded UTF-16
Parsing of undecoded UTF-32
Parsing of undecoded UTF-32
EOT

@warn = $@

$p = HTML::Parser->new(
    api_version => 3,
    start_h => \(@: \@parsed, 'tag'),
    )

$p->parse("\x[EF]\x[BB]\x[BF]<head>Hi there</head>")
$p->eof
ok(!nelems(@warn))
