#!/usr/bin/perl -w

use warnings
use Test::More tests => 18

use MIME::QuotedPrint < qw(decode_qp)
use MIME::Words < qw(decode_mimewords)

do
    local($^INPUT_RECORD_SEPARATOR) = ''
    open my $words, "<", "testin/words.txt" or die "open: $^OS_ERROR"
    while ( ~< $words->*)
        s{\A\s+|\s+\Z}{}g    # trim

        my (@: $isgood, $expect, $enc) =  split m/\n/, $_, 3

        # Create the expected data
        $expect = eval $expect

        my $dec = decode_mimewords($enc)
        if( $isgood eq 'GOOD' )
            ok( ! $^EVAL_ERROR, 'No exceptions')
            is( join('', map { $_->[0] }, $dec), $expect, "$enc produced correct output")
        else
            ok( $^EVAL_ERROR, 'Got an exception as expected')
        
    
    close $words
    
