#!/usr/bin/perl


use warnings

use lib '../lib'

my $fil = "version.h"
my $ver

foreach ( @ARGV)
    my (@: $opt, $arg) =split(m/=/, $_, 2)
    if ($opt eq '--with-version')
        if ($arg =~ m/^(\d)\.(\d\d\d)_?(\d\d\d)/)
            $ver = join(".", (@:  $1*1, $2*1, $3*1))
        else
            $ver = $arg
        
    


print $^STDOUT, "version.h.pl: creating $fil\n"
unless ($ver)
    if (-e '../lib/Mail/SpamAssassin.pm')
        try {
            require Mail::SpamAssassin;
            $ver = Mail::SpamAssassin::Version();
        }
    else
        $^EVAL_ERROR = "File not found."
    
    unless ($ver)
        die join("\n", @:  "Failed to get the version from Mail::SpamAssassin."
                           "Please use the --with-version= switch to specify it manually."
                           ""
                           "The error was:"
                           $^EVAL_ERROR->message, $^EVAL_ERROR->stacktrace
            )
    


open my $in,  "<", "$fil.in" || die "Failed to open $fil.in: $^OS_ERROR"
open my $out, ">", "$fil"    || die "Failed to open $fil: $^OS_ERROR"

print $out, "/* $fil.  Generated by $^PROGRAM_NAME.  */\n"
foreach ((@:  ~< $in->*))
    s/(#define\s+VERSION_STRING\s+)".*"/$1"$ver"/
    print $out, $_


close $in
close $out

