#!/usr/bin/perl

my %opts
my @args
do
    my $opts = 1
    foreach ( @ARGV)
        if ($opts)
            $opts     =  0 if m/^--$/
            %opts{+$1} = $2 if m/^-([a-zA-Z])(.+)$/
        else
            push (@args, $_)
        
    


my $mode = %opts{?'M'}
if ($mode eq 'redirect')
    my $stdout = %opts{?'o'}   || die "No -o"
    my $stderr = %opts{?'O'}   || die "No -O"
    open ($^STDOUT, ">", "$stdout") || die "Could not redirect STDOUT to $stdout: $^OS_ERROR"
    open ($^STDERR, ">", "$stderr") || die "Could not redirect STDERR to $stderr: $^OS_ERROR"

    iohandle::output_autoflush($^STDERR, 1)
    iohandle::output_autoflush($^STDOUT, 1)

    exec < @args
    die "Could not exec " . join(' ', @args) . ": $^OS_ERROR"
else
    die "Unknown mode: $mode\n"

