#!/usr/bin/perl

BEGIN
    if (-e 't/test_dir') # if we are running "t/rule_tests.t", kluge around ...
        chdir 't'

    if (-e 'test_dir')            # running from test directory, not ..
        unshift($^INCLUDE_PATH, '../blib/lib')
        unshift($^INCLUDE_PATH, '../lib')


my $prefix = '.'
if (-e 'test_dir')            # running from test directory, not ..
    $prefix = '..'


use lib '.'
use lib 't'
use SATest sa_t_init("basic_obj_api")
use Test::More
BEGIN { plan tests => 4 }

# ---------------------------------------------------------------------------

require Mail::SpamAssassin

my $sa = create_saobj(\(%: 'dont_copy_prefs' => 1))
$sa->init(0) # parse rules
ok($sa)

my $in
open ($in, "<", "data/spam/009")
my $mail = $sa->parse(\$in->*)
close $in

my $status = $sa->check($mail)
my $rewritten = $status->rewrite_mail()
my $msg = $status->{?msg}

ok $rewritten =~ m/message\/rfc822; x-spam-type=original/
ok $rewritten =~ m/X-Spam-Flag: YES/

$mail->finish()
$status->finish()
ok 1
