#!/usr/bin/perl

# detect use of dollar-ampersand somewhere in the perl interpreter;
# once it is used once, it slows down every regexp match thereafter.

BEGIN 
    if (-e 't/test_dir') # if we are running "t/rule_tests.t", kluge around ...
        chdir 't'
    

    if (-e 'test_dir')            # running from test directory, not ..
        unshift($^INCLUDE_PATH, '../blib/lib')
        unshift($^INCLUDE_PATH, '../lib')
    


my $prefix = '.'
if (-e 'test_dir')            # running from test directory, not ..
    $prefix = '..'


use lib '.'
use lib 't'
use SATest sa_t_init("check_implemented")
use Test::More

BEGIN 
    plan tests => 2
;

# ---------------------------------------------------------------------------

require Mail::SpamAssassin

# kill all 'loadplugin' lines
foreach my $file
    (@: < glob("log/localrules.tmp/*.pre"), < glob("log/test_rules_copy/*.pre"))
    rename $file, "$file.bak" or die "rename $file failed"
    open my $in, "<", "$file.bak" or die "cannot read $file.bak"
    open my $out, ">", "$file" or die "cannot write $file"
    while ( ~< $in->*)
        s/^loadplugin/###loadplugin/g
        print $out, $_
    
    close $in
    close $out


my $sa = create_saobj(\(%: 
                      'dont_copy_prefs' => 1
                      'local_tests_only' => 1
                      ))

$sa->init(1)
ok($sa)

open (my $in, "<", "data/spam/009")
my $mail = $sa->parse(\$in->*)
close $in

try {
    my $status = $sa->check($mail);
    ok 0;       # should never get this far
}
like($^EVAL_ERROR->message, qr/no loaded plugin implements/)

