#!/usr/bin/perl -w

BEGIN 
    if (-e 't/test_dir') # if we are running "t/rule_tests.t", kluge around ...
        chdir 't'
    

    if (-e 'test_dir')            # running from test directory, not ..
        unshift($^INCLUDE_PATH, '../blib/lib')
    


my $prefix = '.'
if (-e 'test_dir')            # running from test directory, not ..
    $prefix = '..'


use Test::More
use Mail::SpamAssassin
use Mail::SpamAssassin::HTML

plan tests => 24

sub try_html($data, $want)

    my $rgb = Mail::SpamAssassin::HTML::name_to_rgb($data)
    if ($want ne $rgb)
        print $^STDOUT, "color mismatch: $data -> $rgb but wanted $want\n"
        return 0
    
    return 1


# normal colors with various whitespace
ok(try_html('black', '#000000'))
ok(try_html('white', '#ffffff'))
ok(try_html('peachpuff', '#ffdab9'))
ok(try_html('#abcdef', '#abcdef'))
ok(try_html('123456', '#123456'))

# Flex Hex
ok(try_html('black ', '#b0ac00'))
ok(try_html(' white ', '#000000'))
ok(try_html(' peachpuff', '#00c0ff'))
ok(try_html('#peachpuff', '#0ec00f'))
ok(try_html('#0f0', '#000f00'))
ok(try_html('0f0f', '#0f0f00'))
ok(try_html('#1234567890abcde1234567890abcde', '#34cd89'))
ok(try_html('6db6ec49efd278cd0bc92d1e5e072d68', '#6ecde0'))
ok(try_html('#f', '#0f0000'))
ok(try_html('zft', '#000f00'))
ok(try_html('#zftygn', '#0f0000'))
ok(try_html('zqbttv', '#00b000'))
ok(try_html('fffffff', '#fffff0'))
ok(try_html('fffff39', '#ffff90'))
ok(try_html('fffffg', '#fffff0'))
ok(try_html('fffff', '#fffff0'))
ok(try_html('fxfefu', '#f0fef0'))
ok(try_html('fafufb', '#faf0fb'))
ok(try_html('fofcff', '#f0fcff'))
