#!/usr/bin/perl

use lib '.'
use lib 't'
use SATest sa_t_init("spamc_cf")
use Test::More tests => (our $SKIP_SPAMC_TESTS ?? 0 !! 4)

exit if our $SKIP_SPAMC_TESTS

# ---------------------------------------------------------------------------

our %patterns = %: 

    q{ Subject: There yours for FREE!}, 'subj'
    q{ X-Spam-Status: Yes, score=}, 'status'
    q{ X-Spam-Flag: YES}, 'flag'


    

my $sockpath = mk_safe_tmpdir()."/spamd.sock"
start_spamd("-D -L --socketpath=$sockpath")

open (my $out_fh, ">", "log/spamc_cf.cf")
print $out_fh, "-U $sockpath\n"
close $out_fh

ok (spamcrun ("-F log/spamc_cf.cf < data/spam/001", &patterns_run_cb))
ok_all_patterns()
stop_spamd()
cleanup_safe_tmpdir()

