#!/usr/bin/perl

use lib '.'
use lib 't'
use SATest sa_t_init("spamc_optC")

use Test::More tests => our $SKIP_SPAMC_TESTS ?? 0 !! 9

exit if our $SKIP_SPAMC_TESTS

# ---------------------------------------------------------------------------

tstlocalrules ("
	loadplugin reporterplugin ../../data/reporterplugin.pm
")

start_spamd("-L --allow-tell")

our %patterns = %:  'Message successfully reported/revoked' => 'reported spam' 

ok (spamcrun ("-C report < data/spam/001", &patterns_run_cb))
ok_all_patterns()

%patterns = %:  'Message successfully reported/revoked' => 'revoked ham' 

ok (spamcrun ("-C revoke < data/nice/001", &patterns_run_cb))
ok_all_patterns()

my $out_fh
open ($out_fh, ">", "log/rptfail")
print $out_fh, "file created to trigger a reporterplugin failure"
close $out_fh

%patterns = %:  'Unable to report/revoke message' => 'failed to report spam' 

ok (spamcrun ("-C report < data/spam/001", &patterns_run_cb))
ok_all_patterns()

%patterns = %:  'Unable to report/revoke message' => 'failed to revoke ham' 

ok (spamcrun ("-C revoke < data/nice/001", &patterns_run_cb))
ok_all_patterns()

stop_spamd()

ok(unlink 'log/rptfail') # need a little cleanup
