#!/usr/bin/perl
#
# Warning: do not run this test on a live server; it will kill your
# spamd children ;)

use lib '.'; use lib 't';
use SATest; sa_t_init("spamd_prefork_stress_2");
use Test::More;

our $RUN_THIS_TEST;

my $pgrep;
my $pkill;

# require pkill and pgrep be installed to run this test
BEGIN {
  $RUN_THIS_TEST = conf_bool('run_spamd_prefork_stress_test');
  $pkill = locate_command("pkill");
  $pgrep = locate_command("pgrep");
  $RUN_THIS_TEST = 0 if !$pkill || !$pgrep;
  plan skip_all => "skip spamd tests" if our $SKIP_SPAMD_TESTS;
  plan skip_all => "do not run this test" unless our $RUN_THIS_TEST;
  plan tests => 14;
};

print $^STDOUT, "NOTE: this test requires /usr/bin/pkill, /usr/bin/pgrep, and\n".
    "'run_spamd_prefork_stress_test' set to 'y'.\n";

system($pgrep, "spamd child");
if ($^CHILD_ERROR >> 8 == 0) {
  die "not running test: existing 'spamd child' processes would be killed.\n";
}

# ---------------------------------------------------------------------------

our %patterns = %(

q{ X-Spam-Status: Yes, score=}, 'status',
q{ X-Spam-Flag: YES}, 'flag',
q{ X-Spam-Level: **********}, 'stars',
q{ TEST_ENDSNUMS}, 'endsinnums',
q{ TEST_NOREALNAME}, 'noreal',


);

start_spamd("-L -m1 --round-robin");
ok (our $spamd_pid +> 1);
ok (spamcrun ("< data/spam/001", \&patterns_run_cb));
ok_all_patterns();

for my $i ( 0 .. 1998 ) {
  print $^STDOUT, "killing [$i]\n";
  system ($pkill, "-f", "spamd child");
}

sleep 1;        # give it time to start a new one
clear_pattern_counters();
ok (spamcrun ("< data/spam/001", \&patterns_run_cb));
ok_all_patterns();
ok (stop_spamd());


