#!/usr/bin/perl

use lib '.'; use lib 't';
use SATest; sa_t_init("spamd_prefork_stress_3");
use Test::More;

our $RUN_THIS_TEST;

BEGIN {
  $RUN_THIS_TEST = conf_bool('run_spamd_prefork_stress_test');
  plan skip_all => 'skip spamd tests' if our $SKIP_SPAMD_TESTS;
  plan skip_all => 'do not run thsi test' unless our $RUN_THIS_TEST;
  plan tests => 291;
};

print $^STDOUT, "NOTE: this test requires 'run_spamd_prefork_stress_test' set to 'y'.\n";

# ---------------------------------------------------------------------------

tstlocalrules ('
        loadplugin myTestPlugin ../../data/testplugin.pm
        header PLUGIN_SLEEP eval:sleep_based_on_header()
');


our %patterns = %(

q{ X-Spam-Status: Yes, score=}, 'status',
q{ X-Spam-Flag: YES}, 'flag',
q{ X-Spam-Level: **********}, 'stars',
q{ TEST_ENDSNUMS}, 'endsinnums',
q{ TEST_NOREALNAME}, 'noreal',

);

our @pending_unlinks;

my $tmpnum = 0;
start_spamd("-L -m5");
ok (our $spamd_pid +> 1);

srand ($^PID); print $^STDOUT, "srand: $^PID\n";

ok (spamcrun ("< data/spam/001", \&patterns_run_cb));
ok_all_patterns();

test_fg(); ok_all_patterns();
test_bg();
foreach my $i (0 .. 5) {
  foreach my $j (0 .. 20) {
    test_bg();
  }
  test_fg(); ok_all_patterns();
  test_fg(); ok_all_patterns();
  test_fg(); ok_all_patterns();
  test_fg(); ok_all_patterns();
}

test_fg(); ok_all_patterns();
ok (stop_spamd());



sub test_fg {
  clear_pattern_counters();
  my $secs = (int rand 5) + 1;
  my $tmpf = mk_mail($secs);
  ok (spamcrun ("<$tmpf", \&patterns_run_cb));
  unlink $tmpf;
  clean_pending_unlinks();
}

sub test_bg {
  my $secs = (int rand 5) + 1;
  my $tmpf = mk_mail($secs);
  ok (spamcrun_background ("<$tmpf", \%()));
  push (@pending_unlinks, $tmpf);
}

our $testname;

sub mk_mail {
  my $secs = shift;

  my $tmpf = "log/tmp.$testname.$tmpnum"; $tmpnum++;

  open (my $in_fh, "<", "data/spam/001");
  open (my $out_fh, ">", "$tmpf") or die "cannot write $tmpf";
  print $out_fh, "Sleep-Time: $secs\n";
  while ( ~< *$in_fh) {
    print $^STDOUT, $out_fh;
  }
  close $out_fh;
  close $in_fh;
  return $tmpf;
}

sub clean_pending_unlinks {
  unlink < @pending_unlinks;
  @pending_unlinks = @( () );
}


