#!/usr/bin/perl

use lib '.'
use lib 't'
use SATest sa_t_init("spamd_protocol_10")
use Test::More
plan tests => (our $SKIP_SPAMD_TESTS ?? 0 !! 10)

exit if our $SKIP_SPAMD_TESTS

use File::Path
use IO::Socket::INET

# ---------------------------------------------------------------------------

our $spamdport
our $socket

our %patterns = %: 

    q{ SPAMD/1.1 0 EX_OK }, 'response-11'
    q{ Spam: True ; }, 'spamheader'	# we use a regexp later for the rest
    q{ GTUBE }, 'gtube'

    


start_spamd("-L")

my $data = ""
open (my $gtube, "<", "data/spam/gtube.eml") || die $^OS_ERROR
foreach (@: ~< $gtube->*)
    s/\r?\n?$/\n/
    print $^STDOUT, "GTUBE: $_"
    $data .= $_

close ($gtube)

my $out

for my $p (0..1)
    $out = run_symbols ($data, $p)
    ok (defined ($out))

    if ($out =~ m/Spam: True \; ([\d\.]+) \/ 5\.0/)
        # the exact count could be just over or under 1000. compute!
        ok ($1 +>= 980 && $1 +< 1020)
    

    patterns_run_cb ($out)
    ok_all_patterns()
    clear_pattern_counters()


stop_spamd()
exit

sub run_symbols($data, $proto10)

    $socket = IO::Socket::INET->new(
        PeerAddr => '127.0.0.1',
        PeerPort => $spamdport,
        Proto    => "tcp",
        Type     => SOCK_STREAM
        )
    unless ($socket)
        warn("FAILED - Couldn't Connect to SpamCheck Host\n")
        return undef
    

    if ($proto10)
        sockwrite ("SYMBOLS SPAMC/1.0\r\n")
    else
        sockwrite ("SYMBOLS SPAMC/1.2\r\n")
        sockwrite ("Content-Length: " . length($data) . "\r\n")
        sockwrite ("\r\n")
    
    sockwrite ($data)

    shutdown($socket, 1)

    $data = ""
    while ( ~< $socket)
        s/\r?\n?$/\n/
        print $^STDOUT, "READ:  $_"
        $data .= $_
    

    $socket = undef

    return $data


sub sockwrite
    my $data = shift
    print $socket, $data
    $data =~ s/^/WRITE: /mg
    print $^STDOUT, $data


