#!/usr/bin/perl

use lib '.'
use lib 't'
use SATest sa_t_init("spamd_ssl")
use Test::More
plan skip_all => 'skip spamd tests' if our $SKIP_SPAMD_TESTS
plan skip_all => 'no ssl available' unless our $SSL_AVAILABLE
plan tests => 9
info "\n\nNote: This may not be a SpamAssassin bug, as some platforms require that you" .
     "\nspecify a protocol in spamc --ssl option, and possibly in spamd --ssl-version.\n\n"

# ---------------------------------------------------------------------------

our %patterns = %: 

    q{ Return-Path: sb55sb55@yahoo.com}, 'firstline'
    q{ Subject: There yours for FREE!}, 'subj'
    q{ X-Spam-Status: Yes, score=}, 'status'
    q{ X-Spam-Flag: YES}, 'flag'
    q{ X-Spam-Level: **********}, 'stars'
    q{ TEST_ENDSNUMS}, 'endsinnums'
    q{ TEST_NOREALNAME}, 'noreal'
    q{ This must be the very last line}, 'lastline'


    

ok (sdrun ("-L --ssl --server-key data/etc/testhost.key --server-cert data/etc/testhost.cert",
           "--ssl < data/spam/001",
           &patterns_run_cb))
ok_all_patterns()
