# This -*- perl -*- script makes the Makefile
# $Id: //depot/MailTools/Makefile.PL#11 $

#--- Distribution section ---

my $NAME     = 'Mail'
my $DISTNAME = "MailTools"
my $VERSION  = "1.77"

BEGIN {  }

use ExtUtils::MakeMaker
use ExtUtils::Manifest < qw(maniread)

#--- Installation check

sub chk_version($pkg,$wanted,?$msg)

    $^OUTPUT_AUTOFLUSH = 1
    print $^STDOUT, "Checking for $pkg..."

    try { my $p; ($p = $pkg . ".pm") =~ s#::#/#g; require $p; }

    my $vstr = Symbol::fetch_glob("$($pkg)::VERSION")->*->$ ?? "found v" . Symbol::fetch_glob("$($pkg)::VERSION")->*->$
        !! "not found"
    my $vnum = Symbol::fetch_glob("$($pkg)::VERSION")->*->$ || 0

    print $^STDOUT, $vnum +>= $wanted ?? "ok\n" !! " " . $vstr . "\n"

    $vnum +>= $wanted


#--- Check for Socket

chk_version('Net::SMTP' => 1.03) or
    warn  "\n"
    . "It is reccomended that you have Net::SMTP version 1.03 or later\n"
    . "Look on CPAN for CPAN/modules/by-author/id/GBARR/libnet-x.x.tar.gz\n\n"

chk_version('Net::Domain' => 1.05) or
    warn  "\n"
    . "It is reccomended that you have Net::Domain version 1.05 or later\n"
    . "Look on CPAN for CPAN/modules/by-author/id/GBARR/libnet-x.x.tar.gz\n\n"

chk_version('IO::Handle' => 0.00) or
    warn  "\n"
    . "To be able to use Mail::Mailer and Mail::Send you will need to\n"
    . "install the IO distribution.\n"
    . "Look on CPAN for CPAN/modules/by-author/id/GBARR/IO-x.x.tar.gz\n\n"

#--- Write the Makefile

WriteMakefile(
    VERSION   => $VERSION,
    DISTNAME  => $DISTNAME,
    NAME      => $NAME,
    AUTHOR    => 'Mark Overmeer <mailtools@overmeer.net>',
    ABSTRACT  => 'Various Mail related modules',
    )

sub MY::postamble

    <<'ESQ'

dist : ppd

ESQ


