require Mail::Header

print $^STDOUT, "1..25\n"

my $h = Mail::Header->new()

my $t = 0

$h->header_hashref(\(%: hhrtest1 => 1
                        hhrtest2 => \(@: 1, "this test line was written by TobiX\n")))
$h->add(Date => "a test header")
$h->add(Date => "a longer test header")
$h->add(Date => "an even longer test header")

$h->print
my $str = $h->get(Date => 0)
print $^STDOUT, "#$str#\nnot "
    unless $str eq "a test header\n"
printf $^STDOUT, "ok \%d\n",++$t

$str = $h->get(Date => 1)
print $^STDOUT, "#$str#\nnot "
    unless $str eq "a longer test header\n"
printf $^STDOUT, "ok \%d\n",++$t

$str = $h->get(Date => 2)
print $^STDOUT, "#$str#\nnot "
    unless $str eq "an even longer test header\n"
printf $^STDOUT, "ok \%d\n",++$t

$str = $h->get('hhrtest2',1)
print $^STDOUT, "#$str#\nnot "
    unless $str eq "this test line was written by TobiX\n"
printf $^STDOUT, "ok \%d\n",++$t

my $href=$h->header_hashref()

print $^STDOUT, "not "
    unless $href->{Date}->[0] eq "a test header\n"
printf $^STDOUT, "ok \%d\n",++$t

print $^STDOUT, "not "
    unless $href->{Hhrtest2}->[0]
printf $^STDOUT, "ok \%d\n",++$t

print $^STDOUT, "not "
    unless $href->{Hhrtest1}->[0]
printf $^STDOUT, "ok \%d\n",++$t

$h->fold(30)

print $^STDOUT, "not "
    unless $h->get(Date => 0) eq "a test header\n"
printf $^STDOUT, "ok \%d\n",++$t

print $^STDOUT, "not "
    unless $h->get(Date => 1) eq "a longer test header\n"
printf $^STDOUT, "ok \%d\n",++$t

print $^STDOUT, "not "
    unless $h->get(Date => 2) eq "an even longer test\n header\n"
printf $^STDOUT, "ok \%d\n",++$t

$h->fold(20)

print $^STDOUT, "not "
    unless $h->get(Date => 0) eq "a test header\n"
printf $^STDOUT, "ok \%d\n",++$t

print $^STDOUT, "not "
    unless $h->get(Date => 1) eq "a longer\n test header\n"
printf $^STDOUT, "ok \%d\n",++$t

print $^STDOUT, "not "
    unless $h->get(Date => 2) eq "an even\n longer test\n header\n"
printf $^STDOUT, "ok \%d\n",++$t

$h->fold(30)

print $^STDOUT, "not "
    unless $h->get(Date => 0) eq "a test header\n"
printf $^STDOUT, "ok \%d\n",++$t

print $^STDOUT, "not "
    unless $h->get(Date => 1) eq "a longer test header\n"
printf $^STDOUT, "ok \%d\n",++$t

print $^STDOUT, "not "
    unless $h->get(Date => 2) eq "an even longer test\n header\n"
printf $^STDOUT, "ok \%d\n",++$t

$h->unfold

print $^STDOUT, "not "
    unless $h->get(Date => 0) eq "a test header\n"
printf $^STDOUT, "ok \%d\n",++$t

print $^STDOUT, "not "
    unless $h->get(Date => 1) eq "a longer test header\n"
printf $^STDOUT, "ok \%d\n",++$t

print $^STDOUT, "not "
    unless $h->get(Date => 2) eq "an even longer test header\n"
printf $^STDOUT, "ok \%d\n",++$t

my $head = <<EOF
From from_
To: to
From: from
Subject:subject
EOF
my $body = "body\n"
my $mail = "$head\n$body"
my @mail = map { "$_\n" }, split m/\n/, $mail

print $^STDOUT, "not "
    unless $h = Mail::Header->new( \@mail, Modify => 0)
printf $^STDOUT, "ok \%d\n",++$t

print $^STDOUT, "not "
    unless $h->as_string eq $head
printf $^STDOUT, "ok \%d\n",++$t

print $^STDOUT, "not "
    unless $h->get('Subject', 0) eq "subject\n"
printf $^STDOUT, "ok \%d\n",++$t

print $^STDOUT, "not "
    unless $h->get('To', 0) eq "to\n"
printf $^STDOUT, "ok \%d\n",++$t

my $headin = <<EOF
Content-Type: multipart/mixed;
       boundary="---- =_NextPart_000_01BDBF1F.DA8F77EE"
Content-Type: multipart/mixed;
       boundary="---- =_NextPart_000_01BDBF1F.DA8F77EE"hkjhgkfhgfhgf"hfkjdhf fhjf fghjghf fdshjfhdsj" hgjhgfjk
Content-Type: multipart/mixed;
       boundary="---- =_NextPart_000_01BDBF1F.DA8F77EE"hkjhg kfhgfhgf"hfkjdhf fhjf fghjghf fdshjfhdsj" hgjhgfjk
Content-Type: multipart/mixed;
       boundary="---- =_NextPart_000_01BDBF1F.DA8F77EE"hhhhhhhhhhhhhhhhhhhhhhhhh fjsdhfkjsd fhdjsfhkj
Content-Type: multipart/mixed;
       boundary="---- =_NextPart_000_01BDBF1F.DA8F77EE" abc def ghfdgfdsgj fdshfgfsdgfdsg hfsdgjfsdg fgsfgjsg
mime-type: text/plain
test1: _abc _def _ghi _fdjhfd _fhdjkfh _dkhkjd _fdjkf _dshfdks _fhdjfdkhfk _dshfds _fdsjk _fdkhfdks _fdsjf _dkf
test1: _abc _def _ghi _fdjhfd _fhdjkfh _dkhaaaaaaaaaaakjdfdjkfdshfdksfhdjfdkhfkdshfdsfdsjkfdkhfdksfdsjf _dkf
EOF
my $headout = <<EOF
Content-Type: multipart/mixed;
 boundary="---- =_NextPart_000_01BDBF1F.DA8F77EE"
Content-Type: multipart/mixed;
 boundary="---- =_NextPart_000_01BDBF1F.DA8F77EE"hkjhgkfhgfhgf"hfkjdhf fhjf fghjghf fdshjfhdsj" hgjhgfjk
Content-Type: multipart/mixed;
 boundary="---- =_NextPart_000_01BDBF1F.DA8F77EE"hkjhg
 kfhgfhgf"hfkjdhf fhjf fghjghf fdshjfhdsj" hgjhgfjk
Content-Type: multipart/mixed;
 boundary="---- =_NextPart_000_01BDBF1F.DA8F77EE"hhhhhhhhhhhhhhhhhhhhhhhhh
 fjsdhfkjsd fhdjsfhkj
Content-Type: multipart/mixed;
 boundary="---- =_NextPart_000_01BDBF1F.DA8F77EE" abc
 def ghfdgfdsgj fdshfgfsdgfdsg hfsdgjfsdg fgsfgjsg
MIME-Type: text/plain
Test1: _abc _def _ghi _fdjhfd _fhdjkfh _dkhkjd _fdjkf _dshfdks _fhdjfdkhfk
 _dshfds _fdsjk _fdkhfdks _fdsjf _dkf
Test1: _abc _def _ghi _fdjhfd _fhdjkfh _dkhaaaaaaaaaaakjdfdjkfdshfdksfhdjfdkhfkdshfdsfdsjkfdkhfdksfdsjf
 _dkf
EOF
@mail = map { "$_\n" }, split m/\n/, $headin

print $^STDOUT, "not "
    unless $h = Mail::Header->new( \@mail, Modify => 1)
printf $^STDOUT, "ok \%d\n",++$t

print $^STDOUT, < $h->as_string,"\n----\n",$headout,"\nnot "
    unless $h->as_string eq $headout
printf $^STDOUT, "ok \%d\n",++$t
