#!perl -w

require Mail::Internet
use Config

use Test::More 'no_plan'

env::var('LOGNAME' ) = env::var('LOGNAME') || 'unknown'

my $head = <<EOF
From from_\@localhost
To: Some perl administrator <$(config_value('perladmin'))>
From: Somebody <$(env::var('LOGNAME'))\@localhost>
Subject: Mail::Internet test subject
EOF

my $body = <<EOF
This is a test message that was sent by the test suite of
Mail::Internet.

Testing.

one

From foo
four

>From bar
seven
EOF

my $mail = "$head\n$body"
(my $mbox = $mail) =~ s/^(>*)From /$1>From /gm
$mbox =~ s/^>From /From / or die
$mbox .= "\n"
my @mail = map { "$_\n" }, split m/\n/, $mail

ok(my $i = Mail::Internet->new( \@mail, Modify => 0))
ok $i->as_string eq $mail
is $i->as_mbox_string, $mbox
#ok 4, $i->send;




