#!/usr/local/bin/perl -w

require Mail::Cap

print $^STDOUT, "1..5\n"

# First we create a mailcap file to test
my $mcfile = "mailcap-$^PID"

open(my $mailcap, ">", "$mcfile") || die "Can't create $mcfile: $^OS_ERROR"

print $mailcap, <<EOT

# This is a comment and should be ignored

image/*; xv \%s \\; echo "Showing image \%s"; description=Simple image format

text/plain; cat \%s;\\
  test=$^EXECUTABLE_NAME -e "exit (!(q\{\%\{charset\}\} =~ m/^iso-8859-1\$/i))";\\
  copiousoutput

text/plain; smartcat \%s; copiousoutput

local;cat \%s;print=lpr \%\{foo\} \%\{bar\} \%t \%s

EOT
close($mailcap)

# OK, lets parse it
my $mc = Mail::Cap->new( $mcfile)
unlink($mcfile)  # no more need for this file

my $desc = $mc->description('image/gif')

print $^STDOUT, "GIF desc: $desc\n"
print $^STDOUT, "ok 1\n" if $desc eq "Simple image format"

my $cmd1 = $mc->viewCmd('text/plain; charset=iso-8859-1', 'file.txt')
my $cmd2 = $mc->viewCmd('text/plain; charset=iso-8859-2', 'file.txt')
my $cmd3 = $mc->viewCmd('image/gif', 'gisle.gif')
my $cmd4 = $mc->printCmd('local; foo=bar', 'myfile')

print $^STDOUT, "$cmd1\n"

print $^STDOUT, "ok 2\n" if $cmd1 eq "cat file.txt"

print $^STDOUT, "$cmd2\n"
print $^STDOUT, "ok 3\n" if $cmd2 eq "smartcat file.txt"

print $^STDOUT, "$cmd3\n"
print $^STDOUT, "ok 4\n" if $cmd3 eq qq(xv gisle.gif ; echo "Showing image gisle.gif")

print $^STDOUT, "$cmd4\n"
print $^STDOUT, "ok 5\n" if $cmd4 =~ m/^lpr\s+bar\s+local\s+myfile$/


#$mc->dump;
