#!/usr/local/bin/perl -w

use Mail::Send

use Test::More

plan tests => 12

ok(my $msg = Mail::Send->new())

ok($msg = Mail::Send->new(
   Subject      => 'example subject',
   To   => 'timbo')
   )

is(nelems($msg->to('user@host')), 1)

is(nelems($msg->subject('user@host')), 1)

is(nelems($msg->cc('user@host', 'user2@no.where')), 2)

is(nelems($msg->bcc('someone@else')), 1)

is(nelems($msg->bcc('nobody@here')), 1)

is(nelems($msg->set('X-Test', 'a test entry')), 1)

is($msg->add('X-Test', 'another test entry'), 2)

is(nelems($msg->set('X-Test2', 'a test2 entry')), 1)

is(nelems($msg->set('X-Test2', 'replaced')), 1)

ok($msg->delete('X-Test'))

