#!/usr/bin/perl -w

# Test bpi() and bexp()

use Test::More

BEGIN
  
    $^OUTPUT_AUTOFLUSH = 1
    # to locate the testing files
    my $location = $^PROGRAM_NAME; $location =~ s/big_pi_e.t//i
    unshift $^INCLUDE_PATH, '../lib'
    if (-d 't')
        chdir 't'
        require File::Spec
        unshift $^INCLUDE_PATH, File::Spec->catdir(File::Spec->updir, $location)
    else
        unshift $^INCLUDE_PATH, $location
    
    print $^STDOUT, "# INC = $(join ' ',$^INCLUDE_PATH)\n"

    plan tests => 8


use Math::BigFloat

#############################################################################

my $pi = Math::BigFloat::bpi()

ok (!defined $pi->{_a}, 'A not set')
ok (!defined $pi->{_p}, 'P not set')

$pi = Math::BigFloat->bpi()

ok (!defined $pi->{_a}, 'A not set')
ok (!defined $pi->{_p}, 'P not set')

$pi = Math::BigFloat->bpi(10)

is ($pi->{?_a}, 10, 'A set')
is ($pi->{?_p}, undef, 'P not set')

#############################################################################
my $e = Math::BigFloat->new(1)->bexp()

ok (!defined $e->{_a}, 'A not set')
ok (!defined $e->{_p}, 'P not set')


