#!/usr/bin/perl -w

use Test::More

BEGIN
  
    $^OUTPUT_AUTOFLUSH = 1
    # to locate the testing files
    my $location = $^PROGRAM_NAME; $location =~ s/bigfltpm.t//i
    unshift $^INCLUDE_PATH, '../lib'
    if (-d 't')
        chdir 't'
        require File::Spec
        unshift $^INCLUDE_PATH, File::Spec->catdir(File::Spec->updir, $location)
    else
        unshift $^INCLUDE_PATH, $location
    
    print $^STDOUT, "# INC = $(join ' ',$^INCLUDE_PATH)\n"

    plan tests => 1374


use Math::BigInt lib => 'Calc'
use Math::BigFloat

our ($class, $try, $x, $y, $f, @args, $ans, $ans1, $ans1_str, $setup, $CL)
$class = "Math::BigFloat"
$CL = "Math::BigInt::Calc"

is ($class->config()->{?class},$class)
is ($class->config()->{?with}, $CL)

# bug #17447: Can't call method Math::BigFloat->bsub, not a valid method
my $c = Math::BigFloat->new( '123.3' )
is ($c->fsub(123)->bstr, '0.3') # calling fsub on a BigFloat works

# Bug until BigInt v1.86, the scale wasn't treated as a scalar:
$c = Math::BigFloat->new('0.008'); my $d = Math::BigFloat->new(3)
my $e = $c->bdiv(Math::BigFloat->new(3),$d)

is ($e->bstr,'0.00267') # '0.008 / 3 => 0.0027');
is (ref($e->{_e}->[0]), '') # 'Not a BigInt');

require 'bigfltpm.inc'	# all tests here for sharing
