#!/usr/bin/perl -w

use Test::More

BEGIN
  
    $^OUTPUT_AUTOFLUSH = 1
    unshift $^INCLUDE_PATH, '../lib' # for running manually
    my $location = $^PROGRAM_NAME; $location =~ s/bigintpm.t//
    unshift $^INCLUDE_PATH, $location # to locate the testing files
    chdir 't' if -d 't'
    plan tests => 1916


use Math::BigInt lib => 'Calc'

our ($scale, $class, $try, $x, $y, $f, @args, $ans, $ans1, $ans1_str, $setup, $CL)
$class = "Math::BigInt"
$CL = "Math::BigInt::Calc"

#############################################################################
# from_hex(), from_bin() and from_oct() tests

$x = Math::BigInt->from_hex('0xcafe')
is ($x->bstr, "51966", 'from_hex() works')

$x = Math::BigInt->from_hex('0xcafebabedead')
is ($x->bstr, "223195403574957", 'from_hex() works with long numbers')

$x = Math::BigInt->from_bin('0b1001')
is ($x->bstr, "9", 'from_bin() works')

$x = Math::BigInt->from_bin('0b1001100110011001100110011001')
is ($x->bstr, "161061273", 'from_bin() works with big numbers')

$x = Math::BigInt->from_oct('0775')
is ($x->bstr, "509", 'from_oct() works')

$x = Math::BigInt->from_oct('07777777777777711111111222222222')
is ($x->bstr, "9903520314281112085086151826", 'from_oct() works with big numbers')

#############################################################################
# all the other tests

require 'bigintpm.inc'	# all tests here for sharing
