#!/usr/bin/perl -w

use Test::More

BEGIN
  
    $^OUTPUT_AUTOFLUSH = 1
    # to locate the testing files
    my $location = $^PROGRAM_NAME; $location =~ s/isa.t//i
    unshift $^INCLUDE_PATH, < qw(../lib)
    if (-d 't')
        chdir 't'
        require File::Spec
        unshift $^INCLUDE_PATH, File::Spec->catdir(File::Spec->updir, $location)
    else
        unshift $^INCLUDE_PATH, $location
    
    print $^STDOUT, "# INC = $(join ' ',$^INCLUDE_PATH)\n"

    plan tests => 7


use Math::BigInt::Subclass
use Math::BigFloat::Subclass
use Math::BigInt
use Math::BigFloat

our ($class, $try, $x, $y, $f, @args, $ans, $ans1, $ans1_str, $setup, $CL)
$class = "Math::BigInt::Subclass"
$CL = "Math::BigInt::Calc"

# Check that a subclass is still considered a BigInt
is ($class->new(123)->isa('Math::BigInt'),1)

# ditto for plain Math::BigInt
is (Math::BigInt->new(123)->isa('Math::BigInt'),1)
is (Math::BigFloat->new(123)->isa('Math::BigInt'),undef)

# see what happens if we feed a Math::BigFloat into new()
$x = Math::BigInt->new(Math::BigFloat->new(123))
ok (ref($x),'Math::BigInt')
is ($x->isa('Math::BigInt'),1)

# ditto for subclass
$x = Math::BigInt->new(Math::BigFloat->new(123))
ok (ref($x),'Math::BigInt')
is ($x->isa('Math::BigInt'),1)

