#!/usr/bin/perl -w

# check that requiring BigFloat and then calling import() works


use Test::More

BEGIN
  
    $^OUTPUT_AUTOFLUSH = 1
    # to locate the testing files
    my $location = $^PROGRAM_NAME; $location =~ s/req_mbfw.t//i
    if (env::var('PERL_CORE'))
        # testing with the core distribution
        $^INCLUDE_PATH = qw(../t/lib)
    
    unshift $^INCLUDE_PATH, < qw(../lib)     # to locate the modules
    if (-d 't')
        chdir 't'
        require File::Spec
        unshift $^INCLUDE_PATH, File::Spec->catdir(File::Spec->updir, $location)
    else
        unshift $^INCLUDE_PATH, $location
    
    print $^STDOUT, "# INC = $(join ' ',$^INCLUDE_PATH)\n"

    plan tests => 3


# normal require that calls import automatically (we thus have MBI afterwards)
require Math::BigFloat
my $x = Math::BigFloat->new(1); $x->binc
is ($x->bstr,2, '$x is 2')

like (Math::BigFloat->config()->{?with}, qr/^Math::BigInt::(Fast)?Calc\z/, 'with ignored' )

# now override
Math::BigFloat->import ( with => 'Math::BigInt::Subclass' )

# the "with" argument is ignored
like (Math::BigFloat->config()->{?with}, qr/^Math::BigInt::(Fast)?Calc\z/, 'with ignored' )

# all tests done

