#!/usr/bin/perl -w

# check that simple requiring BigInt works


use Test::More

BEGIN
  
    $^OUTPUT_AUTOFLUSH = 1
    # to locate the testing files
    my $location = $^PROGRAM_NAME; $location =~ s/require.t//i
    if (env::var('PERL_CORE'))
        # testing with the core distribution
        $^INCLUDE_PATH = qw(../t/lib)
    
    unshift $^INCLUDE_PATH, < qw(../lib)     # to locate the modules
    if (-d 't')
        chdir 't'
        require File::Spec
        unshift $^INCLUDE_PATH, File::Spec->catdir(File::Spec->updir, $location)
    else
        unshift $^INCLUDE_PATH, $location
    
    print $^STDOUT, "# INC = $(join ' ',$^INCLUDE_PATH)\n"

    plan tests => 1


my ($x)

require Math::BigInt; $x = Math::BigInt->new(1); $x->binc

is ($x->bstr,2)

# all tests done

