#!/usr/bin/perl -w

use Test::More

BEGIN
  
    $^OUTPUT_AUTOFLUSH = 1
    # to locate the testing files
    my $location = $^PROGRAM_NAME; $location =~ s/sub_mbf.t//i
    unshift $^INCLUDE_PATH, '../lib'
    if (-d 't')
        chdir 't'
        require File::Spec
        unshift $^INCLUDE_PATH, File::Spec->catdir(File::Spec->updir, $location)
    else
        unshift $^INCLUDE_PATH, $location
    
    print $^STDOUT, "# INC = $(join ' ',$^INCLUDE_PATH)\n"

    plan tests => 1375


use Math::BigFloat::Subclass

our ($class, $try, $x, $y, $f, @args, $ans, $ans1, $ans1_str, $setup, $CL)
$class = "Math::BigFloat::Subclass"
$CL = Math::BigFloat->config()->{?lib} # "Math::BigInt::Calc"; or FastCalc

require 'bigfltpm.inc'	# perform same tests as bigfltpm

###############################################################################
# Now do custom tests for Subclass itself
my $ms = $class->new(23)
print $^STDOUT, "# Missing custom attribute \$ms->\{_custom\}" if !is (1, $ms->{?_custom})

# Check that subclass is a Math::BigFloat, but not a Math::Bigint
is ($ms->isa('Math::BigFloat'),1)
is ($ms->isa('Math::BigInt') || 0,0)

use Math::BigFloat

my $bf = Math::BigFloat->new(23)		# same as other
$ms->badd($bf)
print $^STDOUT, "# Tried: \$ms += \$bf, got $ms" if !is (46, $ms->bstr)
print $^STDOUT, "# Missing custom attribute \$ms->\{_custom\}" if !is (1, $ms->{?_custom})
print $^STDOUT, "# Wrong class: ref(\$ms) was ".ref($ms) if !is ($class, ref($ms))
