#!/usr/bin/perl -w

use Test::More

BEGIN
  
    $^OUTPUT_AUTOFLUSH = 1
    # to locate the testing files
    my $location = $^PROGRAM_NAME; $location =~ s/sub_mbi.t//i
    unshift $^INCLUDE_PATH, < qw(../lib)
    if (-d 't')
        chdir 't'
        require File::Spec
        unshift $^INCLUDE_PATH, File::Spec->catdir(File::Spec->updir, $location)
    else
        unshift $^INCLUDE_PATH, $location
    
    print $^STDOUT, "# INC = $(join ' ',$^INCLUDE_PATH)\n"

    plan tests => 1915


use Math::BigInt::Subclass

our ($class, $try, $x, $y, $f, @args, $ans, $ans1, $ans1_str, $setup, $CL)
$class = "Math::BigInt::Subclass"
$CL = "Math::BigInt::Calc"

my $version = '0.02'   # for $VERSION tests, match current release (by hand!)

require 'bigintpm.inc'	# perform same tests as bigintpm

###############################################################################
# Now do custom tests for Subclass itself

my $ms = $class->new(23)
print $^STDOUT, "# Missing custom attribute \$ms->\{_custom\}" if !is (1, $ms->{?_custom})

# Check that a subclass is still considered a BigInt
is ($ms->isa('Math::BigInt'),1)

use Math::BigInt

my $bi = Math::BigInt->new(23)		# same as other
$ms->badd($bi)
print $^STDOUT, "# Tried: \$ms += \$bi, got $ms" if !is (46, $ms->bstr)
print $^STDOUT, "# Missing custom attribute \$ms->\{_custom\}" if !is (1, $ms->{?_custom})
print $^STDOUT, "# Wrong class: ref(\$ms) was ".ref($ms) if !is ($class, ref($ms))
