#!/usr/bin/perl -w

# see if using Math::BigInt and Math::BigFloat works together nicely.
# all use_lib*.t should be equivalent

use Test::More

BEGIN
  
    $^OUTPUT_AUTOFLUSH = 1
    # to locate the testing files
    my $location = $^PROGRAM_NAME; $location =~ s/use_lib3.t//i
    unshift $^INCLUDE_PATH, < qw(../lib)     # to locate the modules
    if (-d 't')
        chdir 't'
        require File::Spec
        unshift $^INCLUDE_PATH, File::Spec->catdir(File::Spec->updir, $location)
    else
        unshift $^INCLUDE_PATH, $location
    
    print $^STDOUT, "# INC = $(join ' ',$^INCLUDE_PATH)\n"

    plan tests => 2


use Math::BigInt lib => 'BareCalc'
use Math::BigFloat

is (Math::BigInt->config()->{?lib},'Math::BigInt::BareCalc')

is (Math::BigFloat->new(123)->badd(123)->bstr,246)

