package Module::Build::Config

use Config 'config_value', 'config_keys'

sub new($pack, %< %args)
    return bless \(%: 
        stack => \$%
        values => %args{?values} || \$%
        ), $pack


sub get($self, $key)
    return $self->{values}->{?$key} if ref($self) && exists $self->{values}->{$key}
    return config_value($key)


sub set($self, $key, $val)
    $self->{values}->{+$key} = $val


sub push($self, $key, $val)
    push $self->{stack}->{$key}->@, $self->{values}->{?$key}
        if exists $self->{values}->{$key}
    $self->{values}->{+$key} = $val


sub pop($self, $key)

    my $val = delete $self->{values}->{$key}
    if ( exists $self->{stack}->{$key} )
        $self->{values}->{+$key} = pop $self->{stack}->{$key}->@
        delete $self->{stack}->{$key} unless (nelems $self->{stack}->{?$key}->@)
    

    return $val


sub values_set
    my $self = shift
    return undef unless ref($self)
    return $self->{?values}


sub all_config
    my $self = shift
    my $v = ref($self) ?? $self->{?values} !! \$%
    return \%:< ( @+: map { @: $_ => config_value($_) }, config_keys ), < $v->%


1
