#!/usr/bin/perl -w


use lib env::var('PERL_CORE') ?? '../lib/Module/Build/t/lib' !! 't/lib'
use MBTest tests => 7

use Cwd ()
my $cwd = Cwd::cwd

#########################

use_ok 'Module::Build::PodParser'

do
    my $in = <<'EOF'
=head1 NAME

Foo::Bar - Perl extension for blah blah blah

=head1 AUTHOR

C<Foo::Bar> was written by Engelbert Humperdinck I<E<lt>eh@example.comE<gt>> in 2004.

Home page: http://example.com/~eh/

=cut
EOF

    open my $fh, '<', \$in or die

    my $pp = Module::Build::PodParser->new(fh => $fh)
    ok $pp, 'object created'

    is $pp->get_author[0], 'C<Foo::Bar> was written by Engelbert Humperdinck I<E<lt>eh@example.comE<gt>> in 2004.', 'author'
    is $pp->get_abstract, 'Perl extension for blah blah blah', 'abstract'


do
    # Try again without a valid author spec
    my $in = <<'EOF'
=head1 NAME

Foo::Bar - Perl extension for blah blah blah

=cut
EOF
    open my $fh, '<', \$in or die

    my $pp = Module::Build::PodParser->new(fh => $fh)
    ok $pp, 'object created'

    is_deeply $pp->get_author, $@, 'author'
    is $pp->get_abstract, 'Perl extension for blah blah blah', 'abstract'



