#!perl -w


use FindBin
use lib "$FindBin::Bin/lib"
use Test::More tests => 10

do
    my $foo
    ok($foo = MyTest->new())

    my @plugins
    my @expected = qw(MyTest::Plugin::Bar MyTest::Plugin::Quux::Foo)
    ok(@plugins = sort $foo->plugins)

    is_deeply(\@plugins, \@expected)

    @plugins = $@

    ok(@plugins = sort MyTest->plugins)
    is_deeply(\@plugins, \@expected)


do
    my $foo
    ok($foo = MyTestSub->new())

    my @plugins
    my @expected = qw(MyTest::Plugin::Bar MyTest::Plugin::Quux::Foo)
    ok(@plugins = sort $foo->plugins)

    is_deeply(\@plugins, \@expected)

    @plugins = $@

    ok(@plugins = sort MyTestSub->plugins)
    is_deeply(\@plugins, \@expected)


package MyTest

use Module::Pluggable except => \(@:  "MyTest::Plugin::Foo" )



sub new
    my $class = shift
    return bless \$%, $class



package MyTestSub

use Module::Pluggable search_path => "MyTest::Plugin"


sub new
    my $class = shift
    my $self = bless \$%, $class

    $self->except(\(@: "MyTest::Plugin::Foo"))

    return $self

1

