# $Id: 00-version.t 666 2007-06-21 15:08:49Z olaf $ -*-perl-*-

use Test::More
use File::Spec
use File::Find
use ExtUtils::MakeMaker


my @files
my $blib = File::Spec->catfile( <qw(blib lib))

find( sub (@< @_) { push(@files, $File::Find::name) if m/\.pm$/}, $blib)

my $can = try { MM->can('parse_version') }

if (!$^EVAL_ERROR and $can)
    plan tests => (2* scalar nelems(@files)) - 1
else
    plan skip_all => ' Not sure how to parse versions.'


foreach my $file ( @files)
    my $version = MM->parse_version($file)
    diag("$file\t=>\t$version") if env::var('NET_DNS_DEBUG')
    isnt("$file: $version", "$file: undef", "$file has a version")
    next if $file =~ m/Net\/DNS.pm$/
    ok ($version+>290,"$file: version has reasonable value")




