our $math_bigint

BEGIN 
    use Net::IP < qw(:PROC)

    if (eval (require Math::BigInt))
        $math_bigint = 1
    ;
;

use Test::More

my $numtests = 26

$numtests++ if $math_bigint

plan tests => $numtests
#------------------------------------------------------------------------------



my $ip = Net::IP->new('195.114.80/24',4)

ok(defined($ip),$Net::IP::Error)
is($ip->binip(),'11000011011100100101000000000000',$ip->error())
is($ip->ip(),'195.114.80.0',$ip->error())
is($ip->print(),'195.114.80/24',$ip->error())
is($ip->hexip(),'0xc3725000',$ip->error())
is($ip->hexmask(),'0xffffff00',$ip->error())
is($ip->prefixlen(),24,$ip->error())
is($ip->version(),4,$ip->error())
is($ip->size(),256,$ip->error())
is($ip->binmask(),'11111111111111111111111100000000',$ip->error())
is($ip->mask(),'255.255.255.0',$ip->error())
is($ip->intip(),3279048704,$ip->error()) if $math_bigint
is($ip->iptype(),'PUBLIC',$ip->error())
is($ip->reverse_ip(),'80.114.195.in-addr.arpa.',$ip->error())
is($ip->last_bin(),'11000011011100100101000011111111',$ip->error())
is($ip->last_ip(),'195.114.80.255',$ip->error())

$ip->set('202.31.4/24')
is($ip->ip(),'202.31.4.0',$ip->error())

$ip->set('234.245.252.253/2')
is($ip->error(),'Invalid prefix 11101010111101011111110011111101/2',$ip->error())
is($ip->errno(),171,$ip->error())

$ip->set('62.33.41.9')
my $ip2 = Net::IP->new('0.1.0.5')
is($ip->binadd($ip2)->ip(),'62.34.41.14',$ip->error())

$ip->set('133.45.0/24')
$ip2 = Net::IP->new('133.45.1/24')
is($ip->aggregate($ip2)->prefixlen(),23,$ip->error())

$ip2 = Net::IP->new('133.44.255.255')
is($ip->bincomp('gt',$ip2),1,$ip->error())

$ip = Net::IP->new('133.44.255.255-133.45.0.42')
is(($ip->find_prefixes())[3],'133.45.0.40/31',$ip->error())

$ip = Net::IP->new('192.168.2.254-192.168.2.255')
my @prefixes = @:  < $ip->find_prefixes() 
is(scalar(nelems(@prefixes)), 1)
is(@prefixes[0],'192.168.2.254/31',$ip->error())

$ip->set('201.33.128.0/22')
$ip2->set('201.33.129.0/24')

is($ip->overlaps($ip2),$IP_B_IN_A_OVERLAP,$ip->error())

$ip->set('192.168.0.3/32')
is($ip->size,1,$ip->error())


#------------------------------------------------------------------------------
1
