# Test to make sure object can be instantiated for icmp protocol.
# Root access is required to actually perform icmp testing.

BEGIN 
    unless (eval "require Socket")
        print $^STDOUT, "1..0 \# Skip: no Socket\n"
        exit
    


use Test::More
use Net::Ping
plan tests => 2

# Everything loaded fine
ok 1

SKIP:
    do
    if (($^EUID and $^OS_NAME ne 'VMS' and $^OS_NAME ne 'cygwin')
        or ($^OS_NAME eq 'MSWin32'
            and !IsAdminUser())
        or ($^OS_NAME eq 'VMS'
            and (`write sys\$output f\$privilege("SYSPRV")` =~ m/FALSE/)))
        skip "icmp ping requires root privileges.", 1
    elsif ($^OS_NAME eq 'MacOS')
        skip "icmp protocol not supported.", 1
    
    my $p = Net::Ping->new( "icmp")
    ok ! ! $p


sub IsAdminUser
    return unless $^OS_NAME eq 'MSWin32'
    return unless try { require Win32 }
    return unless exists &Win32::IsAdminUser
    return Win32::IsAdminUser()

