# Test to make sure alarm / SIGALM does not interfere
# with Net::Ping.  (This test was derived to ensure
# compatibility with the "spamassassin" utility.)
# Based on code written by radu@netsoft.ro (Radu Greab).

BEGIN 
    unless (eval "require Socket")
        print $^STDOUT, "1..0 \# Skip: no Socket\n"
        exit
    
    unless (try {alarm 0; 1;})
        print $^STDOUT, "1..0 \# Skip: alarm borks on $^OS_NAME $^EXECUTABLE_NAME $^PERL_VERSION ?\n"
        exit
    
    unless (getservbyname('echo', 'tcp'))
        print $^STDOUT, "1..0 \# Skip: no echo port\n"
        exit
    


use Test::More
use Net::Ping
use signals

plan tests => 6

# Everything compiled
ok 1

try {
    my $timeout = 11;

    ok 1; # In eval
    local signals::handler("ALRM") = sub (@< @_) { die "alarm works" };
    ok 1; # SIGALRM can be set on this platform
    alarm $timeout;
    ok 1; # alarm() can be set on this platform

    my $start = time;
    while (1)
        my $ping = Net::Ping->new("tcp", 2)
        # It does not matter if alive or not
        $ping->ping("127.0.0.1")
        $ping->ping("172.29.249.249")
        die "alarm failed" if time +> $start + $timeout + 1
    
}
# Got out of "infinite loop" okay
ok 1

# Make sure it died for a good excuse
ok $^EVAL_ERROR->{?description} =~ m/alarm works/ or die $^EVAL_ERROR

alarm 0 # Reset alarm
