# Test to make sure hires feature works.

BEGIN 
    unless (eval "require Socket")
        print $^STDOUT, "1..0 \# Skip: no Socket\n"
        exit
    
    unless (eval "require Time::HiRes")
        print $^STDOUT, "1..0 \# Skip: no Time::HiRes\n"
        exit
    
    unless (getservbyname('echo', 'tcp'))
        print $^STDOUT, "1..0 \# Skip: no echo port\n"
        exit
    


use Test::More
use Net::Ping
plan tests => 7

# Everything loaded fine
ok 1

my $p = Net::Ping->new( "tcp")

# new() worked?
ok ! ! $p

# Default is to not use Time::HiRes
ok !$Net::Ping::hires

# Enable hires
$p -> hires()
ok $Net::Ping::hires

# Make sure disable works
$p -> hires(0)
ok !$Net::Ping::hires

# Enable again
$p -> hires(1)
ok $Net::Ping::hires

# Test on the default port
my $ret = $p -> ping("localhost")

# localhost should always be reachable, right?
ok $ret
