# Test to perform icmp protocol testing.
# Root access is required.

BEGIN 
    unless (eval "require Socket")
        print $^STDOUT, "1..0 \# Skip: no Socket\n"
        exit
    


use Test::More
use Net::Ping
plan tests => 2

# Everything loaded fine
ok 1

SKIP:
    do
    if (($^EUID and $^OS_NAME ne 'VMS')
        or (($^OS_NAME eq 'MSWin32' or $^OS_NAME eq 'cygwin')
            and !IsAdminUser())
        or ($^OS_NAME eq 'VMS'
            and (`write sys\$output f\$privilege("SYSPRV")` =~ m/FALSE/)))
        skip "icmp ping requires root privileges.", 1
    elsif ($^OS_NAME eq 'MacOS')
        skip "icmp protocol not supported.", 1
    
    my $p = Net::Ping->new( "icmp")
    ok $p->ping("127.0.0.1")


sub IsAdminUser
    return unless $^OS_NAME eq 'MSWin32' or $^OS_NAME eq "cygwin"
    return unless try { require Win32 }
    return unless exists &Win32::IsAdminUser
    return Win32::IsAdminUser()

