package PPI::Exception

use Params::Util '_INSTANCE'

our ($VERSION)
BEGIN 
    $VERSION = '1.204_01'


use base 'error'




#####################################################################
# Constructor and Accessors

sub new
    my $class = shift
    return bless \(%:  < @_ ), $class if nelems(@_) +> 1
    return bless \(%:  message => @_[0] ), $class if nelems(@_)
    return bless \(%:  message => 'Unknown Reason' ), $class


sub callers
    < ( @_[0]->{?callers} || \$@ )->@






#####################################################################
# Main Methods

sub throw
    my $it = shift
    if ( _INSTANCE($it, 'PPI::Exception') )
        if ( $it->{?callers} )
            push  $it->{callers}->@, \@:  caller(0) 
        else
            $it->{+callers} ||= \$@
        
    else
        my $description = @_[0] || 'Unknown Reason'
        $it = $it->new(
            description => $description,
            callers => \(@: 
            \(@:  caller(0) )
            ),
            )
    
    die $it


1
