#!/usr/bin/perl


BEGIN 
    $^OUTPUT_AUTOFLUSH  = 1
    $^WARNING = 1


my $MODULE = 'Test::Pod 1.00'

# Don't run tests for installs
use Test::More
unless ( env::var('AUTOMATED_TESTING') or env::var('RELEASE_TESTING') )
    plan( skip_all => "Author tests not required for installation" )


# Load the testing module
eval "use $MODULE"
if ( $^EVAL_ERROR )
    env::var('RELEASE_TESTING')
        ?? die( "Failed to load required release-testing module $MODULE" )
        !! plan( skip_all => "$MODULE not available for testing" )






#####################################################################
# BEGIN BLACK MAGIC
#####################################################################

# Hack Pod::Simple::BlackBox to ignore the Test::Inline "=begin has more than one word errors"
my $begin = &Pod::Simple::BlackBox::_ponder_begin
sub mybegin
    my $para = @_[1]
    my $content = join ' ', @:  splice $para->@, 2
    $content =~ s/^\s+//s
    $content =~ s/\s+$//s
    my @words = split m/\s+/, $content
    if ( @words[0] =~ m/^test(?:ing)?\z/s )
        foreach ( 2 .. nelems($para->@)-1 )
            $para->[$_] = ''
        
        $para->[2] = @words[0]
    

    # Continue as normal
    return $begin->(< @_)


local $^WARNING = 0
*Pod::Simple::BlackBox::_ponder_begin = &mybegin

#####################################################################
# END BLACK MAGIC
#####################################################################

all_pod_files_ok()
