#!/usr/bin/perl -w



BEGIN

    env::var('PERL_NO_VALIDATION' ) = 0
    require Params::Validate
    Params::Validate->import(':all')


use Test::More
plan tests => 6

Params::Validate::validation_options( stack_skip => 2 )

sub foo
    my %p = %:  < validate(@_, (%:  bar => 1 )) 


sub bar { foo(< @_) }

sub baz { bar(< @_) }

try { baz() }

ok( $^EVAL_ERROR )
ok( $: $^EVAL_ERROR->{?description} =~ m/mandatory.*missing.*call to main::bar/i )

Params::Validate::validation_options( stack_skip => 3 )

try { baz() }

ok( $^EVAL_ERROR )

do
    ok( $: $^EVAL_ERROR->{?description} =~ m/mandatory.*missing.*call to main::baz/i )

    Params::Validate::validation_options
          ( on_fail => sub (@< @_) { die "Idie" } )

    try { baz() }

    ok( $^EVAL_ERROR )
    ok( $^EVAL_ERROR->{?description} eq 'Idie' )


