#!/usr/bin/perl -w



use Params::Validate < qw(validate validate_pos SCALAR)
use Test::More tests => 4

do
    my @p = @:  foo => 1, bar => 2 

    try { validate( @p, %:  foo => \ %: type => SCALAR
                                        callbacks =>
                                        \ %: 'bigger than bar' =>
                                                 sub (@< @_) { @_[0] +> @_[1]{?bar} }
                            bar => \ %:  type => SCALAR
                   ) }

    like( $^EVAL_ERROR->{?description}, qr/bigger than bar/ )

    @p[1] = 3
    try { validate( @p, %:  foo => \ %: type => SCALAR
                                        callbacks =>
                                        \ %:  'bigger than bar' =>
                                                  sub (@< @_) { @_[0] +> @_[1]{?bar} }
                            bar => \ %:  type => SCALAR
                    ) }

    ok( ! $^EVAL_ERROR )


do
    my @p = @: 1, 2, 3
    try { validate_pos( @p,
                        \(%:  type => SCALAR
                              callbacks =>
                              \ %: 'bigger than [1]' =>
                                       sub (@< @_) { @_[0] +> @_[1]->[1] } ),
                        \(%:  type => SCALAR ),
                        \(%:  type => SCALAR ),
                        ) }

    like( $^EVAL_ERROR->{?description}, qr/bigger than \[1\]/ )

    @p[0] = 5
    try { validate_pos( @p,
                        \(%:  type => SCALAR
                              callbacks =>
                              \ %:  'bigger than [1]' =>
                                        sub (@< @_) { @_[0] +> @_[1]->[1] } ),
                        \(%:  type => SCALAR ),
                        \(%:  type => SCALAR ),
                        ) }

    ok( ! $^EVAL_ERROR )

