#!/usr/bin/perl -w



use Params::Validate < qw(validate)
use Test::More tests => 2

do
    my @p = @:  foo => 1 

    try {
        validate( @p,
                  (%:  foo => \(%:  type => 'SCALAR' ) ),
                  );
    }

    like( $^EVAL_ERROR->{?description}, qr/\QThe 'foo' parameter (1) has a type specification which is not a number. It is a string - SCALAR/ )


do
    my @p = @:  foo => 1 

    try {
        validate( @p,
                  (%:  foo => \(%:  type => undef ) ),
                  );
    }

    like( $^EVAL_ERROR->{?description}, qr/\QThe 'foo' parameter (1) has a type specification which is not a number. It is undef/ )


