

package Foo

use Params::Validate < qw(:all)

my %storage = %+: map { %: lc $_ => $_ }, qw( InMemory XML BerkeleyDB )

sub new
    my $class = shift

    local $^WARNING = 1

    my %p = %:  < validate_with( params => @_,
                                 spec   =>
                                        %: storage =>
                                           \ %: callbacks =>
                                                    \ %:  'is a valid storage type' =>
                                                            sub ($v, ...) { %storage{?lc $v} }
                                 ,
                                 allow_extra => 1
                                 )

    return 1


package main

use Test::More

BEGIN { plan tests => 3 }

my %allowed = %:  foo => 1, baz => 1 
do
    my @a = @:  foo => 'foo' 
    validate( @a, (%:  foo => \%: callbacks =>
                                  \ %:  is_allowed => sub (@< @_) { %allowed{?lc @_[0] } }
              ) )
    ok 1


try {
    my @a = (@:  foo => 'aksjgakl' );

    validate( @a, (%:  foo => \%: callbacks =>
                                  \ %:  is_allowed => sub (@< @_) { %allowed{?lc @_[0] } }
              ) );
}
ok( env::var('PERL_NO_VALIDATION') ?? ! $^EVAL_ERROR !!
    $^EVAL_ERROR->{?description} =~ m/is_allowed/ )

# duplicates code from Lingua::ZH::CCDICT that revelead bug fixed in
# 0.56.
do
    Foo->new( storage => 'InMemory', file => 'something' )
    ok 1



1
