

$^OUTPUT_AUTOFLUSH = 1

print $^STDOUT, "1..21\n"

do
    my %def = %:  < foo() 

    ok( 1 )

    ok( %def{?a} == 1,
        "Parameter 'a' was altered: %def{?a}\n" )

    ok( %def{?b} == 2,
        "Parameter 'b' was altered: %def{?b}\n" )

    ok( %def{?c} == 42,
        "No default (or incorrect default) assigned for parameter 'c': %def{?c}\n" )

    ok( %def{?d} == 0,
        "No default (or incorrect default) assigned for parameter 'd': %def{?d}\n" )


do
    my $def = try { foo() }

    ok( ! $^EVAL_ERROR,
        "Error calling foo(): $^EVAL_ERROR\n" )

    ok( $def{?a} == 1,
        "Parameter 'a' was altered: $def{?a}\n" )

    ok( $def{?b} == 2,
        "Parameter 'b' was altered: $def{?b}\n" )

    ok( $def{?c} == 42,
        "No default (or incorrect default) assigned for parameter 'c': $def{?c}\n" )

    ok( $def{?d} == 0,
        "No default (or incorrect default) assigned for parameter 'd': $def{?d}\n" )


do
    my @def = bar()

    ok( 1, "calling bar()" )

    ok( @def[0] == 1,
        "1st parameter was altered: @def[0]\n" )

    ok( @def[1] == 2,
        "2nd parameter was altered: @def[1]\n" )

    ok( @def[2] == 42,
        "No default (or incorrect default) assigned for 3rd parameter: @def[2]\n" )

    ok( @def[3] == 0,
        "No default (or incorrect default) assigned for 4rd parameter: @def[0]\n" )


do
    my $def = try { bar() }

    ok( ! $^EVAL_ERROR,
        "Error calling bar(): $^EVAL_ERROR\n" )

    ok( $def[0] == 1,
        "1st parameter was altered: $def[0]\n" )

    ok( $def[1] == 2,
        "2nd parameter was altered: $def[1]\n" )

    ok( $def[2] == 42,
        "No default (or incorrect default) assigned for 3rd parameter: $def[2]\n" )

    ok( $def[3] == 0,
        "No default (or incorrect default) assigned for 4rd parameter: $def[0]\n" )


# test that defaults containing refs return _copies_ of these refs
do
    my $spec = %:  foobar => \(%:  default => \$@ ) 
    my $test1 = validate_with(params => $@, spec => $spec)
    $test1{+foobar} = \@: 'x'

    my $test2 = validate_with(params => $@, spec => $spec)
    $test2{+foobar} = \@: 'y'

    ok($test1{foobar}->[0] eq 'x')


sub foo
    my @params = @:  a => 1, b => 2 
    return validate( @params, (%:  a => 1
                                   b => \(%:  default => 99 )
                                   c => \(%:  optional => 1, default => 42 )
                                   d => \(%:  default => 0 )
                     ) )


sub bar
    my @params = @:  1, 2 

    return validate_pos( @params, 1, \(%:  default => 99 ), \(%:  default => 42 ), \(%:  default => 0 ) )


sub ok
    my $ok = not not shift
    our ($TESTNUM)
    $TESTNUM++
    print $^STDOUT, "not "x!$ok, "ok $TESTNUM\n"
    print $^STDOUT, "$(join ' ', (@:  <@_))\n" if !$ok


1
