use Test::More
BEGIN { plan tests => 7 }
my $r = '^bar$'

do
    my @a = @:  foo => 'bar' 
    validate( @a, (%:  foo => \(%:  regex => '^bar$' ) ) )
    ok( 1 )


try {
    my @a = (@:  foo => 'bar' );
    validate( @a, (%:  foo => \(%:  regex => qr/^bar$/ ) ) );
}
ok( ! $^EVAL_ERROR )

try {
    my @a = (@:  foo => 'baz' );
    validate( @a, (%:  foo => \(%:  regex => '^bar$' ) ) );
}
ok( env::var('PERL_NO_VALIDATION') ?? ! $^EVAL_ERROR !!
    $^EVAL_ERROR->{?description} =~ m/'foo'.+did not pass regex check/ )

try {
    my @a = (@:  foo => 'baz' );
    validate( @a, (%:  foo => \(%:  regex => qr/^bar$/ ) ) );
}
ok( env::var('PERL_NO_VALIDATION') ?? ! $^EVAL_ERROR !!
    $^EVAL_ERROR->{?description} =~ m/'foo'.+did not pass regex check/ )

try {
    my @a = (@:  foo => 'baz', bar => 'quux' );
    validate( @a, (%:  foo => \(%:  regex => qr/^baz$/ )
                       bar => \(%:  regex => 'uqqx' )
              ) );
}
ok( env::var('PERL_NO_VALIDATION') ?? ! $^EVAL_ERROR !!
    $^EVAL_ERROR->{?description} =~ m/'bar'.+did not pass regex check/ )

try {
    my @a = (@:  foo => 'baz', bar => 'quux' );
    validate( @a, (%:  foo => \(%:  regex => qr/^baz$/ )
                       bar => \(%:  regex => qr/^(?:not this|quux)$/ )
              ) );
}
ok( ! $^EVAL_ERROR )

try {
    my @a = (@:  foo => undef );
    validate( @a, (%:  foo => \(%:  regex => qr/^$|^bubba$/ ) ) );
}
ok( ! $^EVAL_ERROR )



1
