package PerlIO::via::Zlib

use warnings

our $VERSION = v0.1

use base 'PerlIO::via'

use Compress::Raw::Zlib

sub PUSHED($class,$mode, ?$fh)
    # When writing we buffer the data
    my $buf = ''
    my ($infl, $defl)
    if ($mode eq 'r')
        $infl = Compress::Raw::Zlib::Inflate->new(AppendOutput => 1, WindowBits => WANT_GZIP )
    else
        die "Unsupported mode"
    
    return bless( \ (%: infl => $infl
                        defl => $defl
                        buffer => $buf
                        error => 0
                     ), $class )


sub READ
    my (@: $self,$buffer,$len,$fh) = @_
    my $bufref = \ @_[1]
    if (not $self->{buffer})
        my $input
        my $res = read($fh, $input, 4096)
        if (not defined $res)
            $self->{error} = $^OS_ERROR
            return 0
        
        my $status = $self->{infl}->inflate( $input, $self->{buffer} )
        if ($status != Z_OK and $status != Z_STREAM_END)
            $self->{error} = $status
            return 0
        
    
    $bufref->$ = substr($self->{buffer}, 0, $len, '')
    return length($bufref->$)


sub ERROR($self, $fh)
    return $self->{error}


#     sub WRITE
#       {
#      my ($obj,$buf,$fh) = @_;
#      $$obj .= unpack("H*", $buf);
#      return length($buf);
#  }

#     sub FLUSH
#         {
#      my ($obj,$fh) = @_;
#      print $fh $$obj or return -1;
#      $$obj = '';
#      return 0;
#  }

1
