#!/usr/bin/perl -w

use lib 't/lib'
use Test::More tests => 3


is( capture(q{ use Pod::Coverage package => 'Simple2'; }), "Simple2 has a Pod::Coverage rating of 0.75\n'naked' is uncovered", "Simple2 works correctly in import form")

is( capture(q{ use Pod::Coverage package => 'Simple7' }), "Simple7 has a Pod::Coverage rating of 0\nThe following are uncovered: bar, foo", 'Simple7 import form')

is( capture(q{ use Pod::Coverage 'Simple7' }), "Simple7 has a Pod::Coverage rating of 0\nThe following are uncovered: bar, foo", 'Simple7 import form, implicit package')

sub capture
    my $code = shift
    open(my $fh, ">", "test.out") or die "Couldn't open test.out for writing: $^OS_ERROR"
    open(my $oldout, ">&", $^STDOUT)
    open($^STDOUT, ">&", $fh)

    eval $code
    die if $^EVAL_ERROR

    close $^STDOUT
    close $fh
    open($^STDOUT, ">&", $oldout)
    open($fh, "<", "test.out") or die "Couldn't open test.out for reading: $^OS_ERROR"
    my $result
    do { local $^INPUT_RECORD_SEPARATOR = undef; $result = ~< $fh->*; }
    chomp $result
    close $fh
    unlink('test.out')
    return $result

