#  -*- perl -*-

use warnings

use Test::More tests => 2

use Scriptalicious

env::var('PERL5LIB' ) = join ":", @:  "lib", < split ":", (env::var('PERL5LIB') || "")

SKIP: do
    eval 'use Template'
    if ( $^EVAL_ERROR )
        skip "Template not installed", 1
    

    my $output = capture($^EXECUTABLE_NAME, "t/tsay.pl")
    is($output, "Hello, Bernie
tsay.pl: Yo momma's so fat your family portrait has stretchmarks.", "Template say")


env::var('PERL5LIB' ) = join ":", @:  "t/missing", < split ":", (env::var('PERL5LIB') || "")

my $output = capture($^EXECUTABLE_NAME, "t/tsay.pl")
my $expected = <<'EOM'
tsay.pl: warning: install Template Toolkit for prettier messages
tsay.pl: ----- Template `hello' -----
Hello, [% name %]
[% INCLUDE yomomma -%]
tsay.pl: ------ Template variables ------
$x = \%(:
       "name" => "Bernie"
     );
tsay.pl: -------- end of message --------
EOM
chomp($expected)

is($output, $expected, "no Template say")
