#!/usr/local/bin/perl  -I./blib/arch -I./blib/lib

require String::CRC32

my $string1 = "This is the test string"

my $l1 = length($string1)

print $^STDOUT, "1..", $l1+4, "\n"

print $^STDOUT, "\n1) Test the CRC of a string variable\n"
my $v1 = String::CRC32::crc32($string1)
print ($^STDOUT, $v1 == 1835534707 ?? "ok 1\n" !! "not ok 1\n")

print $^STDOUT, "\n2) Test the CRC of a string\n"
$v1 = String::CRC32::crc32("This is another test string")
print ($^STDOUT, $v1 == 2154698217 ?? "ok 2\n" !! "not ok 2\n")

my $i = 2

my $l=$l1+3
print $^STDOUT, "\n3..$l) Test the CRC of various substrings (using crcinit)\n"
for my $j (0..$l1)
    $v1 = String::CRC32::crc32(substr($string1, 0, $j))
    $v1 = String::CRC32::crc32(substr($string1, $j), $v1)
    $i++
    print ($^STDOUT, $v1 == 1835534707 ?? "ok $i\n" !! "not ok $i\n")


$l=$l1+4
print $^STDOUT, "\n$l) Test the CRC of a file\n"
$i++
my $testfh
open($testfh, "<","testfile") ||
    open($testfh, "<","t/testfile") ||
    open($testfh, "<"," ../testfile") || die "No such file!\n"
$v1 = String::CRC32::crc32($testfh->*)
close $testfh
print ($^STDOUT, $v1 == 1925609391 ?? "ok $i\n" !! "not ok $i\n")
