#!/usr/bin/perl

use Test::More
BEGIN { plan tests => 2; }

use String::Escape < qw( printable unprintable escape )

my ( $original, $printable, $comparison )

# Backslash escapes for newline and tab characters

$original = "\tNow is the time\nfor all good folk\nto party.\n"
$comparison = '\tNow is the time\nfor all good folk\nto party.\n'

is( escape('qprintable', $original), '"' . $comparison . '"' )

# Can pass in function references

my $running_total
ok( (escape( sub (@< @_) { $running_total += shift; }, 23)) == 23 )
