use Sub::Install
Sub::Install::install_installers('UNIVERSAL')

# This test, from here on out, is the verbatim "reinstall.t" test from
# Sub::Installer 0.0.2

use Test::More 'no_plan'
use warnings

# Install a sub in a package...

my $sub_ref = main->reinstall_sub(\(%:  ok1 => &ok ))

ok type::is_code($sub_ref) => 'reinstall returns code ref'

is_deeply &ok, $sub_ref                 => 'reinstall returns correct code ref'

ok1(1                                    => 'reinstalled sub runs')


# Install the same sub in the same package...

$^WARN_HOOK = sub($error) { ok 0 => "warned unexpected:  $($error->message)" if $error->message =~ m/redefined/ }

$sub_ref = main->reinstall_sub(\(%:  ok1 => &is ))

ok type::is_code($sub_ref) => 'reinstall2 returns code ref'

is_deeply &is, $sub_ref                 => 'reinstall2 returns correct code ref'

ok1(1,1                                  => 'reinstalled sub reruns')

# Install in another package...

$sub_ref = Other->reinstall_sub(\(%:  ok2 => &ok ))

ok type::is_code($sub_ref) => 'reinstall2 returns code ref'

is_deeply &ok, $sub_ref                 => 'reinstall2 returns correct code ref'

ok1(1,1                                  => 'reinstalled sub reruns')

package Other

ok2(1                                    => 'remotely reinstalled sub runs')
