use Sub::Install < qw(install_sub)
use Test::More 'no_plan'

use warnings

sub source_method($package)
    return $package


do # install named method and let the name be the same
    install_sub(\(%:  code => "source_method", into => "By::Name" ))

    is(
            By::Name->source_method,
            'By::Name',
            "method installed by name"
            )


do # install via a coderef without name names an error
    dies_like( { install_sub(\(%:  code => &source_method, into => "By::Ref" )) },
             qr/couldn't determine name under which to install subroutine/ )

