use Sub::Install
use Test::More tests => 4

use warnings

BEGIN { use_ok('Sub::Install'); }

package Bar
do { no warnings 'once';
    *import = Sub::Install::exporter \(%:  exports => \ qw(foo)  );
}
sub foo { return 10; }

package main

dies_like({ Bar->import('bar'); },
          qr/'bar' is not exported/, "exception on bad import")

dies_like({ foo(); },
          qr/Undefined subroutine/, "foo isn't imported yet")

Bar->import(< qw(foo))
is(foo(), 10, "foo imported from Bar OK")
