use Sub::Install < qw(install_sub)
use Test::More 'no_plan'

use warnings

do # you have to install /something/!
    dies_like( { install_sub(\(%:  into => "Doesn't::Matter" )); },
             qr/code.+not optional/, "you must supply something to install")


do # you can't just make names up and expect Sub::Install to know what you mean
    dies_like( { install_sub(\(%:  code => 'none_such', into => 'Whatever' )); },
             qr/couldn't find subroutine/, "error on unfound sub name")


do # can't install anonymous subs without a name
    dies_like( { install_sub(\(%:  code => sub (@< @_) { return 1; } )); },
             qr/couldn't determine name/, "anon subs need names to install")

