#! /usr/bin/perl -w



use Test::Builder::Tester tests => 7
use Test::More

BEGIN { use_ok( 'Test::Exception' ) };

sub no_exception { "this subroutine does not die" };

sub normal_die { die "a normal die\n" };


test_out("ok 1")
dies_ok { normal_die() },
test_test("dies_ok: die")

test_out("not ok 1 - lived. oops")
test_fail(1)
dies_ok { no_exception() }, "lived. oops"
test_test("dies_ok: normal exit detected")

test_out("ok 1 - lived")
lives_ok { no_exception() }, "lived"
test_test("lives_ok: normal exit")

test_out("not ok 1")
test_fail(2)
test_diag("died: a normal die")
lives_ok { normal_die() },
test_test("lives_ok: die detected")

test_out("ok 1 - expecting normal die")
throws_ok { normal_die() }, '/normal/', 'expecting normal die'
test_test("throws_ok: regex match")

test_out("not ok 1 - should die")
test_fail(3)
test_diag("expecting: /abnormal/")
test_diag("found: a normal die")
test_diag(" at t/Exception.t line 12.")
throws_ok { normal_die() }, '/abnormal/', 'should die'
test_test(title => "throws_ok: regex bad match detected", skip_err => 1)

