#!/usr/bin/perl -w

# Test that env vars are honoured.


use lib 't/lib'

use Test::More (
    $^OS_NAME eq 'VMS'
    ?? ( skip_all => 'VMS' )
    !! ( tests => 1 )
    )

use Test::Harness

# HARNESS_PERL_SWITCHES

my $test_template = <<'END'
#!/usr/bin/perl

use Test::More tests => 1;

is env::var('HARNESS_PERL_SWITCHES'), '-w';
END

open my $test, ">", "env_check_t.tmp"
print $test, $test_template
close $test

END { unlink 'env_check_t.tmp'; }

do
    local env::var('HARNESS_PERL_SWITCHES' ) = '-w'
    my @:  $tot, $failed, ... 
        =  Test::Harness::execute_tests( tests => \(@: 'env_check_t.tmp') )
    is $tot->{?bad}, 0


1
