package util

use IO::File

# mostly stolen from Module::Build MBTest.pm

do    # backwards compatible temp filename recipe adapted from perlfaq
    my $tmp_count = 0
    my $tmp_base_name = sprintf( "\%d-\%d", $^PID, time() )

    sub temp_file_name
        sprintf( "\%s-\%04d", $tmp_base_name, ++$tmp_count )
    

########################################################################

sub save_handle( $handle, $subr)
    my $outfile = temp_file_name()

    my $saveout
    open $saveout, ">&", "" . fileno($handle)
        or die "Can't save output handle: $^OS_ERROR"
    open $handle, ">", "$outfile" or die "Can't create $outfile: $^OS_ERROR"

    try { $subr->() }
    my $err = $^EVAL_ERROR
    open $handle, ">&", $saveout or die "Can't restore output: $^OS_ERROR"

    my $ret = slurp($outfile)
    1 while unlink $outfile
    $err and die $err
    return $ret


sub stdout_of { save_handle( $^STDOUT, < @_ ) }
sub stderr_of { save_handle( $^STDERR, < @_ ) }

sub stdout_stderr_of
    my $subr = shift
    my ( $stdout, $stderr )
    $stdout = stdout_of(
        sub (@< @_)
            $stderr = stderr_of($subr)
        
        )
    return ( (@:  $stdout, $stderr ) )


sub slurp
    my $fh = IO::File->new( @_[0] ) or die "Can't open @_[0]: $^OS_ERROR"
    local $^INPUT_RECORD_SEPARATOR = undef
    return scalar ~< $fh


1

# vim:ts=4:sw=4:et:sta
