package Test::Object::Test

use Carp         ()
use Scalar::Util ()

our ($VERSION)
BEGIN 
    $VERSION = '0.07'






#####################################################################
# Constructor and Accessors

sub new
    my $class = shift
    my $self  = bless \(%:  < @_ ), $class

    # Check params
    unless ( _CLASS($self->class) )
        die("Did not provide a valid test class")

    unless ( _CODELIKE($self->code) )
        die("Did not provide a valid CODE or callable object")

    $self


sub class
    @_[0]->{?class}


sub tests
    @_[0]->{?tests}


sub code
    @_[0]->{?code}






#####################################################################
# Main Methods

sub run
    @_[0]->code->( @_[1] )






#####################################################################
# Support Functions

# Stolen from Params::Util to avoid adding a dependency needlessly

sub _CLASS ($v)
    (defined $v and ! ref $v and $v =~ m/^[^\W\d]\w*(?:::\w+)*$/s) ?? $v !! undef


sub _CODELIKE($v)
    return type::is_code($v)


1
