# -*- perl -*-


require Text::CSV_XS


my($testNum) = 0
sub Test($result)
    $testNum++
    print($^STDOUT, ($result ?? "" !! "not "), "ok $testNum\n")
    $result


$^OUTPUT_AUTOFLUSH = 1
print $^STDOUT, "1..15\n"

my(@: @binFields) =@:  (@: "abc\0def\n\rghi", "ab\"ce,\032\"'", "\377")

my $csv = Text::CSV_XS->new(\(%: 'binary' => 1))
Test($csv->combine(< @binFields)) or print $^STDOUT, "Failed to encode binary fields\n"
my $string = $csv->string()
Test($string eq qq("abc"0def\n\rghi","ab""ce,\032""'",\377))
    or printf($^STDOUT, "Encode: Expected \n\%s\n, got \n\%s\n",
    unpack("H*", qq("abc"0def\n\rghi","ab""ce,\032""'")),
    unpack("H*", $string))
Test($csv->parse($string)) or print $^STDOUT, "Failed to decode binary fields\n"
Test(nelems($csv->fields()) == nelems(@binFields)) or print $^STDOUT, "Wrong number of fields.\n"
Test($csv->fields[0] eq @binFields[0])
    or printf($^STDOUT, "Field 0: Expected \%s, got \%s.\n",
    @binFields[0], $csv->fields[0])
Test($csv->fields[1] eq @binFields[1])
    or printf($^STDOUT, "Field 1: Expected \%s, got \%s.\n",
    @binFields[1], $csv->fields[1])
Test($csv->fields[2] eq @binFields[2])
    or printf($^STDOUT, "Field 1: Expected \%s, got \%s.\n",
    @binFields[1], $csv->fields[1])
$csv->{+'eol'} = "\r\n"
Test($csv->combine(< @binFields)) or print $^STDOUT, "Failed to encode binary fields\n"
$string = $csv->string()
Test($string eq qq("abc"0def\n\rghi","ab""ce,\032""'",\377\r\n))
    or printf($^STDOUT, "Encode: Expected \n\%s\n, got \n\%s\n",
    unpack("H*", qq("abc"0def\n\rghi","ab""ce,\032""'")),
    unpack("H*", $string))
$csv->{+'eol'} = "\n"
Test($csv->combine(< @binFields)) or print $^STDOUT, "Failed to encode binary fields\n"
$string = $csv->string()
Test($string eq qq("abc"0def\n\rghi","ab""ce,\032""'",\377\n))
    or printf($^STDOUT, "Encode: Expected \n\%s\n, got \n\%s\n",
    unpack("H*", qq("abc"0def\n\rghi","ab""ce,\032""'")),
    unpack("H*", $string))
$csv->{+'quote_char'} = undef
Test($csv->combine("abc","def","ghi"))
Test($csv->string() eq qq(abc,def,ghi\n))


# Ken's test
do
    my $csv2 = Text::CSV_XS->new(\(%: 'always_quote' => 1))
    Test($csv2->combine("abc","def","ghi"))
    Test($csv2->string() eq qq("abc","def","ghi"))
        or printf($^STDOUT, "Expected \%s, got \%s.\n", qq("abc","def","ghi"), <
        $csv2->string())

