#!/usr/local/bin/perl -w


use Test::More
use Text::Diff

my @A = map { "$_\n" }, qw( 1 2 3 4 )
my @B = map { "$_\n" }, qw( 1 2 3 5 )

my $A = join "", @A
my $B = join "", @B

my $Af = "io_A"
my $Bf = "io_B"

open my $a_fh, ">", "$Af" or die $^OS_ERROR; print $a_fh, < @A or die $^OS_ERROR ; close $a_fh or die $^OS_ERROR 
open my $b_fh, ">", "$Bf" or die $^OS_ERROR; print $b_fh, < @B or die $^OS_ERROR ; close $b_fh or die $^OS_ERROR 

my @tests = @: 
    sub (@< @_) { ok !diff \@A, \@A }
    sub (@< @_)
        my $d = diff \@A, \@B
        $d =~ m/-4.*\+5/s ?? ok 1 !! is $d, "a valid diff"

    sub (@< @_) { ok !diff \$A, \$A }
    sub (@< @_)
        my $d = diff \$A, \$B
        $d =~ m/-4.*\+5/s ?? ok 1 !! is $d, "a valid diff"

    sub (@< @_) { ok !diff $Af, $Af }
    sub (@< @_)
        my $d = diff $Af, $Bf
        $d =~ m/-4.*\+5/s ?? ok 1 !! is $d, "a valid diff"

    sub (@< @_)
        open my $a1, "<", "$Af" or die $^OS_ERROR
        open my $a2, "<", "$Af" or die $^OS_ERROR
        ok !diff \$a1->*, \$a2->*
        close $a1
        close $a2

    sub (@< @_)
        open my $a, "<", "$Af" or die $^OS_ERROR
        open my $b, "<", "$Bf" or die $^OS_ERROR
        my $d = diff \$a->*, \$b->*
        $d =~ m/-4.*\+5/s ?? ok 1 !! is $d, "a valid diff"
        close $a
        close $b

    sub (@< @_)
        ok !diff sub (@< @_) { \@A}, sub (@< @_) { \@A }

    sub (@< @_)
        my $d = diff sub (@< @_) { \@A }, sub (@< @_) { \@B }
        $d =~ m/-4.*\+5/s ?? ok 1 !! is $d, "a valid diff"



plan tests => scalar nelems(@tests)

for (@tests)
    $_->()

unlink "io_A" or warn $^OS_ERROR
unlink "io_B" or warn $^OS_ERROR
