#!/usr/local/bin/perl -w


use Test::More
use Text::Diff

sub t( $a, $b, $exp_a, $exp_b)
    my $d = diff \$a, \$b, \%:  STYLE => "Table" 
    my $re = qr/^\*.*\|\Q$exp_a\E\s*\|\Q$exp_b\E\s*\*$/m

    ## Older Test.pms don't support ok( $foo, qr// );
    $d =~ $re
        ?? ok 1
        !! is "\n" . $d, "a match for " . $re


sub slurp { open my $slurp, "<", "" . shift or die $^OS_ERROR ; return join "", (@:  ~< $slurp->*) }

my @tests = @: 
    sub () { t " ",  "\t",  "\\s", "\\t" }
    sub () { t " a", "\ta", " a", "\\ta" }
    sub () { t "a ", "a\t", "a\\s", "a\\t" }
    sub () { t "\t", "\\t", "\\t", "\\\\t" }
    sub () { t "\ta", "\tb", "        a", "        b" }
    sub () { t "-\ta", "-\tb", "-       a", "-       b" }
    sub () { t "\\ta", "\\tb", "\\ta", "\\tb" }
    

plan tests => nelems(@tests)

for (@tests)
  $_->()
