package URI::_query

use URI ()
use URI::Escape < qw(uri_unescape)

sub query
    my $self = shift
    $self->$ =~ m,^([^?\#]*)(?:\?([^\#]*))?(.*)$,s or die

    if (nelems(@_))
        my $q = shift
        $self->$ = $1
        if (defined $q)
            $q =~ s/([^$URI::uric])/%URI::Escape::escapes{?$1}/go
            $self->$ .= "?$q"

        $self->$ .= $3

    $2


# Handle ...?foo=bar&bar=foo type of query
sub query_form
    my $self = shift
    my $old = $self->query
    if (nelems(@_))
        # Try to set query string
        my @new = @_
        if (nelems(@new) == 1)
            my $n = @new[0]
            if (ref($n) eq "ARRAY")
                @new = $n->@
            elsif (ref($n) eq "HASH")
                @new = @:< $n->%

        my @query
        while (my (@: ?$key,?$vals) =(@:  splice(@new, 0, 2)))
            $key = '' unless defined $key
            $key =~ s/([;\/?:@&=+,\$\[\]%])/%URI::Escape::escapes{?$1}/g
            $key =~ s/ /+/g
            $vals = \@: ref($vals) eq "ARRAY" ?? < $vals->@ !! $vals
            for my $val ($vals->@)
                $val = '' unless defined $val
                $val =~ s/([;\/?:@&=+,\$\[\]%])/%URI::Escape::escapes{?$1}/g
                $val =~ s/ /+/g
                push(@query, "$key=$val")

        $self->query(nelems(@query) ?? join('&', @query) !! undef)

    return if !defined($old) || !length($old)
    return unless $old =~ m/=/ # not a form
    return map { s/\+/ /g; uri_unescape($_) },
        @+: map { m/=/ ?? split(m/=/, $_, 2) !! (@: $_ => '')}, split(m/&/, $old)


# Handle ...?dog+bones type of query
sub query_keywords
    my $self = shift
    my $old = $self->query
    if (nelems(@_))
        # Try to set query string
        my @copy = @_
        @copy = @copy[0]->@ if nelems(@copy) == 1 && ref(@copy[0]) eq "ARRAY"
        for ( @copy) { s/([;\/?:@&=+,\$\[\]%])/%URI::Escape::escapes{?$1}/g; }
        $self->query(nelems(@copy) ?? join('+', @copy) !! undef)

    return if !defined($old)
    return if $old =~ m/=/  # not keywords, but a form
    return  map { uri_unescape($_) }, split(m/\+/, $old, -1)


# Some URI::URL compatibility stuff
*equery = &query

1
