package URI::mailto  # RFC 2368

require URI
require URI::_query
our @ISA=qw(URI URI::_query)


sub to
    my $self = shift
    my @old = $self->headers
    if (nelems(@_))
        my @new = @old
        # get rid of any other to: fields
        my $i = 0
        while ( $i +< nelems(@new) )
            if (lc(@new[?$i] || '') eq "to")
                splice(@new, $i, 2)
                redo
            
            $i += 2
        

        my $to = shift
        $to = "" unless defined $to
        unshift(@new, "to" => $to)
        $self->headers(< @new)
    

    my @to
    while (nelems(@old))
        my $h = shift @old
        my $v = shift @old
        push(@to, $v) if lc($h) eq "to"
    
    join(",", @to)



sub headers
    my $self = shift

    # The trick is to just treat everything as the query string...
    my $opaque = "to=" . $self->opaque
    $opaque =~ s/\?/&/

    if (nelems(@_))
        my @new = @_

        # strip out any "to" fields
        my @to
        my $i = 0
        while ($i +< nelems(@new))
            if (lc(@new[?$i] || '') eq "to")
                push(@to, (@: splice(@new, $i, 2))[1])  # remove header
                redo
            
            $i += 2
        

        my $new = join(",", @to)
        $new =~ s/%/\%25/g
        $new =~ s/\?/\%3F/g
        $self->opaque($new)
        $self->query_form(< @new) if nelems(@new)
    

    # I am lazy today...
    URI->new("mailto:?$opaque")->query_form


1
