package URI::news  # draft-gilman-news-url-01

require URI::_server
our @ISA=qw(URI::_server)

use URI::Escape < qw(uri_unescape)
use Carp ()

sub default_port { 119 }

#   newsURL      =  scheme ":" [ news-server ] [ refbygroup | message ]
#   scheme       =  "news" | "snews" | "nntp"
#   news-server  =  "//" server "/"
#   refbygroup   = group [ "/" messageno [ "-" messageno ] ]
#   message      = local-part "@" domain

sub _group
    my $self = shift
    my $old = $self->path
    if (nelems(@_))
        my (@: $group,?$from,?$to) =  @_
        if ($group =~ m/\@/)
            $group =~ s/^<(.*)>$/$1/  # "<" and ">" should not be part of it
        
        $group =~ s,%,\%25,g
        $group =~ s,/,\%2F,g
        my $path = $group
        if (defined $from)
            $path .= "/$from"
            $path .= "-$to" if defined $to
        
        $self->path($path)
    

    $old =~ s,^/,,
    if ($old !~ m/\@/ && $old =~ s,/(.*),,)
        my $extra = $1
        return ( (@: uri_unescape($old), < split(m/-/, $extra) ))
    
    @:  uri_unescape($old) 



sub group
    my $self = shift
    if (nelems(@_))
        Carp::croak("Group name can't contain '\@'") if @_[0] =~ m/\@/
    
    my @old = $self->_group(< @_)
    return if @old[0] =~ m/\@/
    return @old


sub message
    my $self = shift
    if (nelems(@_))
        Carp::croak("Message must contain '\@'") unless @_[0] =~ m/\@/
    
    my $old = $self->_group(< @_)[0]
    return unless $old =~ m/\@/
    return $old


1
