#!perl -w

use Test::More

plan tests => 8

use URI::Escape

is(uri_escape("|abcå"), "\%7Cabc\%C3\%A5")
is(uri_escape("abc", "b-d"), "a\%62\%63")

ok( ! defined(uri_escape(undef)) )

is(uri_unescape("\%7Cabc\%e5"), "|abc\x[e5]")

use URI::Escape < qw(%escapes)

is(%escapes{?"\%"}, "\%25")


use URI::Escape < qw(uri_escape)

is(uri_escape("|abcå"), "\%7Cabc\%C3\%A5")

use utf8
is(uri_escape("abc" . utf8::chr(300)), "abc\%C4\%AC")

is(uri_escape(utf8::chr(0xFFF)), "\%E0\%BF\%BF")


