#!perl -w

use env

if (-f "OFFLINE")
    print $^STDOUT, "1..0"
    exit


print $^STDOUT, "1..15\n"

use URI::Heuristic < qw(uf_uristr uf_url)
if (shift(@ARGV))
    $URI::Heuristic::DEBUG++
    open($^STDERR, ">&", $^STDOUT)  # redirect STDERR


print $^STDOUT, "not " unless uf_uristr("http://www.sn.no/") eq "http://www.sn.no/"
print $^STDOUT, "ok 1\n"

if ($^OS_NAME eq "MacOS")
    print $^STDOUT, "not " unless uf_uristr("etc:passwd") eq "file:/etc/passwd"
else
    print $^STDOUT, "not " unless uf_uristr("/etc/passwd") eq "file:/etc/passwd"

print $^STDOUT, "ok 2\n"

if ($^OS_NAME eq "MacOS")
    print $^STDOUT, "not " unless uf_uristr(":foo.txt") eq "file:./foo.txt"
else
    print $^STDOUT, "not " unless uf_uristr("./foo.txt") eq "file:./foo.txt"

print $^STDOUT, "ok 3\n"

print $^STDOUT, "not " unless uf_uristr("ftp.aas.no/lwp.tar.gz") eq "ftp://ftp.aas.no/lwp.tar.gz"
print $^STDOUT, "ok 4\n"

if($^OS_NAME eq "MacOS")
    #  its a weird, but valid, MacOS path, so it can't be left alone
    print $^STDOUT, "not " unless uf_uristr("C:\\CONFIG.SYS") eq "file:/C/\%5CCONFIG.SYS"
else
    print $^STDOUT, "not " unless uf_uristr("C:\\CONFIG.SYS") eq "file:C:\\CONFIG.SYS"

print $^STDOUT, "ok 5\n"

if (gethostbyname("www.netscape.com"))
    # DNS probably work, lets run test 6..8

    $URI::Heuristic::MY_COUNTRY = "bv"
    print $^STDOUT, "not " unless uf_uristr("perl/camel.gif") eq "http://www.perl.com/camel.gif"
    print $^STDOUT, "ok 6\n"

    $URI::Heuristic::MY_COUNTRY = "uk"
    print $^STDOUT, "not " unless uf_uristr("perl/camel.gif") =~ m,^http://www\.perl\.(org|co)\.uk/camel\.gif$,
    print $^STDOUT, "ok 7\n"

    env::var('URL_GUESS_PATTERN' ) = "www.ACME.org www.ACME.com"
    print $^STDOUT, "not " unless uf_uristr("perl") eq "http://www.perl.org"
    print $^STDOUT, "ok 8\n"

else
    # don't make the inocent worry
    print $^STDOUT, "Skipping test 6-8 because DNS does not work\n"
    for (6..8) { print $^STDOUT, "ok $_\n"; }



do
    local env::var('URL_GUESS_PATTERN' ) = ""
    print $^STDOUT, "not " unless uf_uristr("perl") eq "http://perl"
    print $^STDOUT, "ok 9\n"

    print $^STDOUT, "not " unless uf_uristr("http:80") eq "http:80"
    print $^STDOUT, "ok 10\n"

    print $^STDOUT, "not " unless uf_uristr("mailto:gisle\@aas.no") eq "mailto:gisle\@aas.no"
    print $^STDOUT, "ok 11\n"

    print $^STDOUT, "not " unless uf_uristr("gisle\@aas.no") eq "mailto:gisle\@aas.no"
    print $^STDOUT, "ok 12\n"

    print $^STDOUT, "not " unless uf_uristr("Gisle.Aas\@aas.perl.org") eq "mailto:Gisle.Aas\@aas.perl.org"
    print $^STDOUT, "ok 13\n"

    print $^STDOUT, "not " unless uf_url("gopher.sn.no")->scheme eq "gopher"
    print $^STDOUT, "ok 14\n"

    print $^STDOUT, "not " unless uf_uristr("123.3.3.3:8080/foo") eq "http://123.3.3.3:8080/foo"
    print $^STDOUT, "ok 15\n"


#
#print "not " unless uf_uristr("some-site") eq "http://www.some-site.com";
#print "ok 15\n";
#
#print "not " unless uf_uristr("some-site.com") eq "http://some-site.com";
#print "ok 16\n";
#
