#!perl -w

print $^STDOUT, "1..13\n"

use URI

my $u = URI->new("<http://www.perl.com/path?q=f\x[F4]o>")

#print "$u\n";
print $^STDOUT, "not " unless $u->as_string eq "http://www.perl.com/path?q=f\%F4o"
print $^STDOUT, "ok 1\n"

print $^STDOUT, "not " unless $u->port == 80
print $^STDOUT, "ok 2\n"

# play with port
my $old = $u->port(8080)
print $^STDOUT, "not " unless $old == 80 && $u->as_string eq "http://www.perl.com:8080/path?q=f\%F4o"
print $^STDOUT, "ok 3\n"

$u->port(80)
print $^STDOUT, "not " unless $u->as_string eq "http://www.perl.com:80/path?q=f\%F4o"
print $^STDOUT, "ok 4\n"

$u->port("")
print $^STDOUT, "not " unless $u->as_string eq "http://www.perl.com:/path?q=f\%F4o" && $u->port == 80
print $^STDOUT, "ok 5\n"

$u->port(undef)
print $^STDOUT, "not " unless $u->as_string eq "http://www.perl.com/path?q=f\%F4o"
print $^STDOUT, "ok 6\n"

my @q = $u->query_form
print $^STDOUT, "not " unless nelems(@q) == 2 && "$(join ' ',@q)" eq "q f\x[F4]o"
print $^STDOUT, "ok 7\n"

$u->query_form(foo => "bar", bar => "baz")
print $^STDOUT, "not " unless $u->query eq "foo=bar&bar=baz"
print $^STDOUT, "ok 8\n"

print $^STDOUT, "not " unless $u->host eq "www.perl.com"
print $^STDOUT, "ok 9\n"

print $^STDOUT, "not " unless $u->path eq "/path"
print $^STDOUT, "ok 10\n"

$u->scheme("https")
print $^STDOUT, "not " unless $u->port == 443
print $^STDOUT, "ok 11\n"

print $^STDOUT, "not " unless $u->as_string eq "https://www.perl.com/path?foo=bar&bar=baz"
print $^STDOUT, "ok 12\n"

$u = URI->new("http://\%77\%77\%77\%2e\%70\%65\%72\%6c\%2e\%63\%6f\%6d/\%70\%75\%62/\%61/\%32\%30\%30\%31/\%30\%38/\%32\%37/\%62\%6a\%6f\%72\%6e\%73\%74\%61\%64\%2e\%68\%74\%6d\%6c")
print $^STDOUT, "not " unless $u->canonical->as_string eq "http://www.perl.com/pub/a/2001/08/27/bjornstad.html"
print $^STDOUT, "ok 13\n"

