#!perl -w

print $^STDOUT, "1..7\n"

use URI

my $u = URI->new('mailto:gisle@aas.no')

print $^STDOUT, "not " unless $u->to eq 'gisle@aas.no' &&
    $u->as_string eq 'mailto:gisle@aas.no'
print $^STDOUT, "ok 1\n"

my $old = $u->to('larry@wall.org')
print $^STDOUT, "not " unless $old eq 'gisle@aas.no' &&
    $u->to eq 'larry@wall.org' &&
    $u->as_string eq 'mailto:larry@wall.org'
print $^STDOUT, "ok 2\n"

$u->to("?/#")
print $^STDOUT, "not " unless $u->to eq "?/#" &&
    $u->as_string eq 'mailto:%3F/%23'
print $^STDOUT, "ok 3\n"

my @h = $u->headers
print $^STDOUT, "not " unless nelems(@h) == 2 && "$(join ' ',@h)" eq "to ?/#"
print $^STDOUT, "ok 4\n"

$u->headers(to      => 'gisle@aas.no',
    cc      => 'gisle@ActiveState.com,larry@wall.org',
    Subject => 'How do you do?',
    garbage => '/;?#=&',
    )

@h = $u->headers
print $^STDOUT, "not " unless $u->to eq 'gisle@aas.no' &&
    nelems(@h) == 8 &&
    "$(join ' ',@h)" eq 'to gisle@aas.no cc gisle@ActiveState.com,larry@wall.org Subject How do you do? garbage /;?#=&'
print $^STDOUT, "ok 5\n"

#print "$u\n";
print $^STDOUT, "not " unless $u->as_string eq 'mailto:gisle@aas.no?cc=gisle%40ActiveState.com%2Clarry%40wall.org&Subject=How+do+you+do%3F&garbage=%2F%3B%3F%23%3D%26'
print $^STDOUT, "ok 6\n"

$u = URI->new("mailto:")
$u->to("gisle")
print $^STDOUT, "not " unless $u->as_string eq 'mailto:gisle'
print $^STDOUT, "ok 7\n"
