#!perl -w

print $^STDOUT, "1..6\n"

# Test mixing of URI and URI::WithBase objects
use URI
use URI::WithBase
use URI::URL

my $str = "http://www.sn.no/"
my $rel = "path/img.gif"

my $u  = URI->new($str)
my $uw = URI::WithBase->new($str, "http:")
my $uu = URI::URL->new($str)

our ($a, $b, $c, $d)

sub Dump
    require Data::Dumper
    print $^STDOUT, < Data::Dumper->Dump(\(@: $a, $b, $c, $d), \qw(a b c d))


$a = URI->new($rel, $u)
$b = URI->new($rel, $uw)
$c = URI->new($rel, $uu)
$d = URI->new($rel, $str)

#Dump();
print $^STDOUT, "not " unless $a->isa("URI") &&
    ref($b) eq ref($uw) &&
    ref($c) eq ref($uu) &&
    $d->isa("URI")
print $^STDOUT, "ok 1\n"

print $^STDOUT, "not " if $b->base && $c->base
print $^STDOUT, "ok 2\n"

$a = URI::URL->new($rel, $u)
$b = URI::URL->new($rel, $uw)
$c = URI::URL->new($rel, $uu)
$d = URI::URL->new($rel, $str)

print $^STDOUT, "not " unless ref($a) eq "URI::URL" &&
    ref($b) eq "URI::URL" &&
    ref($c) eq "URI::URL" &&
    ref($d) eq "URI::URL"
print $^STDOUT, "ok 3\n"

print $^STDOUT, "not " unless ref($b->base) eq ref($uw) &&
    $b->base->as_string eq $uw->as_string &&
    ref($c->base) eq ref($uu) &&
    $c->base->as_string eq $uu->as_string &&
    $d->base->as_string eq $str
print $^STDOUT, "ok 4\n"



$a = URI->new($uu->as_string, $u)
$b = URI->new($uu->as_string, $uw)
$c = URI->new($uu->as_string, $uu)
$d = URI->new($uu->as_string, $str)

#Dump();
print $^STDOUT, "not " unless ref($a) eq ref($b) &&
    ref($b) eq ref($c) &&
    ref($c) eq ref($d) &&
    ref($d) eq ref($u)
print $^STDOUT, "ok 5\n"

$a = URI::URL->new($u->as_string, $u)
$b = URI::URL->new($u->as_string, $uw)
$c = URI::URL->new($u->as_string, $uu)
$d = URI::URL->new($u->as_string, $str)

print $^STDOUT, "not " unless ref($a) eq "URI::URL" &&
    ref($b) eq "URI::URL" &&
    ref($c) eq "URI::URL" &&
    ref($d) eq "URI::URL"
print $^STDOUT, "ok 6\n"
