#!perl -w

print $^STDOUT, "1..7\n"

use URI

my $u = URI->new("news:comp.lang.perl.misc")

print $^STDOUT, "not " unless $u->group[0] eq "comp.lang.perl.misc" &&
    !defined($u->message) &&
    $u->port == 119 &&
    $u->as_string eq "news:comp.lang.perl.misc"
print $^STDOUT, "ok 1\n"


$u->host("news.online.no")
print $^STDOUT, "not " unless $u->group[0] eq "comp.lang.perl.misc" &&
    $u->port == 119 &&
    $u->as_string eq "news://news.online.no/comp.lang.perl.misc"
print $^STDOUT, "ok 2\n"

$u->group("no.perl", 1 => 10)
print $^STDOUT, "not " unless $u->as_string eq "news://news.online.no/no.perl/1-10"
print $^STDOUT, "ok 3\n"

my @g = $u->group
#print "G: @g\n";
print $^STDOUT, "not " unless nelems(@g) == 3 && "$(join ' ',@g)" eq "no.perl 1 10"
print $^STDOUT, "ok 4\n"

$u->message('42@g.aas.no')
#print "$u\n";
print $^STDOUT, "not " unless $u->message eq '42@g.aas.no' &&
    !defined($u->group) &&
    $u->as_string eq 'news://news.online.no/42@g.aas.no'
print $^STDOUT, "ok 5\n"


$u = URI->new("nntp:no.perl")
print $^STDOUT, "not " unless $u->group[0] eq "no.perl" &&
    $u->port == 119
print $^STDOUT, "ok 6\n"

$u = URI->new("snews://snews.online.no/no.perl")

print $^STDOUT, "not " unless $u->group[0] eq "no.perl" &&
    $u->host  eq "snews.online.no" &&
    $u->port == 563
print $^STDOUT, "ok 7\n"

