#!perl -w

print $^STDOUT, "1..6\n"

use URI::URL < qw(url)

# Test configuration via some global variables.

$URI::URL::ABS_REMOTE_LEADING_DOTS = 1
$URI::URL::ABS_ALLOW_RELATIVE_SCHEME = 1

my $u1 = url("../../../../abc", "http://web/a/b")

print $^STDOUT, "not " unless $u1->abs->as_string eq "http://web/abc"
print $^STDOUT, "ok 1\n"

do
    local $URI::URL::ABS_REMOTE_LEADING_DOTS = undef
    print $^STDOUT, "not " unless $u1->abs->as_string eq "http://web/../../../abc"
    print $^STDOUT, "ok 2\n"



$u1 = url("http:../../../../abc", "http://web/a/b")
print $^STDOUT, "not " unless $u1->abs->as_string eq "http://web/abc"
print $^STDOUT, "ok 3\n"

do
    local $URI::URL::ABS_ALLOW_RELATIVE_SCHEME = undef
    print $^STDOUT, "not " unless $u1->abs->as_string eq "http:../../../../abc"
    print $^STDOUT, "ok 4\n"
    print $^STDOUT, "not " unless $u1->abs(undef,1)->as_string eq "http://web/abc"
    print $^STDOUT, "ok 5\n"


print $^STDOUT, "not " unless $u1->abs(undef,0)->as_string eq "http:../../../../abc"
print $^STDOUT, "ok 6\n"
