#!perl -w

print $^STDOUT, "1..5\n"

use URI::URL

# We used to have problems with URLs that used a base that was
# not absolute itself.

my $u1 = url("/foo/bar", "http://www.acme.com/")
my $u2 = url("../foo/", $u1)
my $u3 = url("zoo/foo", $u2)

my $a1 = $u1->abs->as_string
my $a2 = $u2->abs->as_string
my $a3 = $u3->abs->as_string

print $^STDOUT, "$a1\n$a2\n$a3\n"

print $^STDOUT, "not " unless $a1 eq "http://www.acme.com/foo/bar"
print $^STDOUT, "ok 1\n"
print $^STDOUT, "not " unless $a2 eq "http://www.acme.com/foo/"
print $^STDOUT, "ok 2\n"
print $^STDOUT, "not " unless $a3 eq "http://www.acme.com/foo/zoo/foo"
print $^STDOUT, "ok 3\n"

# We used to have problems with URI::URL as the base class :-(
my $u4 = url("foo", "URI::URL")
my $a4 = $u4->abs
print $^STDOUT, "not " unless $u4->as_string eq "foo" && $a4->as_string eq "uri:/foo"
print $^STDOUT, "ok 4\n"

# Test new_abs for URI::URL objects
print $^STDOUT, "not " unless URI::URL->new_abs("foo", "http://foo/bar")->as_string eq "http://foo/foo"
print $^STDOUT, "ok 5\n"
