#!perl -w

print $^STDOUT, "1..8\n"

use URI

my $u = URI->new('pop://aas@pop.sn.no')

print $^STDOUT, "not " unless $u->user eq "aas" &&
    !defined($u->auth) &&
    $u->host eq "pop.sn.no" &&
    $u->port == 110 &&
    $u->as_string eq 'pop://aas@pop.sn.no'
print $^STDOUT, "ok 1\n"

$u->auth("+APOP")
print $^STDOUT, "not " unless $u->auth eq "+APOP" &&
    $u->as_string eq 'pop://aas;AUTH=+APOP@pop.sn.no'
print $^STDOUT, "ok 2\n"

$u->user("gisle")
print $^STDOUT, "not " unless $u->user eq "gisle" &&
    $u->as_string eq 'pop://gisle;AUTH=+APOP@pop.sn.no'
print $^STDOUT, "ok 3\n"

$u->port(4000)
print $^STDOUT, "not " unless $u->as_string eq 'pop://gisle;AUTH=+APOP@pop.sn.no:4000'
print $^STDOUT, "ok 4\n"

$u = URI->new("pop:")
$u->host("pop.sn.no")
$u->user("aas")
$u->auth("*")
print $^STDOUT, "not " unless $u->as_string eq 'pop://aas;AUTH=*@pop.sn.no'
print $^STDOUT, "ok 5\n"

$u->auth(undef)
print $^STDOUT, "not " unless $u->as_string eq 'pop://aas@pop.sn.no'
print $^STDOUT, "ok 6\n"

$u->user(undef)
print $^STDOUT, "not " unless $u->as_string eq 'pop://pop.sn.no'
print $^STDOUT, "ok 7\n"

# Try some funny characters too
$u->user('fr;k@l')
print $^STDOUT, "not " unless $u->user eq 'fr;k@l' &&
    $u->as_string eq 'pop://f%E5r%3Bk%40l@pop.sn.no'
print $^STDOUT, "ok 8\n"
