#!/usr/bin/perl -w

use Test::More

plan tests => 6

use URI
use URI::WithBase

my $uri = URI->new("http://www.example.com/foo/bar/")

ok( $uri->rel("http://www.example.com/foo/bar/")->as_string eq "./" )
ok( $uri->rel("HTTP://WWW.EXAMPLE.COM/foo/bar/")->as_string eq "./" )
ok( $uri->rel("HTTP://WWW.EXAMPLE.COM/FOO/BAR/")->as_string eq "../../foo/bar/" )
ok( $uri->rel("HTTP://WWW.EXAMPLE.COM:80/foo/bar/")->as_string eq "./" )

my $uri_wb = URI::WithBase->new("/foo/bar", "http://www.example.com/")
is( $uri_wb->rel->as_string, "/foo/bar" )
is( $uri_wb->abs->as_string, "http://www.example.com/foo/bar" )
