#!perl -w

print $^STDOUT, "1..17\n"

use URI::Split < qw(uri_split uri_join)

sub j { join("-", map { defined($_) ?? $_ !! "<undef>" }, @_) }

print $^STDOUT, "not " unless j( <uri_split("p")) eq "<undef>-<undef>-p-<undef>-<undef>"
print $^STDOUT, "ok 1\n"

print $^STDOUT, "not " unless j( <uri_split("p?q")) eq "<undef>-<undef>-p-q-<undef>"
print $^STDOUT, "ok 2\n"

print $^STDOUT, "not " unless j( <uri_split("p#f")) eq "<undef>-<undef>-p-<undef>-f"
print $^STDOUT, "ok 3\n"

print $^STDOUT, "not " unless j( <uri_split("p?q/#f/?")) eq "<undef>-<undef>-p-q/-f/?"
print $^STDOUT, "ok 4\n"

print $^STDOUT, "not " unless j( <uri_split("s://a/p?q#f")) eq "s-a-/p-q-f"
print $^STDOUT, "ok 5\n"

print $^STDOUT, "not " unless uri_join("s", "a", "/p", "q", "f") eq "s://a/p?q#f"
print $^STDOUT, "ok 6\n"

print $^STDOUT, "not " unless uri_join("s", "a", "p", "q", "f") eq "s://a/p?q#f"
print $^STDOUT, "ok 7\n"

print $^STDOUT, "not " unless uri_join(undef, undef, "", undef, undef) eq ""
print $^STDOUT, "ok 8\n"

print $^STDOUT, "not " unless uri_join(undef, undef, "p", undef, undef) eq "p"
print $^STDOUT, "ok 9\n"

print $^STDOUT, "not " unless uri_join("s", undef, "p") eq "s:p"
print $^STDOUT, "ok 10\n"

print $^STDOUT, "not " unless uri_join("s") eq "s:"
print $^STDOUT, "ok 11\n"

print $^STDOUT, "not " unless uri_join() eq ""
print $^STDOUT, "ok 12\n"

print $^STDOUT, "not " unless uri_join("s", "a") eq "s://a"
print $^STDOUT, "ok 13\n"

print $^STDOUT, "not " unless uri_join("s", "a/b") eq "s://a\%2Fb"
print $^STDOUT, "ok 14\n"

print $^STDOUT, "not " unless uri_join("s", ":/?#", ":/?#", ":/?#", ":/?#") eq "s://:\%2F\%3F\%23/:/\%3F\%23?:/?\%23#:/?#"
print $^STDOUT, "ok 15\n"

print $^STDOUT, "not " unless uri_join(undef, undef, "a:b") eq "a\%3Ab"
print $^STDOUT, "ok 16\n"

print $^STDOUT, "not " unless uri_join("s", undef, "//foo//bar") eq "s:////foo//bar"
print $^STDOUT, "ok 17\n"
