#!perl -w

try {
    require Business::ISBN;
}
if ($^EVAL_ERROR)
    print $^STDOUT, "1..0 # Skipped: Needs the Business::ISBN module installed\n\n"
    print $^STDOUT, $^EVAL_ERROR->message
    exit


print $^STDOUT, "1..13\n"

use URI
my $u = URI->new("URN:ISBN:0395363411")

print $^STDOUT, "not " unless $u eq "URN:ISBN:0395363411" &&
    $u->scheme eq "urn" &&
    $u->nid eq "isbn"
print $^STDOUT, "ok 1\n"

print $^STDOUT, "not " unless $u->canonical eq "urn:isbn:0-395-36341-1"
print $^STDOUT, "ok 2\n"

print $^STDOUT, "not " unless $u->isbn eq "0-395-36341-1"
print $^STDOUT, "ok 3\n"

print $^STDOUT, "not " unless $u->isbn_country_code == 0
print $^STDOUT, "ok 4\n"

print $^STDOUT, "not " unless $u->isbn_publisher_code == 395
print $^STDOUT, "ok 5\n"

print $^STDOUT, "not " unless $u->isbn_as_ean eq "9780395363416"
print $^STDOUT, "ok 6\n"

print $^STDOUT, "not " unless $u->nss eq "0395363411"
print $^STDOUT, "ok 7\n"

print $^STDOUT, "not " unless $u->isbn("0-88730-866-x") eq "0-395-36341-1"
print $^STDOUT, "ok 8\n"

print $^STDOUT, "not " unless $u->nss eq "0-88730-866-x"
print $^STDOUT, "ok 9\n"

print $^STDOUT, "not " unless $u->isbn eq "0-88730-866-X"
print $^STDOUT, "ok 10\n"

print $^STDOUT, "not " unless URI::eq("urn:isbn:088730866x", "URN:ISBN:0-88-73-08-66-X")
print $^STDOUT, "ok 11\n"

# try to illegal ones
$u = URI->new("urn:ISBN:abc")
print $^STDOUT, "not " unless $u eq "urn:ISBN:abc"
print $^STDOUT, "ok 12\n"

print $^STDOUT, "not " if $u->nss ne "abc" || defined $u->isbn
print $^STDOUT, "ok 13\n"



