#!perl

use warnings;
use Test::More;

BEGIN {
    eval "use Test::Warn";
    plan skip_all => "Test::Warn required to test $^PROGRAM_NAME" if $^EVAL_ERROR;
    plan tests => 4;
}

BEGIN {
    use_ok( 'WWW::Mechanize' );
}

my $m = WWW::Mechanize->new;
isa_ok( $m, 'WWW::Mechanize' );
 {
    $m->find_link( link_regex => "foo" );
}->
warning_like( qr[Unknown link-finding parameter "link_regex".+line \d+], "Passes message, and includes the line number");
 {
    $m->find_link( url_regex => "foo" );
}->
warning_like( qr[foo passed as url_regex is not a regex.+line \d+], "Passes message, and includes the line number");

