#!perl

use warnings;
use Test::More;

BEGIN {
    eval "use Test::Warn";
    plan skip_all => "Test::Warn required to test warn" if $^EVAL_ERROR;
    plan tests => 6;
}

BEGIN {
    use_ok( 'WWW::Mechanize' );
}

my $m = WWW::Mechanize->new;
isa_ok( $m, 'WWW::Mechanize' );
 {
    $m->warn( "Something bad" );
}->
warning_like( qr[Something bad.+line \d+], "Passes the message, and includes the line number");
 {
    $m->quiet(1);
    $m->warn( "Something bad" );
}->
warning_like( undef, "Quiets correctly");

my $hushed = WWW::Mechanize->new( quiet => 1 );
isa_ok( $hushed, "WWW::Mechanize" );
 {
    $hushed->warn( "Something bad" );
}->warning_like( undef, "Quiets correctly");
