# $Id: SAX.pm 685 2007-09-25 16:28:01Z pajas $
# Copyright (c) 2001-2002, AxKit.com Ltd. All rights reserved.
package XML::LibXML::SAX

our ($VERSION, @ISA)

$VERSION = "1.65" # VERSION TEMPLATE: DO NOT CHANGE

use XML::LibXML
use XML::SAX::Base

use base < qw(XML::SAX::Base)

use Carp
use IO::File

sub _parse_characterstream( $self, $fh)
    # this my catch the xml decl, so the parser won't get confused about
    # a possibly wrong encoding.
    die( "not implemented yet" )


sub _parse_bytestream( $self, $fh)
    $self->{+ParserOptions} //= \ $%
    $self->{ParserOptions}->{+LibParser}      = XML::LibXML->new
    $self->{ParserOptions}->{+ParseFunc}      = &XML::LibXML::parse_fh
    $self->{ParserOptions}->{+ParseFuncParam} = $fh
    return $self->_parse


sub _parse_string( $self, $string)
    $self->{+ParserOptions} //= \ $%
    $self->{+ParserOptions}->{+LibParser}      = XML::LibXML->new()     unless defined $self->{?ParserOptions}->{?LibParser}
    $self->{ParserOptions}->{+ParseFunc}      = &XML::LibXML::parse_string
    $self->{ParserOptions}->{+ParseFuncParam} = $string
    return $self->_parse


sub _parse_systemid
    my $self = shift
    $self->{+ParserOptions} //= \ $%
    $self->{ParserOptions}->{+LibParser}      = XML::LibXML->new
    $self->{ParserOptions}->{+ParseFunc}      = &XML::LibXML::parse_file
    $self->{ParserOptions}->{+ParseFuncParam} = shift
    return $self->_parse


sub parse_chunk( $self, $chunk)
    $self->{ParserOptions}->{+LibParser}      = XML::LibXML->new
    $self->{ParserOptions}->{+ParseFunc}      = &XML::LibXML::parse_xml_chunk
    $self->{ParserOptions}->{+ParseFuncParam} = $chunk
    return $self->_parse


sub _parse
    my $self = shift
    my $args = bless $self->{?ParserOptions}, ref($self)

    $args->{?LibParser}->set_handler( $self )
    try {
        $args->{?ParseFunc}->($args->{?LibParser}, $args->{?ParseFuncParam});
    }

    if ( $args->{LibParser}->{SAX}->{?State} == 1 )
        die( "SAX Exception not implemented, yet; Data ended before document ended\n" )
    

    # break a possible circular reference
    $args->{?LibParser}->set_handler( undef )
    if ( $^EVAL_ERROR )
        die $^EVAL_ERROR
    
    return $self->end_document(\$%)



1

