#!/usr/bin/perl -w

use warnings
use XML::LibXML
use Test::More
BEGIN 
    plan tests => 7
;


# tests for bug #24953: External entities not expanded in included file (XInclude)

my $parser = XML::LibXML->new
my $file = 'test/xinclude/test.xml'
do
    $parser->expand_xinclude(0)
    $parser->expand_entities(1)
    ok($parser->parse_file($file)->toString() !~  m/IT WORKS/)

do
    $parser->expand_xinclude(1)
    $parser->expand_entities(0)
    ok($parser->parse_file($file)->toString() !~  m/IT WORKS/)

do
    $parser->expand_xinclude(1)
    $parser->expand_entities(1)
    ok($parser->parse_file($file)->toString() =~  m/IT WORKS/)

do
    $parser->expand_xinclude(0)
    my $doc = $parser->parse_file($file)
    ok( $doc->process_xinclude(\(%: expand_entities=>0)) )
    ok( $doc->toString()!~m/IT WORKS/ )

do
    my $doc = $parser->parse_file($file)
    ok( $doc->process_xinclude(\(%: expand_entities=>1)) )
    ok( $doc->toString()=~m/IT WORKS/ )

