# $Id: Debug.pm,v 1.1 2003/07/27 16:07:49 matt Exp $

package XML::Parser::Style::Debug

require bytes

sub Start
    my $expat = shift
    my $tag = shift
    print $^STDERR, "$(join ' ',$expat->{?Context}->@) \\\\ ($(join ' ',@_))\n"


sub End
    my $expat = shift
    my $tag = shift
    print $^STDERR, "$(join ' ',$expat->{?Context}->@) //\n"


sub Char
    my $expat = shift
    my $text = shift
    $text =~ s/([\x[80]-\x[ff]])/$(sprintf '#x%X;', < bytes::ord($1))/g
    $text =~ s/([\t\n])/$(sprintf '#\%d;', < bytes::ord($1))/g
    print $^STDERR, "$(join ' ',$expat->{?Context}->@) || $text\n"


sub Proc
    my $expat = shift
    my $target = shift
    my $text = shift
    my @foo = $expat->{?Context}->@
    print $^STDERR, "$(join ' ',@foo) $target($text)\n"


1
__END__

=head1 NAME

XML::Parser::Style::Debug - Debug style for XML::Parser

=head1 SYNOPSIS

  use XML::Parser;
  my $p = XML::Parser->new(Style => 'Debug');
  $p->parsefile('foo.xml');

=head1 DESCRIPTION

This just prints out the document in outline form to STDERR. Nothing special is
returned by parse.

=cut
