
use Test::More tests => 3

use XML::Parser

my $cmnt_count = 0
my $pi_count = 0
my $between_count = 0
my $authseen = 0

sub init
    my $xp = shift
    $xp->skip_until(1)	# Skip through prolog


sub proc
    $pi_count++


sub cmnt
    $cmnt_count++


sub start($xp, $el, ...)
    my $ndx = $xp->element_index
    if (! $authseen and $el eq 'authlist')
        $authseen = 1
        $xp->skip_until(2000)
    elsif ($authseen and $ndx +< 2000)
        $between_count++
    


my $p = XML::Parser->new(Handlers => \(%: Init    => &init
                                          Start   => &start
                                          Comment => &cmnt
                                          Proc    => &proc
    ))

$p->parsefile('samples/REC-xml-19980210.xml')

ok( ! $between_count )

ok( ! $pi_count )

is($cmnt_count, 5)

