
use Test::More tests => 2

use XML::Parser

my $delim = '------------123453As23lkjlklz877'
my $file = 'samples/REC-xml-19980210.xml'
my $tmpfile = 'stream.tmp'

my $cnt = 0


open(my $out_fh, ">", "$tmpfile") or die "Couldn't open $tmpfile for output"
open(my $in_fh, "<", $file) or die "Couldn't open $file for input"

while ( ~< $in_fh->*)
    print $out_fh, $_


close($in_fh)
print $out_fh, "$delim\n"

open($in_fh, "<", $file)
while ( ~< $in_fh->*)
    print $out_fh, $_


close($in_fh)
close($out_fh)

my $parser = XML::Parser->new(Stream_Delimiter => $delim,
    Handlers => \(%: Comment => sub (@< @_) {$cnt++;}))

open(my $foo_fh, "<", $tmpfile)

$parser->parse(\$foo_fh->*)

is($cnt, 37)

$cnt = 0

$parser->parse(\$foo_fh->*)

is($cnt, 37)

close($foo_fh)
unlink($tmpfile)
