use Test::More
BEGIN { plan tests => 8 }
use XML::Parser
use IO::File

my $xmlstr = '<foo>bar</foo>'

do
    # Debug style
    my $parser = XML::Parser->new(Style => 'Debug')
    ok($parser)

    my $tmpfile = IO::File->new_tmpfile()
    open(my $olderr, ">&", $^STDERR)
    open($^STDERR, ">&", "" . $tmpfile->fileno) || die "Cannot re-open STDERR : $^OS_ERROR"

    $parser->parse($xmlstr)

    close($^STDERR)
    open($^STDERR, ">&", $olderr)
    close($olderr)

    seek($tmpfile, 0, 0)
    my $warn = 0
    $warn++ while ( ~< $tmpfile)
    is($warn, 3, "Check we got three warnings out")


do
    # Object style
    my $parser = XML::Parser->new(Style => 'Objects')
    ok($parser)

    my $tree = $parser->parse($xmlstr)
    ok($tree)


do
    # Stream style
    my $parser = XML::Parser->new(Style => 'Stream')
    ok($parser)


do
    # Subs style
    my $parser = XML::Parser->new(Style => 'Subs')
    ok($parser)


do
    # Tree style
    my $parser = XML::Parser->new(Style => 'Tree')
    ok($parser)

    my $tree = $parser->parse($xmlstr)
    is_deeply($tree, (@:  'foo', (@:  $%, 0, 'bar') ) );

