use Test::More
BEGIN { plan tests => 14 }
use XML::SAX::Exception
try {
    XML::SAX::Exception->throw ( Message => "Test" );
}
ok($^EVAL_ERROR) # test died
is($^EVAL_ERROR->stringify, "Test\n") # test stringification
ok($^EVAL_ERROR->isa('XML::SAX::Exception')) # test isa

try {
    XML::SAX::Exception::Parse->throw (
        Message => "Parse",
        LineNumber => 12,
        ColumnNumber => 2,
        SystemId => "throw.xml",
        PublicId => "Some // Public // Identifier",
        );
}
ok($^EVAL_ERROR)
is($^EVAL_ERROR->{?Message}, "Parse")
like($^EVAL_ERROR->stringify, qr/Parse/)
is($^EVAL_ERROR->{?LineNumber}, 12)
ok($^EVAL_ERROR->isa('XML::SAX::Exception::Parse'))

try {
    XML::SAX::Exception::ThisOneDoesNotExist->throw (
        Message => "Fubar",
        );
}
ok($^EVAL_ERROR)
ok(!UNIVERSAL::isa($^EVAL_ERROR, 'XML::SAX::Exception'))

try {
    XML::SAX::Exception::NotRecognized->throw (
        Message => "Not Recognized",
        );
}
ok($^EVAL_ERROR)
ok($^EVAL_ERROR->isa('XML::SAX::Exception'))

try {
    XML::SAX::Exception::NotSupported->throw (
        Message => "Not Supported",
        );
}
ok($^EVAL_ERROR)
ok($^EVAL_ERROR->isa('XML::SAX::Exception'))

