use Test::More
BEGIN { plan tests => 10 }
use XML::SAX::PurePerl
use XML::SAX::PurePerl::DebugHandler
use IO::File

my $handler = XML::SAX::PurePerl::DebugHandler->new()
ok($handler)

my $parser = XML::SAX::PurePerl->new(Handler => $handler)
ok($parser)

my $file = IO::File->new("testfiles/02a.xml")
ok($file)

# check invalid characters
try {
    $parser->parse_file($file);
}
ok($^EVAL_ERROR)
ok($^EVAL_ERROR->{?Message})
is($^EVAL_ERROR->{?LineNumber}, 1)
is($^EVAL_ERROR->{?ColumnNumber}, 6)

# check invalid version number
try {
    $parser->parse_uri("file:testfiles/02b.xml");
}
ok($^EVAL_ERROR)

is($^EVAL_ERROR->{?LineNumber}, 1)
is($^EVAL_ERROR->{?ColumnNumber}, 19)

