use Test::More
BEGIN { plan tests => 6 }
use XML::SAX::PurePerl
use XML::SAX::PurePerl::DebugHandler

my $handler = XML::SAX::PurePerl::DebugHandler->new()
ok($handler)

my $parser = XML::SAX::PurePerl->new(Handler => $handler,
    "http://xml.org/sax/handlers/LexicalHandler" => $handler)
ok($parser)

# check PIs and comments before document element parse ok
$parser->parse_uri("testfiles/03a.xml")
is($handler->{seen}{?processing_instruction}, 2)
ok($handler->{seen}{?comment})

# check invalid version number
try {
    $parser->parse_uri("testfiles/03b.xml");
}
ok($^EVAL_ERROR)
is($^EVAL_ERROR->{?LineNumber}, 4)


