use Test::More
BEGIN { plan tests => 15 }
use XML::SAX::ParserFactory

# load SAX parsers (no ParserDetails.ini available at first in blib)
use XML::SAX < qw(Namespaces Validation)
is(nelems(XML::SAX->parsers->@), 0)
ok(XML::SAX->add_parser(q(XML::SAX::PurePerl)))
is(nelems(XML::SAX->parsers->@), 1)

ok(XML::SAX::ParserFactory->parser) # test class method
my $factory = XML::SAX::ParserFactory->new()
ok($factory)
ok($factory->parser)

ok($factory->require_feature(Namespaces))
ok($factory->parser)

ok($factory->require_feature(Validation))
try {
    my $parser = $factory->parser;
    # should never get here unless PurePerl starts providing validation
    ok(!$parser);
}
ok($^EVAL_ERROR)
ok($^EVAL_ERROR->isa('XML::SAX::Exception'))

$factory = XML::SAX::ParserFactory->new()
my $parser = $factory->parser
ok($parser)

$parser->parse_string('<widget/>')
ok(1)

local $XML::SAX::ParserPackage = 'XML::SAX::PurePerl'
ok(XML::SAX::ParserFactory->parser)

local $XML::SAX::ParserPackage = 'XML::SAX::PurePerl (0.01)'
ok(XML::SAX::ParserFactory->parser)

