use Test::More
BEGIN { plan tests => 11 }

use XML::XPath
ok(1)

my $xp = XML::XPath->new(ioref => $^DATA)
ok($xp)

my @nodes
@nodes = $xp->findnodes('//GGG/ancestor::*')
is(nelems(@nodes), 4)

@nodes = $xp->findnodes('//GGG/descendant::*')
is(nelems(@nodes), 3)

@nodes = $xp->findnodes('//GGG/following::*')
is(nelems(@nodes), 3)
is(@nodes[0]->getName, "VVV")

@nodes = $xp->findnodes('//GGG/preceding::*')
is(nelems(@nodes), 5)
is(@nodes[0]->getName, "BBB") # document order, not HHH

@nodes = $xp->findnodes('//GGG/self::*')
is(nelems(@nodes), 1)
is(@nodes[0]->getName, "GGG")

@nodes = $xp->findnodes('//GGG/ancestor::* | 
        //GGG/descendant::* | 
        //GGG/following::* |
        //GGG/preceding::* |
        //GGG/self::*')
is(nelems(@nodes), 16)

__DATA__
<AAA>
    <BBB>
        <CCC/>
        <ZZZ/>
    </BBB>
    <XXX>
        <DDD>
            <EEE/>
            <FFF>
                <HHH/>
                <GGG> <!-- Watch this node -->
                    <JJJ>
                        <QQQ/>
                    </JJJ>
                    <JJJ/>
                </GGG>
                <VVV/>
            </FFF>
        </DDD>
    </XXX>
    <CCC>
        <DDD/>
    </CCC>
</AAA>
