#!/usr/bin/perl

use strict;
use warnings;

use Cwd;

my $prefix = shift @ARGV;
$prefix or die "No prefix specified";
my $kurila = "$prefix/bin/perlkurila.1.20";

my $distdir = getcwd;

chdir "kurila" or die;
system('sh', './Configure', "-des", "-Dprefix='$prefix'", "-Dusedevel", "-Uinstallusrbinperl") == 0 or die;
system('make all test install') == 0 or die;

# do not promp questions
$ENV{'PERL_MM_USE_DEFAULT'} = 1;

for my $module (qw|
               Test-Harness
               Compress-Raw-Zlib
               PerlIO-via-Zlib
               Compress-Zlib
               Digest-SHA
               Digest-MD5
               libnet
               Archive-Tar
               Archive-Extract
               CPAN
               Encode
               PerlIO-encoding
               Module-Build
               Devel-Symdump
               Pod-Coverage
               Module-Pluggable
               B-Lint
               Net-Ping
               Math-BigInt-FastCalc
               Math-BigInt
               Win32API-File
               URI
               CGI-Minimal
               HTML-Tagset
               HTML-Parser
               libwww-perl
               Class-Data-Inheritable
               Devel-StackTrace
               DBI
               Params-Validate
               Digest-SHA1
               Cache-Cache
               Exception-Class
               Mail-Sendmail
               MailTools
               MIME-tools
               DBD-mysql
               XML-Parser
               XML-Simple
               XML-XPath
               DateTime-Locale
               DateTime-TimeZone
               Class-Factory-Util
               Class-Singleton
               DateTime
               UNIVERSAL-moniker
               Class-Trigger
               Class-Accessor
               File-Type
               B-Fathom
               WWW-Mechanize
               Test-LongString
               Carp-Assert
               Test-Exception
               Carp-Assert-More
               String-Escape
               Pod-Escapes
               DateTime-Format-Strptime
               DateTime-Format-Builder
               DateTime-Format-MySQL
               Clone-PP
               String-CRC32
               Graphics-ColorNames
               Graphics-ColorObject
               Crypt-CBC
               Struct-Compare
               DateTime-Format-Mail
               Text-Greeking
               OLE-Storage_Lite
               Spreadsheet-ParseExcel
               Spreadsheet-ParseExcel-Simple
               Mail-Sender
               Text-CSV_PP
               List-MoreUtils
               Algorithm-Diff
               Text-Diff
               Proc-PID-File
               XML-NamespaceSupport
               XML-SAX
               XML-LibXML-Common
               XML-LibXML
               Exporter-Lite
               DateTime-Format-W3CDTF
               Math-Rand48
               Sys-Syscall
               Digest-Adler32
               Event-Lib
               Scalar-Quote
               RDF-Core
               Text-CSV_XS
               Crypt-Rijndael
               File-BaseDir
               File-MimeInfo
               Net-SSH
               Crypt-SSLeay
               Spiffy
               Scriptalicious
               Digest-HMAC
               Net-IP
               Net-DNS
               Mail-SpamAssassin
               text-highlight
               File-Remove
               Test-Object
               Params-Util
               Clone
               PPI
               Readonly
               String-Format
               Config-Tiny
               Perl-Critic
               Lingua-EN-Inflect
               Sub-Install
               Data-OptList
        |) {
    chdir "$distdir/$module" or die;
    system("$kurila Makefile.PL") == 0 or die;
    -e "Makefile" or next;
    system("make all test install") == 0 or die;
}
