#!./perl -w

use Net::Config
use Net::FTP

unless(defined(%NetConfig{?ftp_testhost}) && %NetConfig{?test_hosts})
    print $^STDOUT, "1..0\n"
    exit 0


my $t = 1
print $^STDOUT, "1..7\n"

my $ftp = Net::FTP->new(%NetConfig{ftp_testhost})
    or (print($^STDOUT, "not ok 1\n"), exit)

printf $^STDOUT, "ok \%d\n",$t++

$ftp->login('anonymous') or die($ftp->message . "\n")
printf $^STDOUT, "ok \%d\n",$t++

$ftp->pwd  or do
    print $^STDERR, $ftp->message,"\n"
    print $^STDOUT, "not "


printf $^STDOUT, "ok \%d\n",$t++

$ftp->cwd('/pub') or do
    print $^STDERR, $ftp->message,"\n"
    print $^STDOUT, "not "


if (my $data = $ftp->stor('libnet.tst'))
    my $text = "abc\ndef\nqwe\n"
    printf $^STDOUT, "ok \%d\n",$t++
    $data->write($text,length $text)
    $data->close
    $data = $ftp->retr('libnet.tst')
    $data->read(my $buf,length $text)
    $data->close
    print $^STDOUT, "not " unless $text eq $buf
    printf $^STDOUT, "ok \%d\n",$t++
    $ftp->delete('libnet.tst') or print $^STDOUT, "not "
    printf $^STDOUT, "ok \%d\n",$t++

else
    print $^STDOUT, "# ",$ftp->message,"\n"
    printf $^STDOUT, "ok \%d\n",$t++
    printf $^STDOUT, "ok \%d\n",$t++
    printf $^STDOUT, "ok \%d\n",$t++


$ftp->quit  or do
    print $^STDERR, $ftp->message,"\n"
    print $^STDOUT, "not "


printf $^STDOUT, "ok \%d\n",$t++
