#!./perl -w

use Test::More

use Net::Domain < qw(hostname domainname hostdomain hostfqdn)
use Net::Config

unless(%NetConfig{?test_hosts})
    plan skip_all => "no test_hosts"


plan tests => 5

my $domain = domainname()

ok(defined $domain && $domain ne "")

# This checks thats hostanme does not overwrite $_
my @domain = qw(foo.example.com bar.example.jp)
my @copy = @domain

my @dummy = grep { defined hostname() and hostname() eq $_ }, @domain

ok(@domain[0] && @domain[0] eq @copy[0])

@dummy = grep { defined hostdomain() and hostdomain() eq $_ }, @domain

ok(@domain[0] && @domain[0] eq @copy[0])

my $name = hostname()
$domain = hostdomain()
SKIP:
    do
    unless (defined $domain && defined $name && $name ne "" && $domain ne "")
        skip "domain not fully defined", 2
    
    ok(hostfqdn() eq $name . "." . $domain)
    ok(domainname() eq $name . "." . $domain)

