print $^STDOUT, "1..3\n"

use HTTP::Response
use HTTP::Headers::Auth

my $res = HTTP::Response->new(401)
$res->push_header(WWW_Authenticate => qq(Foo realm="WallyWorld", foo=bar, Bar realm="WallyWorld2"))
$res->push_header(WWW_Authenticate => qq(Basic Realm="WallyWorld", foo=bar, bar=baz))

print $^STDOUT, $res->as_string

my %auth = %:  < $res->www_authenticate 

print $^STDOUT, "not " unless nelems(keys(%auth)) == 3
print $^STDOUT, "ok 1\n"

print $^STDOUT, "not " unless %auth{basic}->{?realm} eq "WallyWorld" &&
    %auth{bar}->{?realm} eq "WallyWorld2"
print $^STDOUT, "ok 2\n"

$res->www_authenticate("Basic realm=foo1")
print $^STDOUT, $res->as_string

$res->www_authenticate(Basic => \(%: realm => 'foo2'))
print $^STDOUT, $res->as_string

$res->www_authenticate(Basic => \(@: realm => 'foo3', foo=>33),
    Digest => \(%: nonce=>"bar", foo=>'foo'))
print $^STDOUT, $res->as_string

$_ = $res->as_string

print $^STDOUT, "not " unless m/WWW-Authenticate: Basic realm="foo3", foo=33/ &&
    (m/WWW-Authenticate: Digest nonce=bar, foo=foo/ ||
     m/WWW-Authenticate: Digest foo=foo, nonce=bar/)
print $^STDOUT, "ok 3\n"

