
use HTTP::Headers::Util < qw(split_header_words join_header_words)

my $extra_tests = 2

my @s_tests = @: 

   \(@: "foo"                     => "foo")
   \(@: "foo=bar"                 => "foo=bar")
   \(@: "   foo   "               => "foo")
   \(@: "foo="                    => 'foo=""')
   \(@: "foo=bar bar=baz"         => "foo=bar; bar=baz")
   \(@: "foo=bar;bar=baz"         => "foo=bar; bar=baz")
   \(@: 'foo bar baz'             => "foo; bar; baz")
   \(@: 'foo="\"" bar="\\"'     => 'foo="\""; bar="\\"')
   \(@: 'foo,,,bar'               => 'foo, bar')
   \(@: 'foo=bar,bar=baz'         => 'foo=bar, bar=baz')

   \(@: 'text/html; charset=iso-8859-1' =>
        'text/html; charset=iso-8859-1')

   \(@: 'foo="bar"; port="80,81"; discard, bar=baz' =>
        'foo=bar; port="80,81"; discard, bar=baz')

   \(@: 'Basic realm="\"foo\\bar\""' =>
        'Basic; realm="\"foo\\bar\""')
    

print $^STDOUT, "1..", nelems(@s_tests) + $extra_tests, "\n"

my $testno = 1

print $^STDOUT, "split_header_words() tests\n"
for ( @s_tests)
    my(@: $arg, $expect) =  $_->@
    my @arg = @:  ref($arg) ?? < $arg->@ !! $arg 

    my $res = join_header_words( <split_header_words(< @arg))
    if ($res ne $expect)
        print $^STDOUT, "\nUnexpected result: '$res'\n"
        print $^STDOUT, "         Expected: '$expect'\n"
        print $^STDOUT, "  when parsing '", join(", ", @arg), "'\n"
        try {
            require Data::Dumper;
            my @p = split_header_words(< @arg);
            print $^STDOUT, < Data::Dumper::Dumper(\@p);
        }
        print $^STDOUT, "not "
    
    print $^STDOUT, "ok ", $testno++, "\n"



print $^STDOUT, "Extra tests\n"
# some extra tests
print $^STDOUT, "not " unless join_header_words("foo" => undef, "bar" => "baz")
    eq "foo; bar=baz"
print $^STDOUT, "ok ", $testno++, "\n"

print $^STDOUT, "not " unless join_header_words() eq ""
print $^STDOUT, "ok ", $testno++, "\n"
