
# Test extra HTTP::Response methods.  Basic operation is tested in the
# message.t test suite.


print $^STDOUT, "1..7\n"


use HTTP::Date
use HTTP::Request
use HTTP::Response

my $time = time

my $req = HTTP::Request->new(GET => 'http://www.sn.no')
$req->date($time - 30)

my $r = HTTP::Response->new( 200, "OK")
$r->client_date($time - 20)
$r->date($time - 25)
$r->last_modified($time - 5000000)
$r->request($req)

print $^STDOUT, $r->as_string

my $current_age = $r->current_age

if ($current_age +< 35  || $current_age +> 40)
    print $^STDOUT, "not "

print $^STDOUT, "ok 1\n"

my $freshness_lifetime = $r->freshness_lifetime
if ($freshness_lifetime +< 12 * 3600)
    print $^STDOUT, "not "

print $^STDOUT, "ok 2\n"

my $is_fresh = $r->is_fresh

print $^STDOUT, "not " unless $is_fresh
print $^STDOUT, "ok 3\n"

print $^STDOUT, "current_age        = $current_age\n"
print $^STDOUT, "freshness_lifetime = $freshness_lifetime\n"
print $^STDOUT, "response is "
print $^STDOUT, "not " unless $is_fresh
print $^STDOUT, "fresh\n"


print $^STDOUT, "it will be fresh is "
print $^STDOUT, $freshness_lifetime - $current_age
print $^STDOUT, " more seconds\n"

# OK, now we add an Expires header
$r->expires($time)
print $^STDOUT, $r->as_string

$freshness_lifetime = $r->freshness_lifetime
print $^STDOUT, "freshness_lifetime = $freshness_lifetime\n"
print $^STDOUT, "not " unless $freshness_lifetime == 25
print $^STDOUT, "ok 4\n"
$r->remove_header('expires')

# Now we try the 'Age' header and the Cache-Contol:

$r->header('Age', 300)
$r->push_header('Cache-Control', 'junk')
$r->push_header(Cache_Control => 'max-age = 10')

print $^STDOUT, $r->as_string

$current_age = $r->current_age
$freshness_lifetime = $r->freshness_lifetime

print $^STDOUT, "current_age        = $current_age\n"
print $^STDOUT, "freshness_lifetime = $freshness_lifetime\n"

print $^STDOUT, "not " if $current_age +< 300
print $^STDOUT, "ok 5\n"

print $^STDOUT, "not " if $freshness_lifetime != 10
print $^STDOUT, "ok 6\n"

print $^STDOUT, "not " unless $r->fresh_until  # should return something
print $^STDOUT, "ok 7\n"
