use Test::More tests => 10

use LWP::UserAgent

my $ua = LWP::UserAgent->new
my $clone = $ua->clone

ok( $ua->agent =~ m/^libwww-perl/ )

ok( ! defined $ua->proxy(ftp => "http://www.sol.no") )

is( $ua->proxy("ftp")->as_string, "http://www.sol.no" )

my @a = $ua->proxy(\qw(ftp http wais), "http://proxy.foo.com")

is(join(" ", map { $_ ?? $_->as_string !! "undef" }, @a),
   "http://www.sol.no undef undef")

is($ua->proxy("http")->as_string, "http://proxy.foo.com")

is(ref($ua->default_headers), "HTTP::Headers")

$ua->default_header("Foo" => "bar", "Multi" => \(@: 1, 2))
is( $ua->default_headers->header("Foo"), "bar" )

is( $ua->default_header("Foo"), "bar" )

# Try it
$ua->proxy(http => "loopback:")
$ua->agent("foo/0.1")

is( $ua->get("http://www.example.com", x => "y")->content, <<EOT )
GET http://www.example.com
User-Agent: foo/0.1
Foo: bar
Multi: 1, 2
X: y

EOT

is( ref($clone->{?proxy}), 'HASH')
