#!perl

print $^STDOUT, "1..6\n"

# This test tries to make a custom protocol implementation by
# subclassing of LWP::Protocol.


use LWP::UserAgent ()
use LWP::Protocol ()

LWP::Protocol::implementor(http => 'myhttp')

my $ua = LWP::UserAgent->new
$ua->proxy('ftp' => "http://www.sn.no/")

my $req = HTTP::Request->new(GET => 'ftp://foo/')
$req->header(Cookie => "perl=cool")

my $res = $ua->request($req)

print $^STDOUT, $res->as_string

print $^STDOUT, "not " unless $res->code == 200
print $^STDOUT, "ok 5\n"
print $^STDOUT, "not " unless $res->content eq "Howdy\n"
print $^STDOUT, "ok 6\n"
exit


#----------------------------------
package myhttp

BEGIN 
    our @ISA= qw(LWP::Protocol)


sub new
    my $class = shift
    print $^STDOUT, "CTOR: $(dump::view($class))->new($(dump::view(\@_)))\n"
    my (@: $prot, ...) =  @_
    print $^STDOUT, "not " unless $prot eq "http"
    print $^STDOUT, "ok 1\n"
    my $self = $class->SUPER::new(< @_)
    for (keys $self->%)
        my $v = $self->{?$_}
        $v = "<undef>" unless defined($v)
        print $^STDOUT, "$_: $(dump::view($v))\n"
    
    $self


sub request
    my $self = shift
    print $^STDOUT, "REQUEST: \$self->request(",
        join(",", (@:  (< map { dump::view($_) }, @_))), ")\n"

    my(@: $request, $proxy, $arg, $size, $timeout) =  @_
    print $^STDOUT, $request->as_string

    print $^STDOUT, "not " unless $proxy->as_string eq "http://www.sn.no/"
    print $^STDOUT, "ok 2\n"
    print $^STDOUT, "not " unless $request->url->as_string eq "ftp://foo/"
    print $^STDOUT, "ok 3\n"
    print $^STDOUT, "not " unless $request->header("cookie") eq "perl=cool"
    print $^STDOUT, "ok 4\n"

    my $res = HTTP::Response->new(200 => "OK")
    $res->content_type("text/plain")
    $res->date(time)
    $self->collect_once($arg, $res, "Howdy\n")
    $res

