
print $^STDOUT, "1..13\n"


use WWW::RobotRules::AnyDBM_File

my $file = "test-$^PID"

my $r = WWW::RobotRules::AnyDBM_File->new( "myrobot/2.0", $file)

$r->parse("http://www.aas.no/robots.txt", "")

$r->visit("www.aas.no:80")

print $^STDOUT, "not " if $r->no_visits("www.aas.no:80") != 1
print $^STDOUT, "ok 1\n"


$r->push_rules("www.sn.no:80", "/aas", "/per")
$r->push_rules("www.sn.no:80", "/god", "/old")

my @r = $r->rules("www.sn.no:80")
print $^STDOUT, "Rules: $(join ' ', @r)\n"

print $^STDOUT, "not " if "$(join ' ', @r)" ne "/aas /per /god /old"
print $^STDOUT, "ok 2\n"

$r->clear_rules("per")
$r->clear_rules("www.sn.no:80")

@r = $r->rules("www.sn.no:80")
print $^STDOUT, "Rules: $(join ' ', @r)\n"

print $^STDOUT, "not " if "$(join ' ', @r)" ne ""
print $^STDOUT, "ok 3\n"

$r->visit("www.aas.no:80", time+10)
$r->visit("www.sn.no:80")

print $^STDOUT, "No visits: ", $r->no_visits("www.aas.no:80"), "\n"
print $^STDOUT, "Last visit: ", $r->last_visit("www.aas.no:80"), "\n"
print $^STDOUT, "Fresh until: ", $r->fresh_until("www.aas.no:80"), "\n"

print $^STDOUT, "not " if $r->no_visits("www.aas.no:80") != 2
print $^STDOUT, "ok 4\n"

print $^STDOUT, "not " if abs($r->last_visit("www.sn.no:80") - time) +> 2
print $^STDOUT, "ok 5\n"

$r = undef

# Try to reopen the database without a name specified
$r = WWW::RobotRules::AnyDBM_File->new( undef, $file)
$r->visit("www.aas.no:80")

print $^STDOUT, "not " if $r->no_visits("www.aas.no:80") != 3
print $^STDOUT, "ok 6\n"

print $^STDOUT, "Agent-Name: ", $r->agent, "\n"
print $^STDOUT, "not " if $r->agent ne "myrobot"
print $^STDOUT, "ok 7\n"

$r = undef

print $^STDOUT, "*** Dump of database ***\n"
my %cat = DB_File->new($file, 0, 0644) or die "Can't tie: $^OS_ERROR"
%cat->iterate(
    sub (@< @_)
        my (@: $key, $val) = @_
        print $^STDOUT, "$key\t$val\n"
    
    )
print $^STDOUT, "******\n"

%cat = undef

# Try to open database with a different agent name
$r = WWW::RobotRules::AnyDBM_File->new( "MOMSpider/2.0", $file)

print $^STDOUT, "not " if $r->no_visits("www.sn.no:80")
print $^STDOUT, "ok 8\n"

# Try parsing
$r->parse("http://www.sn.no:8080/robots.txt", <<EOT, (time + 3))

User-Agent: *
Disallow: /

User-Agent: Momspider
Disallow: /foo
Disallow: /bar

EOT

@r = $r->rules("www.sn.no:8080")
print $^STDOUT, "not " if "$(join ' ', @r)" ne "/foo /bar"
print $^STDOUT, "ok 9\n"

print $^STDOUT, "not " if $r->allowed(URI->new("http://www.sn.no")) +>= 0
print $^STDOUT, "ok 10\n"

print $^STDOUT, "not " if $r->allowed(URI->new("http://www.sn.no:8080/foo/gisle"))
print $^STDOUT, "ok 11\n"

sleep(5)  # wait until file has expired
print $^STDOUT, "not " if $r->allowed(URI->new("http://www.sn.no:8080/foo/gisle")) +>= 0
print $^STDOUT, "ok 12\n"


$r = undef

print $^STDOUT, "*** Dump of database ***\n"
%cat = DB_File->new($file, 0, 0644) or die "Can't tie: $^OS_ERROR"
%cat->iterate(
    sub (@< @_)
        my (@: $key, $val) = @_
        print $^STDOUT, "$key\t$val\n"
    
    )
print $^STDOUT, "******\n"

%cat = undef            # Otherwise the next line fails on DOSish

while (unlink("$file", "$file.pag", "$file.dir", "$file.db")) {}

# Try open a an emty database without specifying a name
try {
    $r = WWW::RobotRules::AnyDBM_File->new( undef, $file);
}
print $^STDOUT, "# $^EVAL_ERROR->{?description}"
print $^STDOUT, "not " unless $^EVAL_ERROR  # should fail
print $^STDOUT, "ok 13\n"

unlink "$file", "$file.pag", "$file.dir", "$file.db"
